Package: RgoogleMaps
Type: Package
Title: Overlays on Static Maps
Version: 1.5.3
Date: 2025-08-16
Depends: R (>= 2.10)
Imports: graphics, stats, utils, grDevices, methods, png
Suggests: PBSmapping, RColorBrewer, leaflet, jpeg, RCurl
Authors@R: c(
  person("Markus", "Loecher",
         email = "markus.loecher@gmail.com",
         role = c("aut", "cre"),
         comment = c(ORCID = "0000-0002-6823-1994")))
URL:
        https://github.com/markusloecher/rgooglemaps/blob/master/rgooglemaps/www/QuickTutorial.html
Maintainer: Markus Loecher <markus.loecher@gmail.com>
Description: Serves two purposes: (i) Provide a
        comfortable R interface to query the Google server for static
        maps, and (ii) Use the map as a background image to overlay
        plots within R. This requires proper coordinate scaling.
License: GPL
LazyLoad: yes
Repository: CRAN
NeedsCompilation: no
Packaged: 2025-08-17 19:12:22 UTC; loecherm
Author: Markus Loecher [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-6823-1994>)
Date/Publication: 2025-08-19 23:20:07 UTC
Built: R 4.6.0; ; 2026-04-26 11:06:05 UTC; unix

Package: RgoogleMaps
Type: Package
Title: Overlays on Static Maps
Version: 1.5.1
Date: 2023-10-31
Depends: R (>= 2.10)
Imports: graphics, stats, utils, grDevices, methods, png
Suggests: PBSmapping, RColorBrewer, leaflet, jpeg, RCurl
Author: Markus Loecher 
URL:
        https://github.com/markusloecher/rgooglemaps/blob/master/rgooglemaps/www/QuickTutorial.html
Maintainer: Markus Loecher <markus.loecher@gmail.com>
Description: Serves two purposes: (i) Provide a
        comfortable R interface to query the Google server for static
        maps, and (ii) Use the map as a background image to overlay
        plots within R. This requires proper coordinate scaling.
License: GPL
LazyLoad: yes
Repository: CRAN
NeedsCompilation: no
Packaged: 2023-11-06 10:07:34 UTC; loecherm
Date/Publication: 2023-11-06 12:20:02 UTC
Built: R 4.4.0; ; 2026-02-18 02:42:22 UTC; unix

# Default NAMESPACE created by R
# Remove the previous line if you edit this file

# Export all names
exportPattern(".")

# Import all packages listed as Imports or Depends
import(
  graphics,
  stats,
  utils,
  grDevices, 
  methods,
  png
)

#importFrom(RColorBrewer, brewer.pal)
#importFrom(PBSmapping,plotPolys,calcCentroid,addPolys)
#importFrom(sp,CRS, proj4string, coordinates,bbox,spTransform)

SpatialToPBS <- structure(function#converts spatial objects as defined in package sp to simpler PBSmapping type dataframes 
### The PlotPolysOnStaticMap() function currently does not take sp objects directly but instead needs
### PBSmapping type data.frames. This function converts sp objects into such.                         
### THANKS TO Fabio Priuli for a major bug fix w.r.t. holes in spatial polygons!
(
  xy, ##<< spatial object, such as SpatialPoints, SpatialPolygons, etc..
  verbose=0 ##<< level of verbosity
  ) {
    fun = points
    if ("sf" %in% class(xy) ) {#added no March 21st 2024
      
    } else if (inherits(xy, "Spatial")) {
      
      if (inherits(xy, "SpatialPoints")) {
        #xy = sp::coordinates(xy)
        if ("coords" %in% names(attributes(xy))){
          xy = xy@coords
          b = sp_bbox(xy)
        } else {
          warning("no coordinate slot in xy!")
        }
      } else if (inherits(xy, "SpatialPolygons")) {
        res = matrix(ncol = 5, nrow = 0, dimnames = list(NULL, c("PID", "SID", "POS", "X", "Y")))
        for (i in 1:length(xy@polygons)) {
          x = slot(xy@polygons[[i]], "Polygons")
          isHole = unlist(lapply(x, function(x) slot(x, "hole")))
          x = lapply(x, function(x) slot(x, "coords"))
          for (j in 1:length(x)) {
            n = nrow(x[[j]])
            order = 1:n
            if (isHole[j])
              order = n:1
            res = rbind(res, cbind(PID = rep(i, n), SID=rep(j, n), POS = order, x[[j]]))
          }
        }
        xy = res
        b = sp_bbox(res[,c("X","Y")])
        fun = lines
        attr(xy, "projection") <- "LL"
      } else if (inherits(xy, "SpatialLines")) {
        res = list()
        for (j in 1:length(xy)){
          res[[j]] = xy@lines[[j]]@Lines[[1]]@coords
        }
        xy = res
        b = sp_bbox(res[,c("X","Y")])#unlikely to work !
        fun = lines
        attr(xy, "projection") <- "LL"
      }  
    } else {
      b = rbind(range(xy[, 1], na.rm = TRUE), range(xy[, 2], na.rm = TRUE))
    }
    return(list(xy = xy, bb = b, fun = fun))
### list with elements xy = converted object, bb = bounding box, fun = plot function
}, ex = function(){
  if (0) {
    data("NYleukemia", envir = environment())
    population <- NYleukemia$data$population
    cases <- NYleukemia$data$cases
    mapNY <- GetMap(center=c(lat=42.67456,lon=-76.00365), 
                    destfile = file.path(tempdir(),"NYstate.png"), 
                    maptype = "mobile", zoom=9)
    #mapNY=ReadMapTile("NYstate.png")
    clrStuff=ColorMap(100*cases/population, alpha = 0.35, log = TRUE)
    NYpolys = SpatialToPBS(NYleukemia$spatial.polygon)
    PlotPolysOnStaticMap(mapNY, NYpolys$xy, col = clrStuff$colcode, add = FALSE)
    legend("topleft", legend = clrStuff$legend, fill = clrStuff$fill, 
           bg = rgb(0.1,0.1,0.1,0.3))
}
  
})

AddAlpha <- structure(function#add alpha level to color that lacks one
###add alpha level to color that lacks one
(
  plotclr, ##<< color to be modified
  alpha=0.5, ##<< alpha level
  verbose=0 ##<< level of verbosity
){
  tmp <- col2rgb(plotclr, alpha=alpha)
  tmp[4,] = round(alpha*255)
  for (i in 1:ncol(tmp)){
    plotclr[i] = rgb(tmp[1,i], tmp[2,i], tmp[3,i], tmp[4,i], maxColorValue = 255)
  }
  return(plotclr)
### modified color with alpha value
}, ex = function(){

  #example: 
  #require(RColorBrewer)
  if (requireNamespace("RColorBrewer", quietly = TRUE)) {
    plotclr <- RColorBrewer::brewer.pal(8,"YlOrRd")
    plotclr = AddAlpha(plotclr,0.5)
  } else {
    print("package RColorBrewer must be installed for this example")
  }
  
})

osmtile_bbox = function# compute the bounding box of an OpenStreetmap tile
### inspired by \code{osmtile} from the package \code{OpenStreetmap}
### returns the Mercator projection bounding box
(
  x=61, ##<< x tile coordinate
  y=41, ##<< x tile coordinate
  zoom =7, ##<< zoom level
  minim = -20037508 ##<< parameter for OSM projection
){
  sc <- abs(minim) * 2
  
  p1 <- c(x/(2^zoom) * sc + minim, -(y/(2^zoom) * sc + minim))#upper left ??
  p2 <- c((x + 1)/(2^zoom) * sc + minim, -((y + 1)/(2^zoom) * 
                                             sc + minim)) #lowerRight?
  bbox <- list(upperLeft = p1, lowerRight = p2)
  return(bbox)
### bounding box, Mercator projection 
}


plotOSM = function#plots OSM map tiles
### places tiles on plot
(
  mt, ##<< list returned by \code{GetMapTiles}
  upperLeft, ##<< upperLeft corner in lat/lon of the plot region
  lowerRight, ##<< lowerRight corner in lat/lon of the plot region
  lat, ##<< latitude values to be overlaid, if any
  lon, ##<< longitude values to be overlaid, if any
  add = FALSE, 
  removeMargin = TRUE, 
  verbose=0, ##<< level of verbosity
  ... ##<< further arguments to be passed to \code{rasterImage}
) {
  map <- list(tiles = mt)
  map$bboxLL = list()
  
  if (missing(upperLeft) & missing(lowerRight)) {
    x = range(mt$X)
    y = range(mt$Y)
    
    upperLeft = osmtile_bbox(x=x[1], y=y[1], zoom = mt$zoom)$upperLeft
    lowerRight = osmtile_bbox(x=x[2], y=y[2], zoom = mt$zoom)$lowerRight
    map$bbox <- list(upperLeft =upperLeft,lowerRight=lowerRight)
  } else {
    map$bbox <- list(upperLeft = geosphere_mercator(upperLeft[1L], upperLeft[2L]), 
                     lowerRight = geosphere_mercator(lowerRight[1L], lowerRight[2L]))
    if (verbose) print(map$bbox)
    map$bbox <- list(p1 = c(x = min(map$bbox$upperLeft[1L], map$bbox$lowerRight[1L]), 
                            y = max(map$bbox$upperLeft[2L], map$bbox$lowerRight[2L])), 
                     p2 = c(x = max(map$bbox$upperLeft[1L], map$bbox$lowerRight[1L]), 
                            y = min(map$bbox$p1[2L], map$bbox$lowerRight[2L])))
  }
  map$bboxLL$upperLeft =geosphere_mercator(map$bbox$upperLeft,inverse = TRUE)
  map$bboxLL$lowerRight =geosphere_mercator(map$bbox$lowerRight,inverse = TRUE)
  
  if (verbose) print(map$bbox)
  
    
    mar <- par("mar")
    if (add == FALSE) {
        plot.new()
        if (removeMargin) 
            par(mar = c(0, 0, 0, 0))
        xlim_p = c(map$bbox$upperLeft[1], map$bbox$lowerRight[1])
        ylim_p = c(map$bbox$lowerRight[2], map$bbox$upperLeft[2])
        plot.window(xlim_p, ylim_p, xaxs = "i", yaxs = "i", asp = T)
        if (verbose>1) browser()
    }
    #if (verbose>1) browser()
    k=1
    for (x in mt$X){
      for (y in mt$Y){
        osmtile=list()
        osmtile$tile = mt$tiles[[k]]
        osmtile$x=x;osmtile$y=y;osmtile$zoom=mt$zoom
        plotOSMtile(osmtile, verbose=verbose, ...)
        k=k+1
      }
    }

    par(mar = mar)
    invisible(map)
### returns map object invisibly 
}

plotOSMtile = function# plots a single OSM tile
### Adds tile to plot
(
  osmtile, ##<< tile object
  zoom, ##<<  zoom level
  add = TRUE, ##<< 
  raster = TRUE, ##<< 
  verbose=0, ##<< level of verbosity
  ... ##<< further arguments to be passed to \code{rasterImage}
){ 
  
  xres <- nrow(osmtile$tile) #look up: 256 or 255 ?!!
  yres <- ncol(osmtile$tile)
  if (missing(zoom)) zoom = osmtile$zoom
  
  if (verbose>1) browser()
  
  bbox=osmtile_bbox(x=osmtile$x, y=osmtile$y, zoom = zoom)
  bbox$p1 = bbox$upperLeft
  bbox$p2 = bbox$lowerRight
  m=0#0.5 #margin
  xleft = bbox$p1[1] - m * abs(bbox$p1[1] - bbox$p2[1])/yres
  ybottom = bbox$p2[2] + m * abs(bbox$p1[2] - bbox$p2[2])/xres
  xright = bbox$p2[1] - m * abs(bbox$p1[1] - bbox$p2[1])/yres
  ytop = bbox$p1[2] + m * abs(bbox$p1[2] - bbox$p2[2])/xres
  
  
  if (!raster) 
    image(x = seq(xleft, xright, length = yres), y = seq(ybottom, ytop, length = xres), 
          z = t(matrix(1:(xres * yres), nrow = xres, byrow = TRUE))[, 
                                                                    xres:1], col = as.vector(osmtile$tile), add = add, ...)
  else rasterImage(osmtile$tile, xleft, ybottom, xright, ytop, ...)
  
  if (verbose) {
    cat("placing tile at coords:",xleft, ybottom, xright, ytop, "\n")
    rect(xleft, ybottom, xright, ytop)
  }
### returns nothing
}

geosphere_mercator = function#Transform longitude/latiude points to the Mercator projection. 
### From \code{geosphere::mercator}
(
    p, ##<< longitude/latitude of point(s). Can be a vector of two numbers, a matrix of 2 columns (first one is longitude, second is latitude) 
    inverse = FALSE, ##<<  Logical. If TRUE, do the inverse projection (from Mercator to longitude/latitude
    r = 6378137  ##<< Numeric. Radius of the earth; default = 6378137 m
) {
  .pToMatrix <- function(p) {
    
    if (is.data.frame(p)) {
      p <- as.matrix(p)
    } else 
      
      if (is.vector(p)){
        if (length(p) != 2) {
          stop('Wrong length for a vector, should be 2')
        } else {
          p <- matrix(p, ncol=2) 
        }
      } else if (is.matrix(p)) {
        if (ncol(p) != 2) {
          stop( 'A points matrix should have 2 columns')
        }
        cn <- colnames(p)
        if (length(cn) == 2) {
          if (toupper(cn[1]) == 'Y' | toupper(cn[2]) == 'X')  {
            warning('Suspect column names (x and y reversed?)')
          }
          if (toupper(substr(cn[1],1,3) == 'LAT' | toupper(substr(cn[2],1,3)) == 'LON'))  {
            warning('Suspect column names (longitude and latitude reversed?)')
          }
        }		
      } else {
        stop('points should be vectors of length 2, matrices with 2 columns, or inheriting from a SpatialPoints* object')
      }
    
    if (! is.numeric(p) ) { p[] <- as.numeric(p) 
    }
    
    
    return(p)
  }
  
  toRad <- pi/180
  if (inverse) {
    p <- .pToMatrix(p)
    p[, 2] <- pi/2 - 2 * atan(exp(-p[, 2]/r))
    p[, 1] <- p[, 1]/r
    colnames(p) <- c("lon", "lat")
    return(p/toRad)
  }
  else {
    p <- .pToMatrix(p) * toRad
    p[, 2] <- log(tan(p[, 2]) + (1/cos(p[, 2])))
    p <- p * r
    colnames(p) <- c("x", "y")
    return(p)
  }
### Mercator projection of lon/lat points
}

.onAttach <- 
  function(libname, pkgname) {
    packageStartupMessage("\nThank you for using RgoogleMaps!")
    packageStartupMessage("\nTo acknowledge our work, please cite the package: \n")
    packageStartupMessage(" Markus Loecher and Karl Ropkins (2015). RgoogleMaps and loa: Unleashing R
  Graphics Power on Map Tiles. Journal of Statistical Software 63(4), 1-18.")
    #packageStartupMessage(" R package version 5.2.3. https://CRAN.R-project.org/package=stargazer \n")
  }

`LatLon2XY` <- structure(function#computes the coordinate transformation from lat/lon to map tile coordinates 
### The function LatLon2XY(lat,lon,zoom) computes the coordinate transformation from lat/lon to map tile coordinates given a zoom level. 
### It returns the tile coordinates as well as the pixel coordinates within the Tile itself. 
(
  lat, ##<< latitude values to transform
  lon, ##<< longitude values to transform
  zoom ##<< zoom level.lat,lon,zoom
){
  #The int part may be used directly to obtain the Tiles (Attention: Illegal) using a URL formed like this:

  #String.Format("http://mt.google.com/mt?x={0}&y={1}&zoom={2}", c.x, c.y, 17-zoom)

  ##note<< The fractional part times 256 is the pixel coordinate within the Tile itself. 
  
  #double sin_phi = System.Math.Sin(this.lat * System.Math.PI /180);
  #double norm_x = this.lon / 180;
  #double norm_y = (0.5 * System.Math.Log((1 + sin_phi) / (1 -sin_phi))) / System.Math.PI;
  #this.y = System.Math.Pow(2, this.zoom) * ((1 - norm_y) / 2);
  #this.x = System.Math.Pow(2, this.zoom) * ((norm_x + 1) / 2); 
  SinPhi = sin(lat * pi /180);
  normX = lon / 180;
  normY = (0.5 * log((1 + SinPhi) / (1 -SinPhi))) / pi;
  Y = (2^zoom) * ((1 - normY) / 2);
  X = (2^zoom) * ((normX + 1) / 2); 	

  x = 256 *(X- floor(X));
  y = 256 *(Y- floor(Y));
  
  return(list(Tile = cbind(X=floor(X),Y=floor(Y)), Coords = cbind(x=x,y=y)))
###  A list with values
###  \item{Tile}{integer numbers specifying the tile}
###  \item{Coords}{pixel coordinate within the Tile}
}, ex = function(){
  LatLon2XY(38.45, -122.375, 11)
})

`PlotArrowsOnStaticMap` <-structure(function#plots arrows or segments on map 
###This function plots/overlays arrows or segments on a map.
(
  MyMap, ##<< map image returned from e.g. \code{GetMap()} 
  lat0, ##<< latitude valuesof points FROM which to draw.
  lon0, ##<< longitude values of points FROM which to draw.
  lat1=lat0, ##<< latitude valuesof points TO which to draw.
  lon1=lon0, ##<< longitude values of points TO which to draw.
  TrueProj = TRUE, ##<< set to FALSE if you are willing to accept some degree of inaccuracy in the mapping. In that case, the coordinates of the image are in lat/lon and the user can simply overly points/lines/axis without worrying about projections
  FUN = arrows, ##<<, plotting function to use for overlay; typical choices would be \link{arrows} and \link{segments} 
  add = FALSE, ##<< start a new plot or add to an existing
  verbose = 0, ##<< level of verbosity 
  ... ##<< further arguments to be passed to \code{FUN}
){
  ##seealso<< \link{PlotOnStaticMap} \link{arrows}
  if (TrueProj){
    Rcoords0 <- LatLon2XY.centered(MyMap,lat= lat0,lon= lon0);   
    Rcoords1 <- LatLon2XY.centered(MyMap,lat= lat1,lon= lon1);
  }  else { #no transformtion
    Rcoords0 <- list(newY= lat0,newX= lon0);   
    Rcoords1 <- list(newY= lat1,newX= lon1);
  }
  
  if (!add) tmp <- PlotOnStaticMap(MyMap, TrueProj = TrueProj, verbose=verbose);
  FUN(x0=Rcoords0$newX, y0=Rcoords0$newY, x1=Rcoords1$newX, y1=Rcoords1$newY, ...);
### return value of \code{FUN}
}, ex = function(){
  if (0){
    	MyMap <- GetMap(center=c(lat=40.7,lon=-74), zoom=11)
	  PlotArrowsOnStaticMap(MyMap, lat0=40.69, lon0=-73.9, lat1=40.71, lon1=-74.1, col = 'red')   
  }
})

ColorMap <- structure(function#Plot Levels of a Variable in a Colour-Coded Map
### Plot Levels of a Variable in a Colour-Coded Map
(
  values, ##<< variable to plot
  map=NULL, ##<< map object
  polys=NULL, ##<< an object of class SpatialPolygons (See \link[sp]{SpatialPolygons-class}
  log = FALSE, ##<< boolean of whether to plot values on log scale
  nclr = 7, ##<< number of colour-levels to use
  include.legend = list(TRUE), ##<< boolean of whether to include legend
  round = 3, ##<< number of digits to round to in legend
  brks = NULL, ##<< if desired, pre-specified breaks for legend
  legend = NULL, ##<< if desired, a pre-specified legend
  location = "topright", ##<< location of legend
  rev = FALSE, ##<< boolean of whether to reverse colour scheme (darker colours for smaller values)
  alpha = 0.5, ##<< alpha value of colors
  GRAY = FALSE, ##<< boolean: if TRUE, use gray scale instead
  palette = c("YlOrRd", "RdYlGn","Spectral")[1],##<< palette to choose from RColorBrewer
  textInPolys = NULL, ##<< text to be displayed inside polygons. This can be a column names for values
  ... ##<< extra args to pass to \code{PlotPolysOnStaticMap}
  ){
    if (length(palette) == nclr) {
      plotclr <- palette
    } else if (GRAY | !requireNamespace("RColorBrewer", quietly = TRUE) ) {
      plotclr <- grey(1 - seq(0, 1, by = 1/(nclr - 1)))
    } else {
      plotclr <- RColorBrewer::brewer.pal(nclr,palette)
      #display.brewer.all()
    }
   
    plotclr = AddAlpha(plotclr,alpha)
    
    nclr <- nclr + 1
    if (is.null(brks)) {
        if (log) {
            brks <- exp(seq(from = min(log(values)), to = max(log(values)), 
                length.out = nclr))
        }
        else {
            brks <- seq(from = min(values), to = max(values), 
                length.out = nclr)
        }
    }
    nclr <- nclr - 1
    print(brks)
    if (rev) {
        plotclr <- rev(plotclr)
    }
    colornum <- findInterval(values, brks, all.inside = T)
    colcode <- plotclr[colornum]
    if (is.null(legend)) {
      leglabs =
      function (vec, under = "under", over = "over", between = "-") 
      {
        x <- vec
        lx <- length(x)
        if (lx < 3) 
          stop("vector too short")
        res <- character(lx - 1)
        res[1] <- paste(under, x[2])
        for (i in 2:(lx - 2)) res[i] <- paste(x[i], between, x[i + 
          1])
        res[lx - 1] <- paste(over, x[lx - 1])
        res
      }
        legend <- leglabs(signif(brks, digits = round))
        legend[1] <- paste(signif(min(values), digits = round), 
            "-", substr(legend[1], 7, nchar(legend[1])))
        legend[nclr] <- paste(substr(legend[nclr], 6, nchar(legend[nclr])), 
            "-", signif(max(values), digits = round))
    }
    if (is.null(polys)) {#no plotting, just return the colors
      return(list(colcode=colcode, legend = legend, fill = plotclr))
    } else {
      if (is.null(map)) {
        PBSmapping::plotPolys(polys, col = colcode )#hoping, this is well defined by the class somehow !
      } else {
        if (inherits(polys, 'Spatial')) polys = SpatialToPBS(polys)$xy
        #if (!is.null(textInPolys)) textInPolys = as.character(values[,textInPolys])
        PlotPolysOnStaticMap(map, polys, col = colcode, textInPolys=textInPolys,...)
      }
    
    if (include.legend[[1]]) 
        legend(location, legend = legend, fill = plotclr, bty = "n")
    }
}, ex = function(){
  if (0){
    data("NYleukemia", envir = environment())
    population <- NYleukemia$data$population
    cases <- NYleukemia$data$cases
    mapNY <- GetMap(center=c(lat=42.67456,lon=-76.00365), destfile = "NYstate.png", 
                    maptype = "mobile", zoom=9)
    ColorMap(100*cases/population, mapNY, NYleukemia$spatial.polygon, add = FALSE,
             alpha = 0.35, log = TRUE, location = "topleft")
}
  #ColorMap(100*cases/population, map=NULL, NYleukemia$spatial.polygon)
  
})

`mypolygon` <-structure(function#simple wrapper function to plot colored polygons
###same as \link{polygon}, execept the value for color is taken from the 1st element of the exra column 'col'
(
  x, ##<< matrix containing columns X,Y,col
  ...##<< extra arguments passed to  \link{polygon}
){
  polygon(x[,c("X","Y")],col=x[1,"col"],...)  
})

`MapBackground` <-structure(function# get static Map from the Google server
###  get static Map from the Google server
(
  lat, ##<< 
  lon, ##<< 
  destfile, ##<<  File to load the map image from or save to, depending on \code{NEWMAP}.
  NEWMAP = TRUE, ##<< if TRUE, query the Google server and save to \code{destfile}, if FALSE load from destfile.
  myTile, ##<< map tile from previous downloads
  zoom=NULL, ##<< Google maps zoom level.
  size = c(640,640), ##<< desired size of the map tile image. defaults to maximum size returned by the Gogle server, which is 640x640 pixels 
  GRAYSCALE  = FALSE, ##<< Boolean toggle; if TRUE the colored map tile is rendered into a black & white image, see \link{RGB2GRAY}
  mar=c(0,0,0,0), ##<< outer margin in plot; if you want to see axes, change the default
  PLOT = FALSE, ##<< if TRUE, leave the plotting to \link{PlotOnStaticMap}, highly recommended
  verbose = 1, ##<< level of verbosity
  ... ##<< further arguments to be passed to \link{GetMap.bbox}
){
   #library(TeachingDemos);#only needed for the function updateusr       
    bb <- qbbox(lat,lon, TYPE = "all", margin = list(m=rep(5,4), TYPE = c("perc", "abs")[1]));
   	lat.center <- mean(bb$latR);
    lon.center <- mean(bb$lonR);
    if (is.null(zoom)) 
      if (diff(bb$latR) <= 0.000001 | diff(bb$lonR) <=  0.000001) zoom <- 12 else zoom <- min(MaxZoom(bb$latR, bb$lonR, size));
   
    
   	if (NEWMAP | missing(destfile)){
   	  if (missing(destfile)) destfile = paste(round(lat.center,3),round(lon.center,3),"png",sep=".")
   	  #GetMap(center = c(lat.center, lon.center), zoom = zoom, destfile = destfile);
   	  MyMap <- GetMap.bbox(bb$lonR, bb$latR, destfile = destfile, verbose = verbose, size = size, GRAYSCALE  =GRAYSCALE,...);
   	  size <- dim(MyMap[[4]])[2:1];
   	  if (is.null(zoom)) zoom <- min(MaxZoom(bb$latR, bb$lonR, size));
   	  if (verbose) cat("center, zoom: ", lat.center, lon.center, zoom, "\n");
     } else {
      cat("no new tile query, instead load prestored ", destfile, "\n");
    
       MyMap <- ReadMapTile(destfile, TRUE);
       if ( !('lat.center' %in% names(MyMap)) | !('lon.center' %in% names(MyMap)) | !('zoom' %in% names(MyMap)) ) 
         MyMap <- list(lat.center=lat.center, lon.center=lon.center, zoom=zoom, myTile= MyMap);
    }
    
     MyMap$BBOX <- list(ll = XY2LatLon(MyMap, -size[1]/2 + 0.5, -size[2]/2 + 0.5), ur = XY2LatLon(MyMap, size[1]/2 - 0.5, size[2]/2 - 0.5) );
     # if (GRAYSCALE ) MyMap[[4]] <- RGB2GRAY(MyMap[[4]]);
     if (PLOT){
       par(mar=mar);#par(pin=c(9,9))
       
   	   if (class(MyMap[[4]])[1] == 'matrix'){
		 image(y= seq(MyMap$BBOX$ll[1], MyMap$BBOX$ur[1], length= size[1]), x= seq(MyMap$BBOX$ll[2], MyMap$BBOX$ur[2], length= size[2]), z=MyMap[[4]], col = attr(MyMap[[4]], "COL"), xlab = "", ylab = "")
   	   } else if (class(MyMap[[4]])[1] == 'SpatialGridDataFrame'){
   	 	 image(MyMap[[4]], red=1, green=2, blue=3)
   	   } else	{
   	   	plot(MyMap[[4]]);
   	   }
     
      tmp2 <- par('usr');
      #updateusr(tmp2[1:2], x2=c(-size[1]+1, size[1]-1)/2, tmp2[3:4], y2=c(-size[2]+1, size[2]-1)/2 );
      updateusr(tmp2[1:2], x2=c(MyMap$BBOX$ll[1], MyMap$BBOX$ur[1]), tmp2[3:4], y2=c(MyMap$BBOX$ll[2], MyMap$BBOX$ur[2]));
    
     if (verbose) {
   	   cat("tmp2:");print(tmp2); 
       cat("par('usr')");print(par('usr'))
      }
   }   
   #browser();
    class(MyMap) =  "staticMap"
   invisible(MyMap); 
### list containing the map tile

})

PlotOnMapTiles = structure(function#plots on map tiles by "stitching" them together
### Counterpart to \code{PlotOnStaticMap} for map tiles
(
  mt, ##<< list returned by \code{GetMapTiles}
  lat, ##<< latitude values to be overlaid, if any
  lon, ##<< longitude values to be overlaid, if any
  center, ##<< optional center
  size = c(768,768), ##<< size (in pixels) of "stitched" map 
  add=FALSE, ##<< start a new plot or add to an existing
  FUN = points, ##<< plotting function to use for overlay; typical choices would be \link{points} and \link{lines} 
  mar=c(0,0,0,0), ##<< outer margin in plot; if you want to see axes, change the default
  verbose=0, ##<< level of verbosity
  ... ##<< further arguments to be passed to \code{FUN}
){
  #library(png)
  if (mt$tileExt == ".jpg") {
    readImg = jpeg::readJPEG
  } else if (mt$tileExt == ".png")  {
    readImg = png::readPNG
  }
  par(mar=mar)
  
  if (grepl("osm|stamen", mt$type)) {
    plotOSM(mt)
    
    if (!missing(lat) & !missing(lon)){
      stopifnot(length(lat)==length(lon))
      XY=geosphere_mercator(cbind(lon,lat))
      
      FUN(XY[,"x"],XY[,"y"],...)
    }
  } else {
    
  
  tw = 257/256#257/256 #tile width and height
  X=mt$X;Y=mt$Y
  rX = range(X);rY = range(Y);
  if (0) if (missing(center)) {
    if (!missing(lat) & !missing(lon)){
      centerXY=LatLon2XY(mean(lat),mean(lon),mt$zoom)
      XY2=as.data.frame(centerXY$Tile + centerXY$Coords/256)
      XY2[,"Y2"] = sum(rY)-XY2[,"Y"]
      xx=XY2[,"X"]+size[1]/512*c(-1,1)
      yy=XY2[,"Y2"]+size[2]/512*c(-1,1)
      plot(xx,yy,type="n", axes=FALSE, xlab="", ylab="", asp = 1);
      tmp2 <- par('usr');
      updateusr(tmp2[1:2], x2=xx, tmp2[3:4], y2=yy );
    } else {
      
    }
  }
  if (!add){
    plot(rX+c(0,tw),rY+c(0,tw),type="n", axes=FALSE, xlab="", ylab="", asp = 1);
    tmp2 <- par('usr');
    updateusr(tmp2[1:2], x2=rX+c(0,tw), tmp2[3:4], y2=rY+c(0,tw) );
    if (verbose) cat("user coords:",par("usr"), "\n")
    
    k=1
    for (x in X){
      for (y in Y){
        if (length(mt$tiles)==0){
          mapFile = file.path(mt$tileDir, paste(mt$zoom, x, y, sep="_"))
          tile=readImg(paste0(mapFile,mt$tileExt), native=TRUE);
        } else {
          tile = mt$tiles[[k]]
          k=k+1
        }
        if (exists("rasterImage")) { # can plot only in R 2.11.0 and higher      
          #if (require(grid)) grid.raster(MyMap[[4]], width=1, height=1, y=0, just="bottom") else 
          yr = sum(rY)-y
          rasterImage(tile, x,yr,x+tw,yr+tw);
          if (verbose) {
            cat("placing tile at coords:",x,yr,x+tw,yr+tw, "\n")
            rect(x,yr,x+tw,yr+tw)
          }
        }
      }
    }
  }
  
  if (!missing(lat) & !missing(lon)){
    stopifnot(length(lat)==length(lon))
    XY=LatLon2XY(lat,lon,mt$zoom)
    XY2=as.data.frame(XY$Tile + XY$Coords/256)
    #browser()
    XY2[,"Y2"] = sum(rY)-XY2[,"Y"]
    if (verbose) {
      cat("lat lon become:")
      print(XY2)
    }
    FUN(XY2[,"X"],XY2[,"Y2"]+1,...)
  }
  }
### nothing returned
}, ex = function(){

  if (0){
    lat = c(40.702147,40.718217,40.711614);
    lon = c(-74.012318,-74.015794,-73.998284);
    center = c(mean(lat), mean(lon));
    zoom <- min(MaxZoom(range(lat), range(lon)));
    bb=qbbox(lat,lon)
    
    manhattan_osm = GetMapTiles(latR =bb$latR , lonR=bb$lonR,zoom=zoom,verbose=1)
    PlotOnMapTiles(manhattan_osm,lat=lat,lon=lon,pch=20,col=c('red', 'blue', 'green'),cex=2)
    
    manhattan_goo = GetMapTiles(latR =bb$latR , lonR=bb$lonR,zoom=zoom,
                     tileDir= TRUE, type="google" )
    PlotOnMapTiles(manhattan_goo,lat=lat,lon=lon,pch=20,col=c('red', 'blue', 'green'),cex=2)
    
  }
})

`TextOnStaticMap` <-structure(function#plots text on map
### TextOnStaticMap draws the strings given in the vector labels at the coordinates given by x and y on a map. y may be missing since xy.coords(x,y) is used for construction of the coordinates.
(
  MyMap, ##<<  map image returned from e.g. \code{GetMap()}
  lat, ##<< latitude where to put text.
  lon, ##<< longitude where to put text.
  labels = seq_along(lat), ##<< a character vector or \link{expression} specifying the text to be written. An attempt is made to coerce other language objects (names and calls) to expressions, and vectors and other classed objects to character vectors by \link{as.character}. If labels is longer than x and y, the coordinates are recycled to the length of labels.
  TrueProj = TRUE, ##<< set to FALSE if you are willing to accept some degree of inaccuracy in the mapping. In that case, the coordinates of the image are in lat/lon and the user can simply overly points/lines/axis without worrying about projections
  FUN = text, ##<< overlay function, typical choice would be \link{text}
  add = FALSE, ##<< start a new plot or add to an existing
  verbose = 0, ##<< level of verbosity 
  ... ##<< further arguments to be passed to \code{FUN}
){
      
  if (TrueProj){
    Rcoords <- LatLon2XY.centered(MyMap,lat= lat,lon= lon);   
  }  else { #no transformtion
    Rcoords <- list(newY= lat,newX= lon);   
  }
  
  if (!add) tmp <- PlotOnStaticMap(MyMap, TrueProj = TrueProj, verbose=verbose);
  FUN(x=Rcoords$newX, y=Rcoords$newY, labels = labels, ...);
### return value of \code{FUN}
}, ex = function(){
  if (0) {
   lat = c(40.702147,40.718217,40.711614);
    lon = c(-74.012318,-74.015794,-73.998284);
    center = c(mean(lat), mean(lon));
    zoom <- min(MaxZoom(range(lat), range(lon)));
    
   
   MyMap <- GetMap(center=center, zoom=zoom,markers = paste0("&markers=color:blue|label:S|",
            "40.702147,-74.015794&markers=color:green|label:G|40.711614,-74.012318&markers=",
             "color:red|color:red|label:C|40.718217,-73.998284"), destfile = "MyTile1.png");
    TextOnStaticMap(MyMap, lat=40.711614,lon=-74.012318, "Some Text", cex=2, col = 'red')
    
}
})

DF2SpatialPointsDataFrame <- structure(function#change data.frame to SpatialPointsDataFrame
### This function modifies an object of class data.frame to one of class SpatialPointsDataFrame
(  x, ##<< data frame to be converted
   coords = c("x", "y"),##<< which columns are coordinates
   crs = sp::CRS("+init=epsg:28992") ##<< projection scheme
){
  #require(sp)
  sp::coordinates(x) <- ~x+y #c("x", "y")
  sp::proj4string(x) <- crs;
  return(x)
###  the new object of class SpatialPointsDataFrame
} , ex = function(){
  if (requireNamespace("sp", quietly = TRUE)) {
    data("meuse", package = "sp", envir = environment())
    meuseSP = DF2SpatialPointsDataFrame(meuse)
    
    sp::plot(meuseSP, asp = 1, cex = 4 * meuse$zinc/max(meuse$zinc),
         pch = 1, col = as.numeric(meuse$ffreq)+1 )
    data("meuse.riv", package = "sp", envir = environment())
    lines(meuse.riv)  
  } else {
    print("package sp must be installed for this example")
  }

  
})

`GetMap.bbox` <- structure(function
### Wrapper function for \link{GetMap}. Query the Google server for a static map tile, defined primarily by its lat/lon range and/or center and/or zoom. 
### Multiple additional arguments allow the user to customize the map tile.
( lonR, ##<< longitude range
  latR, ##<<  latitude range
  center, ##<< optional center
  size = c(640,640), ##<< desired size of the map tile image. defaults to maximum size returned by the Gogle server, which is 640x640 pixels 
  destfile = "MyTile.png", ##<<  File to load the map image from or save to, depending on \code{NEWMAP}.
  MINIMUMSIZE = FALSE, ##<< reduce the size of the map to its minimum size that still fits the lat/lon ranges ?
  RETURNIMAGE = TRUE, ##<< return image yes/no default: TRUE
  GRAYSCALE =FALSE, ##<< Boolean toggle; if TRUE the colored map tile is rendered into a black & white image, see \link{RGB2GRAY}
  NEWMAP = TRUE, ##<< if TRUE, query the Google server and save to \code{destfile}, if FALSE load from destfile.
  zoom,  ##<< Google maps zoom level. optional
  verbose=0, ##<< level of verbosity
  SCALE = 1, ##<< use the API's scale parameter to return higher-resolution map images. The scale value is multiplied with the size to determine the actual output size of the image in pixels, without changing the coverage area of the map
  type = c("google", "google-m","google-s","osm", "osm-hot", "stamen-toner", "stamen-terrain", "stamen-watercolor")[1],  ##<< choice of tile server
  urlBase = "http://mt1.google.com/vt/lyrs=m" , ##<< tileserver URL, alternatives would be "http://a.tile.openstreetmap.org/", "http://tile.stamen.com/toner/","http://tile.stamen.com/watercolor/"
  tileDir= "/tmp/", ##<< map tiles can be stored in a local directory, e.g. "~/mapTiles/Google/"
  ... ##<< extra arguments to \link{GetMap} 
){
  	if (missing(zoom)) zoom <- min(MaxZoom(latR, lonR, size));
 	if (missing(center)){
 	  lat.center <- mean(latR);#latR[1] + diff(latR)/2;
      lon.center <- mean(lonR);#lonR[1] + diff(lonR)/2;
    } else {
    	lat.center <- center[1];
    	lon.center <- center[2];
    }
     
    if (MINIMUMSIZE){
    	ll <- LatLon2XY(latR[1], lonR[1], zoom);#lower left corner
    	ur <- LatLon2XY(latR[2], lonR[2], zoom );#upper right corner
    	cr <- LatLon2XY(lat.center, lon.center, zoom );#center
    	ll.Rcoords <- Tile2R(ll, cr);
    	ur.Rcoords <- Tile2R(ur, cr);
    	if (verbose>1){
    		cat("ll:"); print(ll);print(ll.Rcoords)
    		cat("ur:"); print(ur);print(ur.Rcoords);
    		cat("cr:"); print(cr);
    	}
    	#return(list(ll,ur));
    	size[1] <- 2*max(c(ceiling(abs(ll.Rcoords$X)), ceiling(abs(ur.Rcoords$X)) ))+1;
    	size[2] <- 2*max(c(ceiling(abs(ll.Rcoords$Y)), ceiling(abs(ur.Rcoords$Y)) ))+1;
    	#size[1] <- ceiling(abs(256* (ur$Tile[,"X"] - ll$Tile[,"X"]) + (ur$Coords[,"x"] - ll$Coords[,"x"])));
    	#size[2] <- ceiling(abs(256* (ur$Tile[,"Y"] - ll$Tile[,"Y"]) + (ur$Coords[,"y"] - ll$Coords[,"y"])));
    	if (verbose) cat("new size: ", size, "\n")
    }
 	#if (NEWMAP) 
 	return(GetMap(center = c(lat.center, lon.center), zoom = zoom, size=size, destfile = destfile, RETURNIMAGE = RETURNIMAGE, GRAYSCALE = GRAYSCALE, SCALE=SCALE, type=type, urlBase=urlBase, tileDir=tileDir, verbose = verbose, ...));
 ### map tile

 }, ex = function(){
   if (0){
   	mymarkers <- cbind.data.frame(lat = c(38.898648,38.889112, 38.880940), 
            lon = c(-77.037692, -77.050273, -77.03660), size =  c('tiny','tiny','tiny'), 
            col = c('blue', 'green', 'red'), char = c('','',''));
  
  	##get the bounding box:
    	bb <- qbbox(lat = mymarkers[,"lat"], lon = mymarkers[,"lon"]);
    
  	##download the map:
    	MyMap <- GetMap.bbox(bb$lonR, bb$latR, destfile = "DC.png", GRAYSCALE =TRUE,
                  markers = mymarkers);
   	##The function qbbox() basically computes a bounding box for the given lat,lon 
     #points with a few additional options such as quantile boxes, additional buffers, etc.  
    	bb <- qbbox(c(40.702147,40.711614,40.718217),c(-74.015794,-74.012318,-73.998284), 
              TYPE = "all", margin = list(m=rep(5,4), TYPE = c("perc", "abs")[1]));
   	##download the map:           
  	MyMap <- GetMap.bbox(bb$lonR, bb$latR,destfile = "MyTile3.png", maptype = "satellite") 

  }
})

`PlotOnStaticMap` <-structure(function# overlays plot on background image of map tile
###This function is the workhorse of the package RgoogleMaps. It overlays plot on background image of map tile
(
  MyMap, ##<< optional map object 
  lat, ##<< latitude values to be overlaid
  lon, ##<< longitude values to be overlaid
  destfile, ##<< File to load the map image from or save to, depending on whether \code{MyMap} was passed. 
  zoom = NULL, ##<< Google maps zoom level. optional if \code{MyMap} is passed, required if not.
  size, ##<< desired size of the map tile image. defaults to maximum size returned by the Gogle server, which is 640x640 pixels  
  GRAYSCALE =FALSE, ##<< Boolean toggle; if TRUE the colored map tile is rendered into a black & white image, see \link{RGB2GRAY} 
  add=FALSE, ##<< start a new plot or add to an existing
  FUN = points, ##<< plotting function to use for overlay; typical choices would be \link{points} and \link{lines} 
  mar=c(0,0,0,0), ##<< outer margin in plot; if you want to see axes, change the default
  NEWMAP = TRUE, ##<< load map from file or get it "new" from the static map server
  TrueProj = TRUE, ##<< set to FALSE if you are willing to accept some degree of inaccuracy in the mapping. In that case, the coordinates of the image are in lat/lon and the user can simply overly points/lines/axis without worrying about projections
  axes= FALSE, ##<< overlay axes ?
  atX = NULL, ##<< numeric; position of ticks on x-axis; if missing, \link{axTicks} is called for nice values; see \link{axis}
  atY = NULL, ##<< numeric; position of ticks on y-axis; if missing, \link{axTicks} is called for nice values; see \link{axis}
#  alpha = 0.75, ##<< opacity
  verbose = 0, ##<< level of verbosity 
  ... ##<< further arguments to be passed to \code{FUN}
){
  
  if (!NEWMAP & missing(MyMap) & missing(lat) & missing(lon) ){
    MyMap <- ReadMapTile(destfile, TRUE);
  } else if (missing(MyMap)) MyMap <- MapBackground(lat=lat,lon=lon, destfile =destfile, zoom=zoom, size=size, GRAYSCALE =GRAYSCALE, mar=mar, NEWMAP = NEWMAP, verbose=verbose);
  
  if (missing(size)) size <- dim(MyMap[[4]])[2:1];
  if (verbose == -1) browser();
  
  lat.center <- MyMap[[1]];
  lon.center <- MyMap[[2]];
  zoom <- MyMap[[3]];
  # if (TrueProj & MyMap$url == "OSM") {
  #   print("Caution: map type is OpenStreetMap. Until we find the correct projection algorithm, we treat lat/lon like planar coordinates and set TrueProj = FALSE.")
  #   TrueProj = FALSE;
  # }
  
  if ( !("BBOX" %in% names(MyMap)) ) MyMap$BBOX <- list(ll = XY2LatLon(MyMap, -size[1]/2 + 0.5, -size[2]/2 + 0.5), ur = XY2LatLon(MyMap, size[1]/2 - 0.5, size[2]/2 - 0.5) );
  
  if (verbose > 0) print(str(MyMap));
  if (!add) {
    #require(rimage)
    if ( all(is.na(charmatch(c("png","pdf","postscript", "jpeg"), names(dev.cur())))) ) {
      #if ( is.na(charmatch("null", names(dev.cur())) ) )  dev.off();
      #dev.new(width=7*size[1]/640, height=7*size[2]/640)
    }
    par(mar=mar);#par(pin=c(9,9))
    
    if (class(MyMap[[4]])[1] == "matrix"){
      x= seq(MyMap$BBOX$ll[2], MyMap$BBOX$ur[2], length= size[1]);
      y= seq(MyMap$BBOX$ll[1], MyMap$BBOX$ur[1], length= size[2]);
      image(x=x,y=y, z=MyMap[[4]], col = attr(MyMap[[4]], "COL"), xlab = "", ylab = "", axes = FALSE)
      #image(MyMap[[4]], "ind", col = attr(MyMap[[4]], "COL"))
    } else if (class(MyMap[[4]])[1] == "SpatialGridDataFrame"){
      image(MyMap[[4]], red=1, green=2, blue=3, axes = FALSE);
    } else if (class(MyMap[[4]])[1] %in% c("nativeRaster", "raster", "array")){
      if (exists("rasterImage")) { # can plot only in R 2.11.0 and higher
        plot(0:1,0:1,type="n", axes=FALSE, xlab="", ylab="", asp = size[2]/size[1]);
        tmp2 <- par('usr');
        updateusr(tmp2[1:2], x2=c(0,1), tmp2[3:4], y2=c(0,1) );
        #if (require(grid)) grid.raster(MyMap[[4]], width=1, height=1, y=0, just="bottom") else 
        rasterImage(MyMap[[4]], 0,0,1,1);
      } else {
        #myplot.imagematrix(x=x, y=y, z=MyMap[[4]], axes = FALSE);
      }
    } 
    tmp2 <- par("usr");
    offset = 1;
    if (TrueProj){
      SCALE = 2*MyMap$SCALE
      updateusr(tmp2[1:2], x2=c(-size[1]+offset, size[1]-offset)/SCALE, tmp2[3:4], y2=c(-size[2]+offset, size[2]-offset)/SCALE );
    } 
    if (axes){
      degreeAxis(1, MyMap=MyMap, at=atX); degreeAxis(2, MyMap=MyMap, at=atY);
    }
    #browser();
  }
  
  
  if (!missing(lat) & !missing(lon)){
    #if (TrueProj){
    Rcoords <- LatLon2XY.centered(MyMap,lat,lon);
    newX <- Rcoords$newX;
    newY <- Rcoords$newY;
    #browser()
    if (verbose) {
      print(range(newX, na.rm=TRUE));
      print(range(newY, na.rm=TRUE));
      #print(list(newX,newY));
    }
    #     } else {
    #        Rcoords<-transfXY(MyMap, lon, lat)
    #        newX <- Rcoords$newX;
    #        newY <- Rcoords$newY;
    #        #newX <- lon;
    #        #newY <- lat;
    #     }    
    
    FUN(newX, newY, ...)
  }
  
  #invisible(list(newX,newY)); 
  invisible(MyMap)
  ### the map object is returned via \code{invisible(MyMap)}
}, ex = function(){
#The first step naturally will be to download a static map from the Google server. A simple example:

  if (0){
    lat = c(40.702147,40.711614,40.718217);
    lon = c(-74.015794,-74.012318,-73.998284);
    center = c(mean(lat), mean(lon));
    zoom <- min(MaxZoom(range(lat), range(lon)));
    #this overhead is taken care of implicitly by GetMap.bbox();              
    MyMap <- GetMap(center=center, zoom=zoom,markers = paste0("&markers=color:blue|label:S|",
             "40.702147,-74.015794&markers=color:green|label:G|40.711614,-74.012318&markers=",
             "color:red|color:red|label:C|40.718217,-73.998284"), destfile = "MyTile1.png");
                   
     tmp <- PlotOnStaticMap(MyMap, lat = lat, 
                            lon = lon, 
                            destfile = "MyTile1.png", cex=1.5,pch=20,
                            col=c('red', 'blue', 'green'), add=FALSE);
     #and add lines:
     PlotOnStaticMap(MyMap, lat = c(40.702147,40.711614,40.718217), 
                     lon = c(-74.015794,-74.012318,-73.998284), 
                     lwd=1.5,col=c('red', 'blue', 'green'), FUN = lines, add=TRUE)
     	
  }
})

`RGB2GRAY` <-structure(function#translates an RGB image matrix to gray scale
 ###  This function translates the rgb values of the array myTile into a scalar matrix with just one gray value per pixel.
 (
   myTile ##<< rgb image matrix, usually array with 3 dimensions
 ){
   #Gray scale intensity = 0.30R + 0.59G + 0.11B
   stopifnot(attr(myTile, "type") != "gray");
   f = NULL
   ##details<< Gray scale intensity defined as  0.30R + 0.59G + 0.11B
   if (class(myTile)[1] == 'nativeRaster'){
     # comparing nativeRaster values is not easy, so let's do write/read again
     f = file.path(tempdir(), "tmpMap.png")
     writePNG(myTile, f)
     myTile = readPNG(f)
   }
   
   if (class(myTile)[1] == 'array'){
     #       if (0) {
     #         tmp = matrix(0.7, ncol=dim(myTile)[2], nrow=dim(myTile)[1] )
     #         for (i in 1:nrow(tmp))
     # 		for (j in 1:ncol(tmp))
     # 			tmp[i,j] = .3*myTile[i,j,1] + .59*myTile[i,j,2] + .11*myTile[i,j,3]
     #          myTile = tmp
     #        }
     #or in vectorized form:
     ncol=dim(myTile)[2]; nrow=dim(myTile)[1]
     dim(myTile) <- c(prod(dim(myTile)[1:2]),dim(myTile)[3])
     tmp = .3*myTile[,1] + .59*myTile[,2] + .11*myTile[,3]
     myTile = matrix(tmp, ncol=ncol, nrow=nrow )
     
   } 
   if (!is.null(f)){
     writePNG(myTile, f)
     myTile = readPNG(f, native = TRUE)
   }
   return(myTile);	
   ### image tile
}, ex=function(){
  if (0){
    BrooklynLatLon = getGeoCode("Brooklyn")
    mapBrooklyn <- GetMap(center=BrooklynLatLon, destfile = file.path(tempdir(), "Brooklyn.png"), 
                   zoom=11, size = c(240,240))
    mapBrooklynBW$myTile = RGB2GRAY(mapBrooklyn$myTile)
    PlotOnStaticMap(mapBrooklynBW)
  }
})

getGeoCode <- structure(function#geocoding utility
### Geocode your data using, R, JSON and OSM or Google Maps' Geocoding APIs 
(
  gcStr, ##<< adddress to geocode
  API = c("osm", "google")[1], ##<< which API to use. see https://nominatim.org/release-docs/develop/api/Search/ and http://allthingsr.blogspot.de/2012/01/geocode-your-data-using-r-json-and.html
  JSON = FALSE, ##<< use the JSON protocol. If FALSE, we do not have to load additional libraries
  verbose=0 ##<< level of verbosity
){
  #library("RJSONIO") #Load Library
  gcStr <- enc2utf8(gsub(' ','%20',gcStr)) #Encode URL Parameters
  if (API == "google"){
    #baseURL= paste0('http://maps.google.com/maps/api/geocode/",ifelse(JSON, "json","xml"),"?sensor=false&address=')
  
    if (JSON){
      #Open Connection
      # connectStr <- paste('http://maps.google.com/maps/api/geocode/json?sensor=false&address=',gcStr, sep="") 
      # if (verbose) cat("fetching ", connectStr, "\n")
      # con <- url(connectStr)
      # data.json <- fromJSON(paste(readLines(con), collapse=""))
      # close(con)
      # #Flatten the received JSON
      # data.json <- unlist(data.json)
      # lat <- data.json["results.geometry.location.lat"]
      # lng <- data.json["results.geometry.location.lng"]
      
      connectStr <- paste('http://maps.google.com/maps/api/geocode/json?sensor=false&address=',gcStr, sep="") 
      if (verbose) cat("fetching ", connectStr, "\n")
      con <- url(connectStr)
      data.json <- readLines(con)
      close(con)
      
      iLoc = grep("\"location\"", data.json,fixed=TRUE)
      iLat = grep("\"lat\"", data.json,fixed=TRUE); iLat = min(iLat[iLat>iLoc])
      lat = as.numeric(gsub(",", "",gsub("\"lat\" : ", "", data.json[iLat])))
      iLng = grep("\"lng\"", data.json,fixed=TRUE); iLng = min(iLng[iLng>iLoc])
      lng = as.numeric(gsub(",", "",gsub("\"lng\" :", "", data.json[iLng])))
      
    } else {
      #Open Connection
      connectStr <- paste('http://maps.google.com/maps/api/geocode/xml?sensor=false&address=',gcStr, sep="") 
      if (verbose) cat("fetching ", connectStr, "\n")
      con <- url(connectStr)
      data.xml <- readLines(con)
      close(con)
      #browser()
      iLoc = grep("<location>", data.xml,fixed=TRUE)
      iLat = grep("<lat>", data.xml,fixed=TRUE); iLat = min(iLat[iLat>iLoc])
      lat = as.numeric(gsub("</lat>", "",gsub("<lat>", "", data.xml[iLat])))
      iLng = grep("<lng>", data.xml,fixed=TRUE); iLng = min(iLng[iLng>iLoc])
      lng = as.numeric(gsub("</lng>", "",gsub("<lng>", "", data.xml[iLng])))
    }
  } else if (API == "osm") {
    #baseURL= paste0("https://nominatim.openstreetmap.org/search?format=",ifelse(JSON, "json","xml"),"&polygon=0&addressdetails=0&q=")
    # https://nominatim.openstreetmap.org/search?format=xml&polygon=0&addressdetails=0&q=135+pilkington+avenue,+birmingham&
    #https://nominatim.openstreetmap.org/search?q=17+Strada+Pictor+Alexandru+Romano%2C+Bukarest&format=xml
    if (JSON) {
      
    } else {
      connectStr <- paste0("https://nominatim.openstreetmap.org/search?q=",gcStr,"&format=xml&limit=1") 
      if (verbose) cat("fetching ", connectStr, "\n")
      con <- url(connectStr)
      data.xml <- readLines(con, warn=FALSE)
      close(con)
      #browser()
      tmp=unlist(strsplit( data.xml," "))
      iLat = grep("lat=", tmp,fixed=TRUE)
      lat = as.numeric(gsub("lat='|'", "",tmp[iLat]))
      iLng = grep("lon=", tmp,fixed=TRUE)
      lng = as.numeric(gsub("lon='|'", "",tmp[iLng]))
    }
    
  }
  gcodes <- as.numeric(c(lat, lng))
  names(gcodes) <- c("lat", "lon")
  return (gcodes)
### returns lat/lon for address
}, ex = function(){
  if (0){
    getGeoCode("1600 Amphitheatre Parkway, Mountain View, CA")
    getGeoCode("Brooklyn")
    #You can run this on the entire column of a data frame or a data table:
    DF = cbind.data.frame(address=c("Berlin,Germany", "Princeton,NJ", 
              "cadillac+mountain+acadia+national+park"), lat = NA, lon = NA)
    DF <- with(DF, data.frame(address, t(sapply(DF$address, getGeoCode))))
  }
})

`updateusr` <-structure(function#Updates the 'usr' coordinates in the current plot.
### For a traditional graphics plot this function will update the 'usr'
### coordinates by transforming a pair of points from the current usr
### coordinates to those specified.
(
  x1, ##<< The x-coords of 2 points in the current 'usr' coordinates, or anything that can be passed to \code{xy.coords}.
  y1 = NULL, ##<< The y-coords of 2 points in the current 'usr' coordinates, or an object representing the points in the new 'usr' coordinates. 
  x2, ##<< The x-coords for the 2 points in the new coordinates.
  y2 = NULL ##<< The y-coords for the 2 points in the new coordinates.
) 
{
    xy1 <- xy.coords(x1, y1)
    xy2 <- if (missing(x2) && missing(y2)) {
        xy.coords(y1)
    }
    else {
        xy.coords(x2, y2)
    }
    cur.usr <- par("usr")
    xslope <- diff(xy2$x)/diff(xy1$x)
    yslope <- diff(xy2$y)/diff(xy1$y)
    new.usr.x <- xslope * (cur.usr[1:2] - xy1$x) + xy2$x
    new.usr.y <- yslope * (cur.usr[3:4] - xy1$y) + xy2$y
    invisible(par(usr = c(new.usr.x, new.usr.y)))

##details<< Sometimes graphs (in the traditional graphing scheme) end up with usr
##  coordinates different from expected for adding to the plot (for
##  example \code{barplot} does not center the bars at integers).  This
##  function will take 2 points in the current 'usr' coordinates and the
##  desired 'usr' coordinates of the 2 points and transform the user
##  coordinates to make this happen.  The updating only shifts and scales
##  the coordinates, it does not do any rotation or warping transforms.
##
##  If \code{x1} and \code{y1} are lists or matricies and \code{x2} and
##  \code{y2} are not specified, then \code{x1} is taken to be the
##  coordinates in the current system and \code{y1} is the coordinates in
##  the new system.
##
##  Currently you need to give the function exactly 2 points in each
##  system.  The 2 points cannot have the same x values or y values in
##  either system.

##note<<  Currently you need to give coordinates for exactly 2 points without
##  missing values.  Future versions of the function will allow missing
##  values or multiple points.
##  
##  Note by Markus Loecher: both the source and the documentations were copied from the package TeachingDemos version 2.3


### An invisible list with the previous 'usr' coordinates from \code{par}.
}, ex = function(){
  tmp <- barplot(1:4)
  updateusr(tmp[1:2], 0:1, 1:2, 0:1)
  lines(1:4, c(1,3,2,2), lwd=3, type='b',col='red')

  # update the y-axis to put a reference distribution line in the bottom
  # quarter

  tmp <- rnorm(100)
  hist(tmp)
  tmp2 <- par('usr')
  xx <- seq(min(tmp), max(tmp), length.out=250)
  yy <- dnorm(xx, mean(tmp), sd(tmp))
  updateusr( tmp2[1:2], tmp2[3:4], tmp2[1:2], c(0, max(yy)*4) )
  lines(xx,yy)

})

genStaticMap = structure(function#generates a "static map" from map tiles by "stitching" them together
### necssary because the Google static maps API requires a key now
(
  #mt, ##<< list returned by \code{GetMapTiles}
  center, ##<< optional center
  zoom = 15, ##<< zoom
  size = c(640,640), ##<< size (in pixels) of "stitched" map 
  destfile = tempfile("staticMap",fileext = ".png"), ##<<  File to load the map image from or save to, depending on \code{NEWMAP}.
  type = c("google", "google-m","google-s","osm", "osm-hot", "stamen-toner", "stamen-terrain", "stamen-watercolor")[1],  ##<< choice of tile server
  urlBase = "http://mt1.google.com/vt/lyrs=m" , ##<< tileserver URL, alternatives would be "http://a.tile.openstreetmap.org/", "http://tile.stamen.com/toner/","http://tile.stamen.com/watercolor/"
  tileDir= "/tmp/", ##<< map tiles can be stored in a local directory, e.g. "~/mapTiles/Google/"
  tileExt = ".png", ##<< image type of tile
  verbose=0, ##<< level of verbosity
  ... ##<< further arguments to be passed to \code{FUN}
){
  #library(png)
  nTiles = round(size/256)+3
  #browser() 
  if (grepl("lyrs=s|lyrs=y",urlBase)) tileExt = ".jpg" #satellite or hybrid
  if (tileExt == ".jpg") {
    readImg = jpeg::readJPEG
  } else if (tileExt == ".png")  {
    readImg = png::readPNG
  }
  
  
  mt = GetMapTiles(center=center,zoom=zoom,tileDir = tileDir,
                   type=type,urlBase=urlBase, 
                   nTiles = nTiles)
  
  tw = 257/256#257/256 #tile width and height
  X=mt$X;Y=mt$Y
  #rX = range(X);rY = range(Y);
  
  XY=LatLon2XY(center[1],center[2],mt$zoom)
  XY2=as.data.frame(XY$Tile + XY$Coords/256)
  
  
  rX=XY2[,"X"]+ c(-1,1)*size[1]/512
  rY=XY2[,"Y"]+ c(-1,1)*size[2]/512-1
  XY2[,"Y2"] = sum(rY)-XY2[,"Y"]+1
  
  png(destfile,size[1],size[2])
  par(mar=rep(0,4))
  plot(rX+c(0,1/256),rY+c(0,1/256),type="n", axes=FALSE, xlab="", ylab="", asp = 1);
  tmp2 <- par('usr');
  
  updateusr(tmp2[1:2], x2=rX+c(0,1/256), tmp2[3:4], y2=rY+c(0,1/256) );
  usrNew =par("usr")
  if (verbose) cat("user coords:",par("usr"), "\n")
    
  k=0
  for (x in X){
      for (y in Y){
        k=k+1
        if (length(mt$tiles)==0){
          mapFile = file.path(mt$tileDir, paste(mt$zoom, x, y, sep="_"))
          tile=readImg(paste0(mapFile,mt$tileExt), native=TRUE);
        } else {
          tile = mt$tiles[[k]]
        }
        if (exists("rasterImage")) { # can plot only in R 2.11.0 and higher      
          #if (require(grid)) grid.raster(MyMap[[4]], width=1, height=1, y=0, just="bottom") else 
          yr = sum(rY)-y
          rasterImage(tile, x,yr,x+tw,yr+tw);
          if (verbose>1) rect(x,yr,x+tw,yr+tw)
          if (!all(usrNew ==par("usr"))) #if (verbose)
            cat("placing ", k,"th tile at coords:",x,yr,x+tw,yr+tw, "\n")
        }
      }
  }
  
  
  if (verbose>1) {
    points(XY2[,"X"],XY2[,"Y2"],col=2,pch=20)
    browser()
  }
  dev.off()
  
  
invisible(destfile)
### list with tiles
}, ex = function(){

  if (0){
    lat = c(40.702147,40.718217,40.711614);
    lon = c(-74.012318,-74.015794,-73.998284);
    center = c(mean(lat), mean(lon));
    zoom <- min(MaxZoom(range(lat), range(lon)));
    bb=qbbox(lat,lon)
    
    mt = GetMapTiles(latR =bb$latR , lonR=bb$lonR,zoom=zoom,verbose=1)
    PlotOnMapTiles(mt,lat=lat,lon=lon,pch=20,col=c('red', 'blue', 'green'),cex=2)
    
    mt = GetMapTiles(latR =bb$latR , lonR=bb$lonR,zoom=zoom,
                     tileDir= "~/mapTiles/Google/")
    PlotOnMapTiles(mt,lat=lat,lon=lon,pch=20,col=c('red', 'blue', 'green'),cex=2)
    
  }
})

IdentifyPoints <-structure( function#identify points by clicking on map
### The user can try to identify lat/lon pairs on the map by clicking on them
( 
  MyMap, ##<< map object
  n=1,##<< the maximum number of points to locate.
  verbose = 0 ##<< level of verbosity
){
  cat("please identify ", n, "point(s) on the map with your mouse:\n")
  ret = locator(n)
  LatLon <- XY2LatLon(MyMap, ret$x,Y=ret$y)
  return(LatLon)
### the lat/lon coordinates of the chosen points are returned 
}, ex = function(){
  #The first step naturally will be to download a static map from the Google server. A simple example:
  
   #identifiy points:
   #IdentifyPoints(MyMap,5)
  
})

`GetMap` <- structure(function# download a static map from the Google server
### Query the Google server for a static map tile, defined primarily by its 
### center and zoom. Many additional arguments allow the user to customize 
### the map tile.
### documentation at https://developers.google.com/maps/documentation/staticmaps/
(
  center=c(lat=42, lon=-76), ##<< optional center (lat first,lon second  )
  size = c(640,640), ##<< desired size of the map tile image. defaults to maximum size returned by the Gogle server, which is 640x640 pixels 
  destfile = tempfile("staticMap",fileext = ".png"), ##<<  File to load the map image from or save to, depending on \code{NEWMAP}.
  zoom =12, ##<< Google maps zoom level.
  markers,  ##<< (optional) defines one or more markers to attach to the image at specified locations. This parameter takes a string of marker definitions separated by the pipe character (|) 
  path="",  ##<< (optional) defines a single path of two or more connected points to overlay on the image at specified locations. This parameter takes a string of point definitions separated by the pipe character (|)
  span, ##<< (optional) defines a minimum viewport for the map image expressed as a latitude and longitude pair. The static map service takes this value and produces a map of the proper zoom level to include the entire provided span value from the map`s center point. Note that the resulting map may include larger bounds for either latitude or longitude depending on the rectangular dimensions of the map. If zoom is specified, span is ignored 
  frame, ##<< (optional) specifies that the resulting image should be framed with a colored blue border. The frame consists of a 5 pixel, 55 % opacity blue border. 
  hl, ##<< (optional) defines the language to use for display of labels on map tiles. Note that this paramater is only supported for some country tiles; if the specific language requested is not supported for the tile set, then the default language for that tile set will be used.
  sensor = "true",  ##<< specifies whether the application requesting the static map is using a sensor to determine the user`s location. This parameter is now required for all static map requests.
  maptype = c("roadmap","mobile","satellite","terrain","hybrid","mapmaker-roadmap","mapmaker-hybrid")[2], ##<< defines the type of map to construct. There are several possible maptype values, including satellite, terrain, hybrid, and mobile. 
  format = c("gif","jpg","jpg-baseline","png8","png32")[5],  ##<< (optional) defines the format of the resulting image. By default, the Static Maps API creates GIF images. There are several possible formats including GIF, JPEG and PNG types. Which format you use depends on how you intend to present the image. JPEG typically provides greater compression, while GIF and PNG provide greater detail. This version supports only PNG.
  extraURL="", ##<< custom URL suffix
  RETURNIMAGE = TRUE, ##<< return image yes/no default: TRUE
  GRAYSCALE =FALSE, ##<< Boolean toggle; if TRUE the colored map tile is rendered into a black & white image, see \link{RGB2GRAY}
  NEWMAP = TRUE, ##<< if TRUE, query the Google server and save to \code{destfile}, if FALSE load from destfile. 
  SCALE = 1, ##<< use the API's scale parameter to return higher-resolution map images. The scale value is multiplied with the size to determine the actual output size of the image in pixels, without changing the coverage area of the map
  API_console_key, ##<< API key (formerly optional, now mandatory). If missing, the function "stitches" a static map from map tiles
  type = c("google", "google-m","google-s","osm", "osm-hot", "stamen-toner", "stamen-terrain", "stamen-watercolor")[1],  ##<< choice of tile server
  urlBase = "http://mt1.google.com/vt/lyrs=m" , ##<< tileserver URL, alternatives would be "http://a.tile.openstreetmap.org/", "http://tile.stamen.com/toner/","http://tile.stamen.com/watercolor/"
  tileDir= "/tmp/", ##<< map tiles can be stored in a local directory, e.g. "~/mapTiles/Google/"
  verbose=0 ##<< level of verbosity
){
  ##note<<Note that size is in order (lon, lat)
  
  if (!NEWMAP) {
    #no new map download
    myMap <- ReadMapTile(destfile); 
    return(myMap);
  }
  
  if (is.character(center)) {
    if (verbose) cat("geocoding ", center, "\n")
    center = getGeoCode(center,verbose)
  }
  if (all(c("lat","lon") %in% names(center))) center = center[c("lat","lon")]
  ##seealso<< \link{GetMap.bbox}
  
#   if (is.null(names(center))) {
#     names(center) = c("lat", "lon");
#   } else stopifnot( all(names(center) %in% c("lat", "lon")) )
#   
  if (!is.null(center)) {
    centerNum = center
    center <- paste(center,collapse=",")
  }
  
  if (!missing(API_console_key)){
    print("API key provided")
    
    stopifnot(all(size <=640));
   
    if (length(size) < 2) {s <- paste(size,size,sep="x")} else {s <- paste(size,collapse="x");}
    
    # if (missing(format)){	
    #   if ( fileExt == "png") format <- "png32"
    # }
   
    googleurl <- "https://maps.googleapis.com/maps/api/staticmap?"# "http://maps.google.com/maps/api/staticmap?"; # googleurl <- 'http://maps.google.com/staticmap?';
  	
  	if (!missing(span)){#Images may specify a viewport (defined by latitude and longitude values expressed as degrees) to display around a provided center point by passing a span parameter. Defining a minimum viewport in this manner obviates the need to specify an exact zoom level. The static map service uses the span parameter in conjunction with the size parameter to construct a map of the proper zoom level which includes at least the given viewport constraints.
  		span <- paste(span,collapse=",")
  		urlStr <- paste(googleurl, "center=", center, "&span=", span,  "&size=",  s, "&maptype=", maptype, "&format=", format, "&sensor=", sensor, sep="")
  
  	} else 	if (is.null(center) & missing(zoom)) {#let the Static Maps API determine the correct center and zoom level implicitly, based on evaluation of the position of the markers:
  		stopifnot(!missing(markers) | path != "");
  		urlStr <- paste(googleurl,  "size=",  s, "&maptype=", maptype, "&format=", format, "&sensor=", sensor, sep="")
  	} else {
  		stopifnot(!is.null(center), !missing(zoom));
  		urlStr <- paste(googleurl, "center=", center, "&zoom=", zoom,  "&size=",  s, "&maptype=", maptype, "&format=", format, "&sensor=", sensor, sep="")
  	}
    if (!is.null(API_console_key))  
      urlStr <- paste0(urlStr,"&key=", API_console_key);
  	urlStr <- paste(urlStr, path, sep="");
  	urlStr <- paste(urlStr, extraURL, sep="");
  	
    if (!missing(hl)) urlStr <- paste0(urlStr, "&language=",hl);
    if (SCALE == 2) urlStr <- paste(urlStr, "&scale=", SCALE, sep="");
  	
  	if (!missing(markers)) {
  		#assumes markers is a list with names lat, lon, size (optional), color (optional), char (optional)
  		#if(is.data.frame(markers)) markers<-as.matrix(markers)
  		if ( is.matrix(markers) | is.data.frame(markers)) {
  		  stopifnot(all(c("lat","lon") %in% colnames(markers)))
  		  latlon = which(colnames(markers) %in% c("lat","lon"))
  		  for (i in 1:nrow(markers)){
  		  	m1 <- paste(markers[i,c("lat","lon")], collapse=",");
  		  	if (any(c("size","color","label") %in% colnames(markers) ) ) {
  		  	  m2 <- paste(colnames(markers)[-latlon], markers[i,-latlon], collapse="|",sep=":");
  		  	  m <- paste(m2,m1,sep="|")
  		  	} else {
  		  	  m <- m1
  		  	}
  		  	#m <- paste("&markers=",m,sep="")
  		  	#print(m)
  		  	if (i==1){ 
  		  		markers.string <- paste0("&markers=",m);
  			  } else { 
  				  markers.string <- paste(markers.string,paste0("&markers=",m), sep=""); 
  		    }
  		    #if (verbose) print(markers.string);
  		  }
  		  #browser()
  		  #markers.string <- paste("&markers=", markers.string,sep="")
  		} else if (is.character(markers)) {#already in the correct string format:
  		  markers.string <- markers;
  		} 
  		
  		urlStr <- paste(urlStr, markers.string, sep="");
      
  	}
  
  	if (verbose) print(urlStr);
  	if (is.null(center)) {
  	  if (verbose) print("Note that when center and zoom are not specified, no meta information on the map tile can be stored. This basically means that R cannot compute proper coordinates. You can still download the map tile and view it in R but overlays are not possible.");
  	  #ans <- readLines(n=1);
  	  #if (ans != "y") return(); 
  	  MetaInfo <- list(lat.center = NULL, lon.center  = NULL, zoom = zoom, 
  	                   url = "google", BBOX = NULL, size=size, SCALE = SCALE);
  	  
  	} else if ( is.numeric(centerNum) & !missing(zoom)) {  
  	  myMap <- list(lat.center = centerNum[1], lon.center  = centerNum[2], zoom = zoom, SCALE = SCALE);
  	  BBOX <- list(ll = XY2LatLon(myMap, -size[1]/2 + 0.5, -size[2]/2 - 0.5), ur = XY2LatLon(myMap, size[1]/2 + 0.5, size[2]/2 - 0.5) );
  	  MetaInfo <- list(lat.center = centerNum[1], lon.center  = centerNum[2], zoom = zoom, 
  	                   url = "google", BBOX = BBOX, size=size, SCALE = SCALE);
  	} 
  	if (missing(destfile)) destfile=file.path(tempdir(),"mapTile.png")
  	if (verbose == -1) browser();
  	
  	if (NEWMAP) {
  	  if (!missing(destfile)){ # destfile=file.path(tempdir(),"mapTile.png")
    	  fileBase <- substring(destfile,1, nchar(destfile)-4);
    	  fileExt <-  substring(destfile,nchar(destfile)-2,nchar(destfile));
    	  #save meta information about the image:    
    	  save(MetaInfo, file = paste(destfile,"rda",sep="."));
  	    download.file(urlStr, destfile, mode="wb", quiet = TRUE);
  	    myTile <- readPNG(destfile, native=TRUE);
  	  } else { #do not save to file, read direcly from connection
  	    #o new dependency on curl package: static maps are not saved to file by default any longer, instead read directly from connection
    	  #connectStr=enc2utf8(gsub(' ','%20',"http://maps.google.com/maps/api/staticmap?center=42,-76&zoom=16&size=640x640&maptype=mobile&format=png32&sensor=true")) #Encode URL Parameters
  	    #connectStr=enc2utf8(gsub(' ','%20', urlStr))
  	    #does not work in RStudio, see http://stackoverflow.com/questions/18407177/load-image-from-website !!
    #     con <- curl(urlStr, "rb")
    # 	  binMap=readBin(con,raw(), 1E5)
    # 	  
  	    # 	  myTile <- readPNG(binMap, native=FALSE);
    # 	  close(con)
  	  }
  	} else { #no new map download
  	  myMap <- ReadMapTile(destfile); 
  	}
  } else {# end of missing API key
  
    f=genStaticMap(center=centerNum, destfile = destfile, type=type, urlBase=urlBase, tileDir=tileDir, zoom=zoom, size=size,verbose=verbose)
    
    myMap <- list(lat.center = centerNum[1], lon.center  = centerNum[2], zoom = zoom, SCALE = SCALE);
    BBOX <- list(ll = XY2LatLon(myMap, -size[1]/2 + 0.5, -size[2]/2 - 0.5), ur = XY2LatLon(myMap, size[1]/2 + 0.5, size[2]/2 - 0.5) );
    url = "google"
    if (grepl("google", urlBase)) url = "google"
    if (grepl("stamen", urlBase)) url = "stamen"
    if (grepl("openstreetmap", urlBase)) url = "OSM"
    
    MetaInfo <- list(lat.center = centerNum[1], lon.center  = centerNum[2], zoom = zoom, 
                     url = url, BBOX = BBOX, size=size, SCALE = SCALE);


    fileBase <- substring(destfile,1, nchar(destfile)-4);
    fileExt <-  substring(destfile,nchar(destfile)-2,nchar(destfile));
    #save meta information about the image:    
    save(MetaInfo, file = paste(destfile,"rda",sep="."));
    myTile <- readPNG(destfile, native=TRUE);
  }  
    
    
	if (GRAYSCALE) {
		#browser()
		myTile <- RGB2GRAY(myTile);
		if (!missing(destfile)) writePNG(myTile, destfile)
	 }

	if (RETURNIMAGE){
 	  #myMap <- ReadMapTile(destfile); 
	  myMap <- list(lat.center= MetaInfo$lat.center, lon.center=MetaInfo$lon.center, zoom=MetaInfo$zoom, 
	                myTile=myTile, BBOX = MetaInfo$BBOX, url = MetaInfo$url, size=size, SCALE=MetaInfo$SCALE);
	  class(myMap) =  "staticMap"
  	return(myMap);
 	}
 	
	invisible(urlStr)
### map structure or URL used to download the tile.
}, ex = function(){
  if (0){#takes too long to run for CRAN check
    
    lat = c(40.702147,40.718217,40.711614);
    lon = c(-74.012318,-74.015794,-73.998284);
    center = c(mean(lat), mean(lon));
    zoom <- min(MaxZoom(range(lat), range(lon)));
    #this overhead is taken care of implicitly by GetMap.bbox(); 
    markers = paste0("&markers=color:blue|label:S|40.702147,-74.015794&markers=color:",
                     "green|label:G|40.711614,-74.012318&markers=color:red|color:red|",
                     "label:C|40.718217,-73.998284")
    myMap <- GetMap(center=center, zoom=zoom,markers=markers);
    #Note that in the presence of markers one often needs to add some extra padding to the 
    #latitude range to accomodate the extent of the top most marker
    
    #add a path, i.e. polyline:
    myMap <- GetMap(center=center, zoom=zoom,
                    path = paste0("&path=color:0x0000ff|weight:5|40.737102,-73.990318|",
                    "40.749825,-73.987963|40.752946,-73.987384|40.755823,-73.986397"));
    #use implicit geo coding 
    BrooklynMap <- GetMap(center="Brooklyn", zoom=13)
    PlotOnStaticMap(BrooklynMap)
    
    #use implicit geo coding and display labels in Korean:
    BrooklynMap <- GetMap(center="Brooklyn", zoom=13, hl="ko")
    PlotOnStaticMap(BrooklynMap)
    
    #no highways
    ManHatMap <- GetMap(center="Lower Manhattan", zoom=14, 
                        extraURL="&style=feature:road.highway|visibility:off",
                        destfile = "LowerManhattan.png")
    PlotOnStaticMap(ManHatMap)
    
    #reload the map without a new download:
    ManHatMap <- GetMap(destfile = "LowerManhattan.png",NEWMAP=FALSE)
    PlotOnStaticMap(ManHatMap)
  
    #The example below defines a polygonal area within Manhattan, passed a series of 
    #intersections as locations:
    #myMap <- GetMap(path = paste0("&path=color:0x00000000|weight:5|fillcolor:0xFFFF0033|",
    #          "8th+Avenue+%26+34th+St,New+York,NY|8th+Avenue+%26+42nd+St,New+York,NY|",
    #          "Park+Ave+%26+42nd+St,New+York,NY,NY|Park+Ave+%26+34th+St,New+York,NY,NY"),
    #            destfile = "MyTile3a.png");
    
    #note that since the path string is just appended to the URL you can "abuse" the path 
    #argument to pass anything to the query, e.g. the style parameter:
    #The following example displays a map of Brooklyn where local roads have been changed 
    #to bright green and the residential areas have been changed to black:
    # myMap <- GetMap(center="Brooklyn", zoom=12, maptype = "roadmap", 
    #path = paste0("&style=feature:road.local|element:geometry|hue:0x00ff00|",
    #        "saturation:100&style=feature:landscape|element:geometry|lightness:-100"),
    #        sensor='false', destfile = "MyTile4.png",  RETURNIMAGE = FALSE);
    
    #In the last example we set RETURNIMAGE to FALSE which is a useful feature in general
    #if png is not installed. In that cases, the images can still be fetched 
    #and saved but not read into R.
    
    #In the following example we let the Static Maps API determine the correct center and 
    #zoom level implicitly, based on evaluation of the position of the markers. 
    #However, to be of use within R we do need to know the values for zoom and 
    #center explicitly, so it is better practice to compute them ourselves and 
    #pass them as arguments, in which case meta information on the map tile can be saved as well.
    
    #myMap <- GetMap(markers = paste0("&markers=color:blue|label:S|40.702147,-74.015794&",
    #          "markers=color:green|label:G|40.711614,-74.012318&markers=color:red|",
    #          "color:red|label:C|40.718217,-73.998284"), 
    #           destfile = "MyTile1.png",  RETURNIMAGE = FALSE);
  }
})

`XY2LatLon` <-structure(function#computes the centered coordinate transformation from lat/lon to map tile coordinates 
###The function XY2LatLon(MyMap, X,Y,zoom) computes the coordinate transformation from map tile coordinates to lat/lon given a map object.
(
  MyMap, ##<< map object
  X, ##<< latitude values to transform
  Y, ##<< longitude values to transform
  zoom ##<< optional zoom level. If missing, taken from \code{MyMap}
){
#X and Y are the centered integer pixel values, i.e. they should be zero in the center of the matrix/image !
  if (!missing(MyMap)){
     lat.center <- MyMap[[1]];
     lon.center <- MyMap[[2]];
     if (missing(zoom)) zoom <- MyMap[[3]];
        
     mycenter <- LatLon2XY(lat.center,lon.center,zoom);
     
     #first transform to original x,y coordinates
     x <- mycenter$Tile[,"X"] + (X+mycenter$Coords[,"x"])/256;
     y <- mycenter$Tile[,"Y"] - (Y-mycenter$Coords[,"y"])/256;
   } else {
     x = X
     y = Y
   }
   ytilde <- 1 - y/2^(zoom-1);
   yy = (exp(2*pi* ytilde) - 1)/(exp(2*pi* ytilde) + 1);
   ShiftLat <- function(yy){
   	 n = c(-1,0,1);
     #print(180*asin( yy )/pi)
     #lat = 2*pi*(n+1) - asin( yy ) ; 
     lat = 2*pi*(n) + asin( yy ) ; 
     lat <- lat[which(lat <= pi/2 & lat > -pi/2 )];
     #convert back to degrees: 
     lat <- 180 * lat/ pi;
     return(lat);
   }
   lat <- sapply(yy, ShiftLat);
   #longitude is easy:
   lon =  180*( x/2^(zoom-1) - 1 );
##seealso<< \link{LatLon2XY} \link{Tile2R}

   return(cbind(lat=lat, lon=lon));
### properly scaled and centered (with respect to the center of \code{MyMap} ) coordinates  
###  \item{lon }{longitude}
###  \item{lat }{latitude}
}, ex = function(){
#quick test:

  zoom=12;MyMap <- list(40,-120,zoom, url="google", BBOX = list(ll=c(35,-125), ur=c(45,-115)));
  LatLon <- c(lat = 40.0123, lon = -120.0123);
  Rcoords <- LatLon2XY.centered(MyMap,LatLon["lat"],LatLon["lon"])
  newLatLon <- XY2LatLon(MyMap, Rcoords$newX, Rcoords$newY)
  max(abs(newLatLon - LatLon));

#more systematic:
 for (zoom in 2:10){
   cat("zoom: ", zoom, "\n");
   MyMap <- list(40,-120,zoom, url="google", BBOX = list(ll=c(35,-125), ur=c(45,-115)));
   LatLon <- c(lat = runif(1,-80,80), lon = runif(1,-170,170));
   Rcoords <- LatLon2XY.centered(MyMap,LatLon["lat"],LatLon["lon"])
   newLatLon <- XY2LatLon(MyMap, Rcoords$newX, Rcoords$newY)
   if(max(abs(newLatLon - LatLon)) > 0.0001) print(rbind(LatLon, newLatLon));
 }

})

`GetBingMap` <- structure(function# download a static map from the Microsoft map tile server
### Query the Google server for a static map tile, defined primarily by its 
### center and zoom. Many additional arguments allow the user to customize 
### the map tile.
(
  center=c(lat=42, lon=-76), ##<< optional center (lat first,lon second  )
  mapArea=c(45.219,-122.325,47.610,-122.107), ##<< A rectangular area specified as a bounding box (ll,ur). Required when a center point or set of route points are not specified
  size = c(640,640), ##<< desired size of the map tile image. defaults to maximum size returned by the Gogle server, which is 640x640 pixels 
  destfile, ##<<  File to load the map image from or save to, depending on \code{NEWMAP}.
  zoom =12, ##<< Google maps zoom level.
  markers,  ##<< (optional) defines one or more markers to attach to the image at specified locations. This parameter takes a string of marker definitions separated by the pipe character (|) 
  path="",  ##<< (optional) defines a single path of two or more connected points to overlay on the image at specified locations. This parameter takes a string of point definitions separated by the pipe character (|)
 
  # span, ##<< (optional) defines a minimum viewport for the map image expressed as a latitude and longitude pair. The static map service takes this value and produces a map of the proper zoom level to include the entire provided span value from the map`s center point. Note that the resulting map may include larger bounds for either latitude or longitude depending on the rectangular dimensions of the map. If zoom is specified, span is ignored 
#  frame, ##<< (optional) specifies that the resulting image should be framed with a colored blue border. The frame consists of a 5 pixel, 55 % opacity blue border. 
 # hl, ##<< (optional) defines the language to use for display of labels on map tiles. Note that this paramater is only supported for some country tiles; if the specific language requested is not supported for the tile set, then the default language for that tile set will be used.
#  sensor = "true",  ##<< specifies whether the application requesting the static map is using a sensor to determine the user`s location. This parameter is now required for all static map requests.
  maptype = c("Road","Aerial","AerialWithLabels")[1], ##<< defines the type of map to construct. See https://msdn.microsoft.com/en-us/library/ff701724.aspx
  format = c("png","gif","jpg","jpg-baseline","png8","png32")[1],  ##<< (optional) defines the format of the resulting image. By default, the Static Maps API creates GIF images. There are several possible formats including GIF, JPEG and PNG types. Which format you use depends on how you intend to present the image. JPEG typically provides greater compression, while GIF and PNG provide greater detail. This version supports only PNG.
  extraURL="", ##<< custom URL suffix
  RETURNIMAGE = TRUE, ##<< return image yes/no default: TRUE
  GRAYSCALE =FALSE, ##<< Boolean toggle; if TRUE the colored map tile is rendered into a black & white image, see \link{RGB2GRAY}
  NEWMAP = TRUE, ##<< if TRUE, query the Google server and save to \code{destfile}, if FALSE load from destfile. 
  SCALE = 1, ##<< use the API's scale parameter to return higher-resolution map images. The scale value is multiplied with the size to determine the actual output size of the image in pixels, without changing the coverage area of the map
  apiKey = NULL, ##<< optional API key (allows for higher rate of downloads)
  verbose=0 ##<< level of verbosity
){
  ##note<<Note that size is in order (lon, lat)
  if (!(maptype %in% c("Road","Aerial","AerialWithLabels"))) maptype="Road"
  
  if (missing(destfile)) destfile=file.path(tempdir(),"mapTile.png")
  if (is.character(center)) {
    if (verbose) cat("geocoding ", center, "\n")
    center = getGeoCode(center,verbose)
  }
  if (all(c("lat","lon") %in% names(center))) center = center[c("lat","lon")]
  ##seealso<< \link{GetMap.bbox}
  
#   if (is.null(names(center))) {
#     names(center) = c("lat", "lon");
#   } else stopifnot( all(names(center) %in% c("lat", "lon")) )
#   
  stopifnot(all(size <=640));
  
  fileBase <- substring(destfile,1, nchar(destfile)-4);
  fileExt <-  substring(destfile,nchar(destfile)-2,nchar(destfile));
  #save meta information about the image:    
  if (is.null(center)) {
    if (verbose) print("Note that when center and zoom are not specified, no meta information on the map tile can be stored. This basically means that R cannot compute proper coordinates. You can still download the map tile and view it in R but overlays are not possible.");
	  #ans <- readLines(n=1);
	  #if (ans != "y") return(); 
	  MetaInfo <- list(lat.center = NULL, lon.center  = NULL, zoom = zoom, 
	                   url = "bing", BBOX = NULL, size=size, SCALE = SCALE);
	  save(MetaInfo, file = paste(destfile,"rda",sep="."));
  } else if ( is.numeric(center) & !missing(zoom)) {  
      MyMap <- list(lat.center = center[1], lon.center  = center[2], zoom = zoom, SCALE = SCALE);
      BBOX <- list(ll = XY2LatLon(MyMap, -size[1]/2 + 0.5, -size[2]/2 - 0.5), ur = XY2LatLon(MyMap, size[1]/2 + 0.5, size[2]/2 - 0.5) );
	  MetaInfo <- list(lat.center = center[1], lon.center  = center[2], zoom = zoom, 
        url = "bing", BBOX = BBOX, size=size, SCALE = SCALE);
	  save(MetaInfo, file = paste(destfile,"rda",sep="."));
  } 
  
  if (length(size) < 2) {s <- paste(size,size,sep=",")} else {s <- paste(size,collapse=",");}
  if (!is.null(center)) center <- paste(center,collapse=",")
  # if (missing(format)){	
  #   if ( fileExt == "png") format <- "png32"
  # }
 
  bingURL = paste0("http://dev.virtualearth.net/REST/v1/Imagery/Map/",maptype, "/")
  #paste0(bingURL,"Road/47.619048,-122.35384/15?mapSize=640,640&key=",apiKey)
 
  #browser()
  # if (!missing(extraURL)) {
  #   url <- paste0(bingURL,extraURL,"&format=", format)
  # } else 
  if (is.null(center) & missing(zoom)) {#let the Static Maps API determine the correct center and zoom level implicitly, based on evaluation of the position of the markers:
		stopifnot(!missing(markers) | path != "");
		url <- paste0(bingURL,  "size=",  s, "&maptype=", maptype, "&format=", format)
	} else if (missing(mapArea)) {
		stopifnot(!is.null(center), !missing(zoom));
		url <- paste0(bingURL, center, "/", zoom,  "?mapSize=",  s, "&format=", format)
	} else if (!missing(mapArea)) {
	  latR=range(mapArea[c(1,3)])
	  lonR=range(mapArea[c(2,4)])
	  zoom <- min(MaxZoom(latR, lonR, size));
	  #if (missing(center)){
	    lat.center <- mean(latR);#latR[1] + diff(latR)/2;
	    lon.center <- mean(lonR);#lonR[1] + diff(lonR)/2;
	  #}
	  center = c(lat.center, lon.center)
	  BBOX = list(ll = mapArea[1:2], ur =mapArea[3:4])
	  names(BBOX$ll) = c("lat", "lon");names(BBOX$ur) = c("lat", "lon")
	  MetaInfo <- list(lat.center = center[1], lon.center  = center[2], zoom = zoom, 
	                   url = "bing", BBOX = BBOX, size=size, SCALE = SCALE);
	  save(MetaInfo, file = paste(destfile,"rda",sep="."));
	  
	  bingURL = paste0("http://dev.virtualearth.net/REST/v1/Imagery/Map/",maptype, "?mapArea=")
	  url <- paste0(bingURL, paste0(mapArea,collapse=","), "&mapSize=",  s, "&format=", format)
	}
	
	url <- paste(url, path, sep="");
	url <- paste(url, extraURL, sep="");
	
  #if (!missing(hl)) url <- paste0(url, "&language=",hl);
  #if (SCALE == 2) url <- paste(url, "&scale=", SCALE, sep="");
	
	if (!missing(markers)) {
		#assumes markers is a list with names lat, lon, size (optional), color (optional), char (optional)
		#if(is.data.frame(markers)) markers<-as.matrix(markers)
		if ( is.matrix(markers) | is.data.frame(markers)) {
		  stopifnot(all(c("lat","lon") %in% colnames(markers)))
		  latlon = which(colnames(markers) %in% c("lat","lon"))
		  for (i in 1:nrow(markers)){
		  	m1 <- paste(markers[i,c("lat","lon")], collapse=",");
		  	if (any(c("size","color","label") %in% colnames(markers) ) ) {
		  	  m2 <- paste(colnames(markers)[-latlon], markers[i,-latlon], collapse="|",sep=":");
		  	  m <- paste(m2,m1,sep="|")
		  	} else {
		  	  m <- m1
		  	}
		  	#m <- paste("&markers=",m,sep="")
		  	#print(m)
		  	if (i==1){ 
		  		markers.string <- paste0("&markers=",m);
			  } else { 
				  markers.string <- paste(markers.string,paste0("&markers=",m), sep=""); 
		    }
		    #if (verbose) print(markers.string);
		  }
		  #browser()
		  #markers.string <- paste("&markers=", markers.string,sep="")
		} else if (is.character(markers)) {#already in the correct string format:
		  markers.string <- markers;
		} 
		
		url <- paste0(url, markers.string);
    
	}
  #if (!is.null(API_console_key))  url <- paste0(url,"&key=", API_console_key);
	url <- paste0(url, "&key=", apiKey)
	
	if (verbose) print(url);
	if (verbose == -1) browser();
	if (verbose < 2 & NEWMAP) 
	  suppressWarnings(download.file(url, destfile, mode="wb", quiet = TRUE));
	
	if (GRAYSCALE) {
		myTile <- readPNG(destfile, native=FALSE);
		#browser()
		myTile <- RGB2GRAY(myTile);
      	writePNG(myTile, destfile)
	  }

	if (RETURNIMAGE){
 	  myMap <- ReadMapTile(destfile); 
  	  return(myMap);
 	}
 	
	invisible(url)
### map structure or URL used to download the tile.
}, ex = function(){
  
  if (0){
    #for bing maps you will need your own API key, 
    #sign up at https://msdn.microsoft.com/en-us/library/ff428642.aspx
    apiKey = scan("bingAPIkey.txt",what="")
    map1=GetBingMap(center=c(47.619048,-122.35384),zoom=15,apiKey=apiKey, 
                    verbose=1, destfile="Seattle.png") 
    PlotOnStaticMap(map1)
    m="&pp=47.620495,-122.34931;21;AA&pp=47.619385,-122.351485;;AB&pp=47.616295,-122.3556;22"
    map2=GetBingMap(center=c(47.619048,-122.35384),zoom=15,markers=m,apiKey=apiKey, 
                    verbose=1, destfile="Seattle2.png")
    
    PlotOnStaticMap(map2,lat=c(47.620495,47.619385,47.616295),
                    lon=c(-122.34931,-122.351485,-122.3556))
    	
    m="&pp=49.28273,-123.12074;22&pp=44.05207,-123.08675;22"
    
    map3= GetBingMap(center=c(47.677006,-122.125526),zoom=6,markers=m,apiKey=apiKey,
                     verbose=1, destfile="Seattle2.png")
    #plotmap(map=map3)
    m=cbind.data.frame(lat=c(49.28273,44.05207),lon=c(-123.12074,-123.08675),col=c(3:4))
    PlotOnStaticMap(map3, lat =m$lat,lon=m$lon,col=m$col,pch=19)
    
    #overlay traffic:
    #Get a map with Road imagery and traffic flow based on a query.
    #This example gets a map with road imagery based on a query result Bellevue, Washington. 
    #Traffic flow is also included on the map.
    
    #http://dev.virtualearth.net/REST/V1/Imagery/Map/Road/Bellevue%20Washington
    #?mapLayer=TrafficFlow&key=BingMapsKey
    #note that we are using the extraURL argument to pass any extra parameters:
    map4 = GetBingMap(center="Bellevue%20Washington", zoom=12, extraURL="&mapLayer=TrafficFlow", 
                      apiKey=apiKey,verbose=1, destfile="BellevueTraffic.png")
    PlotOnStaticMap(map4)
    
    #Get a map with Road imagery that displays a route.
    #This example gets a map with road imagery that displays a driving 
    #route between the cities of Seattle and Redmond in Washington State. 
    
    #note that we are using the extraURL argument to pass any extra parameters:
    #http://dev.virtualearth.net/REST/v1/Imagery/Map/Road/Routes
    #?wp.0=Seattle,WA;64;1&wp.1=Redmond,WA;66;2&key=BingMapsKey 
    map5 = GetBingMap(center="Bellevue%20Washington", zoom=8, 
                      extraURL="&Routes?wp.0=Seattle,WA;64;1&wp.1=Redmond,WA;66;2", 
                    apiKey=apiKey,verbose=1, destfile="Seattle2Redmond.png")
    PlotOnStaticMap(map5)
  }
})

# tile2long = function(x,z){ return (x/(2^z)*360-180); }
# tile2lat= function(y,z) { n=pi-2*pi*y/(2^z);
#                           return (180/pi*atan(0.5*(exp(n)-exp(-n)))); }


`GetMapTiles` <- structure(function# download map tiles from specified map tile servers such as openstreetmap or Google
### Query the server for map tiles, defined uniquely by their 
### X and Y ID and zoom. For offline usage, these map tiles are stored in a local directory
### Example OSM:http://a.tile.openstreetmap.org/10/549/335.png
### Also see https://wiki.openstreetmap.org/wiki/Tile_servers
### Example Google mobile: http://mt1.google.com/vt/lyrs=m&x=1325&y=3143&z=13
### Example Google satellite: http://mt1.google.com/vt/lyrs=s&x=1325&y=3143&z=13

(
  center=c(lat=52.431635, lon=13.194773), ##<< optional center (lat first,lon second  )
  lonR, ##<< longitude range
  latR, ##<< latitude range
  nTiles = c(3,3), ##<< number of tiles in x and y direction
  #size = c(640,640), ##<< desired size of the map tile image. defaults to maximum size returned by the Gogle server, which is 640x640 pixels 
  # taskfile = "Zehlendorf", ##<<  File to save the meta information to.
  zoom =13, ##<< Google maps zoom level.
  # maptype = c("roadmap","mobile","satellite","terrain","hybrid","mapmaker-roadmap","mapmaker-hybrid")[1], ##<< defines the type of map to construct. There are several possible maptype values, including satellite, terrain, hybrid, and mobile. 
  type = c("google", "google-m","google-s","osm", "osm-hot", "stamen-toner", "stamen-terrain", "stamen-watercolor")[1],  ##<< choice of tile server
  urlBase = "http://mt1.google.com/vt/lyrs=m" , ##<< tileserver URL, alternatives would be "http://a.tile.openstreetmap.org/", "http://tile.stamen.com/toner/","http://tile.stamen.com/watercolor/"
  tileDir= "/tmp/", ##<< map tiles can be stored in a local directory, e.g. "~/mapTiles/Google/"
  CheckExistingFiles = TRUE, ##<< logical, if TRUE check if files already exist and only download if not!
  TotalSleep = NULL, ##<< overall time (in seconds) that one is willing to add in between downloads. This is intended to lower the risk of a server denial. If NULL no call to \link{Sys.sleep} is executed
  #format = c("gif","jpg","jpg-baseline","png8","png32")[5],  ##<< (optional) defines the format of the resulting image. By default, the Static Maps API creates GIF images. There are several possible formats including GIF, JPEG and PNG types. Which format you use depends on how you intend to present the image. JPEG typically provides greater compression, while GIF and PNG provide greater detail. This version supports only PNG.
  #RETURNIMAGE = TRUE, ##<< return image yes/no default: TRUE
  #GRAYSCALE =FALSE, ##<< Boolean toggle; if TRUE the colored map tile is rendered into a black & white image, see \link{RGB2GRAY}
  #NEWMAP = TRUE, ##<< if TRUE, query the Google server and save to \code{destfile}, if FALSE load from destfile. 
  #SCALE = 1, ##<< use the API's scale parameter to return higher-resolution map images. The scale value is multiplied with the size to determine the actual output size of the image in pixels, without changing the coverage area of the map
  tileExt = ".png", ##<< image type of tile
  returnTiles = TRUE, ##<< return tiles in a list?
  verbose=0 ##<< level of verbosity
){
  ##note<<Note that size is in order (lon, lat)
  #if (missing(destfile)) destfile=file.path(tempdir(),"mapTile.png")
  #require(RgoogleMaps)
  
  type = switch(type,
         "google" = "google-m",
         "stamen" = "stamen-toner",
         type
  )
  tileservers = c("osm"= "http://a.tile.openstreetmap.org/",
                  "osm-hot"= "http://a.tile.openstreetmap.fr/hot/",
                  "google-m" = "http://mt1.google.com/vt/lyrs=m",
                  "google-s" = "http://mt1.google.com/vt/lyrs=s",
                  "stamen-toner" = "http://tile.stamen.com/toner/",
                  "stamen-watercolor" ="http://tile.stamen.com/watercolor/",
                  "stamen-terrain" = "http://tile.stamen.com/terrain/",
                  "osm-public-transport"= "http://tile.memomaps.de/tilegen/"
                  )
  
  if (type %in% names(tileservers)) urlBase=tileservers[type]
  
  if (verbose) cat("tileserver:", urlBase, "\n")
  
  if (is.character(center)) {
    if (verbose) cat("geocoding ", center, "\n")
    center = getGeoCode(center,verbose)
    if (verbose) cat("result:", center, "\n")
  }
  if (all(c("lat","lon") %in% names(center))) center = center[c("lat","lon")] else names(center) = c("lat","lon")
  ##seealso<< \link{GetMap.bbox}
  #turn out we do NOT HAVE TO cap the zoom to a fake 13 after all !!
  # We can truthfully record the correct zoom level, YES
  fakeZoom = zoom#min(zoom,13)
  #if (!is.null(center)) center <- paste(center,collapse=",")
  if (!missing(lonR) & !missing(latR)) {
    XYmin = LatLon2XY(lat=latR[1], lon=lonR[1],zoom=zoom)
    XYmax = LatLon2XY(lat=latR[2], lon=lonR[2],zoom=zoom)
    nTiles[1] = abs(XYmax$Tile[1,1]-XYmin$Tile[1,1])+1
    nTiles[2] = abs(XYmax$Tile[1,2]-XYmin$Tile[1,2])+1
    #browser()
    #if (missing(center) | is.null(center)) 
    center = c(lat=mean(latR),lon=mean(lonR))  
    if (verbose){
      cat("nTiles=",nTiles,", center=", round(center,3), "\n")
    }
  } #else {
    XY = LatLon2XY(lat=center["lat"], lon=center["lon"],zoom=zoom)
    tileXY = XY$Tile + as.numeric(XY$Coords > 256)
  #}
  if (nTiles[1] %% 2 == 0) {#even
    X = (tileXY[1,1]-nTiles[1]/2):(tileXY[1,1]+nTiles[1]/2-1);
  } else {
    X = (tileXY[1,1]-(nTiles[1]-1)/2):(tileXY[1,1]+(nTiles[1]-1)/2);
  }
  if (nTiles[2] %% 2 == 0) {#even
    Y = (tileXY[1,2]-nTiles[2]/2):(tileXY[1,2]+nTiles[2]/2-1);
  } else {
    Y = (tileXY[1,2]-(nTiles[2]-1)/2):(tileXY[1,2]+(nTiles[2]-1)/2);
  }
  
  if (verbose>1) browser() 
  if (isTRUE(tileDir)) tileDir = paste0("~/mapTiles/",type,"/")
    
  if (!is.null(tileDir)) {
    if (!dir.exists(tileDir)) {
      if (verbose) cat("trying to create dir",tileDir, "\n")
      dir.create(tileDir, recursive = TRUE)
    }
    if (CheckExistingFiles) ExistingFiles=list.files(path=tileDir)
  }
  NumTiles = length(X)*length(Y)
  if (verbose) cat (NumTiles, "tiles to download \n")
    
  #http://a.tile.openstreetmap.org/15/9647/12321.png
  DOWNLOAD=TRUE;sleptTotal=0
  
  if (grepl("watercolor",urlBase) | grepl("terrain",urlBase) | grepl("lyrs=s|lyrs=y",urlBase)){
    tileExt = ".jpg"
  }
  if (verbose) cat("tile image format:", tileExt, "\n")
    
  k=1;tiles=list()
  for (x in X){
    for (y in Y){
      if (grepl("openstreetmap|stamen",urlBase) | grepl("osm",type)){
        if (grepl("watercolor",urlBase) | grepl("terrain",urlBase)){
          tileExt = ".jpg"
          url <- paste0(urlBase, zoom, "/",x , "/", y, ".jpg")#not necessary as the stamenWeb server automatically converts the png request to jpg
        } else {
          url <- paste0(urlBase, zoom, "/",x , "/", y, ".png")
        }
        
      } else if (grepl("google",urlBase)){
        url <- paste0(urlBase, "&x=", x, "&y=", y, "&z=", zoom)
        if (grepl("lyrs=s|lyrs=y",urlBase)) tileExt = ".jpg" #satellite or hybrid
      } 
      
		  #browser()
      #print(url)
      # we need to keep the x and y coords to 4 digits!
      #xFake = x
      #yFake = y
      f=paste(zoom, x, y, sep="_")
		  if (CheckExistingFiles) 
        if (paste0(f,tileExt) %in% ExistingFiles) {
          if (verbose) cat("NOT downloading existing file ",f, tileExt, "\n",sep="" )
          DOWNLOAD=FALSE
        } else {
          DOWNLOAD=TRUE
        }
      destfile = file.path(tileDir, f)
      mapFile=paste0(destfile,tileExt)
      if (DOWNLOAD){
  		  if (!is.null(TotalSleep)){
  		    sleep_a_bit = round(runif(1,max=2*TotalSleep/NumTiles),1)
  		    Sys.sleep(sleep_a_bit)
  		    sleptTotal= sleptTotal+sleep_a_bit
  		  }
        res=try(download.file(url, mapFile, mode="wb", quiet = TRUE));
        if (inherits(res,"try-error")){
          tmp=RCurl::getBinaryURL(url)
          if (tileExt == ".png") png::writePNG(tmp, mapFile)
        }
      }
      
      if (tileExt == ".jpg") {
        readImg = jpeg::readJPEG
      } else if (tileExt == ".png")  {
        readImg = png::readPNG
      }
      if (returnTiles){
        res=try(readImg(mapFile, native=TRUE))
        if (inherits(res,"try-error")){#download again
          download.file(url, mapFile, mode="wb", quiet = TRUE);
        } else tiles[[k]]=res
        
      } 
      #browser()
		  k=k+1
    }
  }
  if (verbose) cat("sleptTotal=",sleptTotal, "\n")
  mt = list(X=X,Y=Y,zoom=zoom,tileDir=tileDir,tileExt=tileExt,type=type, tiles=tiles)
  class(mt) =  "mapTiles"
  invisible(mt)	
### list with important information
}, ex = function(){
  if (0){
    
    #OSM, Ireland
    xlim = c(-7, -3.5) 
    ylim = c(51.35, 55.35)
    Dublin = c(lon=-6.266155,lat=53.350140)
    DublinMerc = geosphere_mercator(Dublin)
    
    ir.osm <- GetMapTiles(lonR=xlim, latR=ylim, zoom=7, verbose=1,
                          type = "osm", tileDir= TRUE)
    map = plotOSM(ir.osm)
    par("usr")#A vector of the form c(x1, x2, y1, y2)
    points(map$bbox$upperLeft,col=2,pch=20)
    points(map$bbox$lowerRight,col=2,pch=20)
    
    points(DublinMerc, col =2, pch=1,cex=1.5)
    
    ir.stamenToner <- GetMapTiles(lonR=xlim, latR=ylim, zoom=7,verbose=0,
                                  type = "stamen", tileDir= TRUE)
    plotOSM(ir.stamenToner)
    
    ir.stamenWater <- GetMapTiles(lonR=xlim, latR=ylim, zoom=7, verbose=1,
                                  type = "stamen-watercolor", tileDir= TRUE)
    plotOSM(ir.stamenWater)
   
    
    #############################################
    zoom=5
    nTiles = prod(NumTiles(lonR=c(-135,-66), latR=c(25,54) , zoom=zoom))
    us_google_5 = GetMapTiles(lonR=c(-135,-66), latR=c(25,54) , zoom=zoom, TotalSleep = 2*nTiles,
                type = "google", tileDir= TRUE, verbose = TRUE)
    
    PlotOnMapTiles(us_google_5)
    wtc_ll = getGeoCode("World Trade Center, NY")
    wtc_google_15=GetMapTiles(wtc_ll, zoom=15,nTiles = c(3,3), type = "google", 
                              tileDir= TRUE, verbose = 1)
    PlotOnMapTiles(wtc_google_15)
    wtc_google_16 =GetMapTiles(wtc_ll, zoom=16,nTiles = c(4,4), type = "google", 
                               tileDir= TRUE, verbose=1)
    PlotOnMapTiles(wtc_google_16)

  
    wtc_stamen=GetMapTiles(wtc_ll, zoom=15,nTiles = c(3,3), verbose=1,
                    type = "stamen-toner", tileDir= TRUE)
    PlotOnMapTiles(wtc_stamen)
  

  
  ###combine with leaflet:
  #From:http://stackoverflow.com/questions/5050851/
  #     best-lightweight-web-server-only-static-content-for-windows
  #To use Python as a simple web server just change your working 
  #directory to the folder with your static content and type 
  #python -m SimpleHTTPServer 8000, everything in the directory
  #will be available at http:/localhost:8000/
    
  library(leaflet)
  m = leaflet::leaflet() %>% 
    addTiles( urlTemplate = "http:/localhost:8000/mapTiles/OSM/{z}_{x}_{y}.png")
  m = leaflet::leaflet() %>% 
    addTiles( urlTemplate = "http:/localhost:8000/mapTiles/Google/{z}_{x}_{y}.png")
  m = m %>% leaflet::setView(-74.01312, 40.71180, zoom = 16)
  m = m %>% leaflet::addMarkers(-74.01312, 40.71180)
  
  #Quadriga:
  m = m %>% leaflet::setView(13.39780, 52.51534, zoom = 16)
  m = m %>% leaflet::addMarkers(13.39780, 52.51534)
  }
  
}) 

`GetOsmMap` <- structure(function#Query the Open Street Map server for map tiles instead of Google Maps
### The querying parameters for Open Street Maps are somewhat different in this version. 
### Instead of a zoom, center and size, the user supplies a scale parameter and a lat/lon bounding box. 
### The scale determines the image size.
(
  lonR=c(-74.02132,-73.98622), ##<< longitude range
  latR= c(40.69983,40.72595), ##<< latitude range
  scale= 20000, ##<< Open Street map scale parameter. The larger this value, the smaller the resulting map tile in memory. There is a balance to be struck between the lat/lon bounding box and the scale parameter.
  destfile = "MyTile.png", ##<<  File to load the map image from or save to, depending on \code{NEWMAP}.
  format = 'png', ##<< (optional) defines the format of the resulting image.
  RETURNIMAGE = TRUE, ##<< return image yes/no default: TRUE
  GRAYSCALE =FALSE, ##<< Boolean toggle; if TRUE the colored map tile is rendered into a black & white image, see \link{RGB2GRAY}
  NEWMAP = TRUE, ##<< if TRUE, query the Google server and save to \code{destfile}, if FALSE load from destfile.
  verbose=1, ##<< level of verbosity,
  ... ##<< extra arguments to be used in future versions
){
   ##note<<The OSM maptile server is frequently too busy to accomodate every request, so patience is warranted.
 	 options(scipen = 12);#to suppress scientific notation on the scale parameter
 	 
 	OSMbbox <- paste(lonR[1],latR[1],lonR[2],latR[2], sep=",")
 	#http://tile.openstreetmap.org/cgi-bin/export?bbox=-4.54,47.49,4.37,52.45&scale=14000000&format=png
    OSMurl <- 'http://tile.openstreetmap.org/cgi-bin/export?';
 	url <- paste(OSMurl, "bbox=", OSMbbox, "&scale=", scale, "&format=", format, sep="")
 	#OR, use zoom level (e.g. z=12 ):
 	# http://tah.openstreetmap.org/MapOf/index.php?long=-74.02132&lat=40.69983&z=12&w=256&h=256&format=png

 	if (verbose) print(url);
 	    
 	if (NEWMAP) ret <- download.file(url, destfile, mode="wb", quiet = FALSE);
    #BBOX <- list(ll = c(lonR[1], latR[1]), ur = c(lonR[2], latR[2]) );
    #thanks to Julien Barnier who corrected this bug:
    BBOX <- list(ll = c(latR[1], lonR[1]), ur = c(latR[2], lonR[2]))
	MetaInfo <- list(lat.center = mean(latR), lon.center  = mean(lonR), zoom = NULL, url = "OSM", BBOX = BBOX, scale=scale, SCALE = 1);
	save(MetaInfo, file = paste(destfile,"rda",sep="."));
 	if (verbose == -1) browser();

 	if (RETURNIMAGE){
 	  myMap <- ReadMapTile(destfile);
 	  if (GRAYSCALE) {
     	     myMap$myTile <- RGB2GRAY(myMap$myTile);
        }
	  return(myMap);	    
 	} else {
	  invisible(url)
	}
### map structure or URL used to download the tile.
 }, ex = function(){
if (0) {
 	CologneMap <- GetOsmMap(lonR= c(6.89, 7.09), latR = c(50.87, 51), scale = 150000, 
                            destfile = "Cologne.png");
	PlotOnStaticMap(CologneMap, mar=rep(4,4), NEWMAP = FALSE, TrueProj = FALSE, axes= TRUE);
		
	PrincetonMap <- GetOsmMap(lonR= c(-74.67102, -74.63943), latR = c(40.33804,40.3556), 
                             scale = 12500, destfile = "Princeton.png");
	png("PrincetonWithAxes.png", 1004, 732)
      PlotOnStaticMap(PrincetonMap, axes = TRUE, mar = rep(4,4));
    dev.off()
 }
})

`PlotPolysOnStaticMap` <-structure(function#plots polygons on map
###This function plots/overlays polygons on a map. Typically, the polygons originate from a shapefile.
(
  MyMap, ##<< map image returned from e.g. \code{GetMap()}
  polys, ##<<  polygons to overlay; these can be either of class \link[PBSmapping]{PolySet} from the package PBSmapping
### or of class \link[sp]{SpatialPolygons} from the package sp
  col, ##<< (optional) vector of colors, one for each polygon
  border = NULL, ##<< the color to draw the border. The default, NULL, means to use \link{par}("fg"). Use border = NA to omit borders, see \link{polygon}
  lwd = .25, ##<< line width, see \link{par}
  verbose = 0, ##<< level of verbosity 
  add=TRUE, ##<< start a new plot or add to an existing 
  textInPolys = NULL, ##<< text to be displayed inside polygons.
  ... ##<< further arguments passed to \code{PlotOnStaticMap}
){
  ##seealso<< \link{PlotOnStaticMap} \link{mypolygon}
  ##details<< 
  #print(str(polys))
  stopifnot(class(polys)[1] == "SpatialPolygons" | class(polys)[1] == "PolySet" | class(polys)[1] == "data.frame" | class(polys)[1] == "matrix")
  if (class(polys)[1] == "SpatialPolygons")
    polys = SpatialToPBS(polys)$xy
  
  Rcoords <- LatLon2XY.centered(MyMap,lat= polys[,"Y"],lon= polys[,"X"]);
  polys.XY <- as.data.frame(polys);
  polys.XY[,"X"] <- Rcoords$newX;
  polys.XY[,"Y"] <- Rcoords$newY;
  
  if ( !( "PID" %in% colnames(polys.XY)) ) 
     polys.XY[,"PID"] <- 1;
  if ( !( "SID" %in% colnames(polys.XY)) ) 
     polys.XY[,"SID"] <- 1;
  polys.XY[,"PIDSID"] <- apply(polys.XY[,c("PID","SID")],1,paste,collapse=":")
  if (!add) tmp <- PlotOnStaticMap(MyMap, verbose=0, ...)
  if (verbose>1) browser()
  #browser()
  if (!is.null(textInPolys)) Centers = PBSmapping::calcCentroid(polys.XY)
if (requireNamespace("PBSmapping", quietly = TRUE) & all(c("PID","X","Y","POS") %in% colnames(polys.XY)) ) {
	attr(polys.XY, "projection") <- NULL;
	usr <- par('usr')
	PBSmapping::addPolys(polys.XY,col=col, border = border, lwd = lwd, xlim =usr[1:2], ylim = usr[3:4],  ...)
	if (!is.null(textInPolys)) {
	  text(Centers[,"X"],Centers[,"Y"],textInPolys,cex=0.75, col = "blue")
	}
} else {
  if (!missing(col)) {
  	polys.XY[,"col"] <- col;
  	PIDtable <- as.numeric(table(polys.XY[,"PID"]));
  	SIDtable <- as.numeric(table(polys.XY[,"PIDSID"]))
  	if (length(SIDtable)==length(col))  polys.XY[,"col"] <- rep(col, SIDtable);
  	if (length(PIDtable)==length(col))  polys.XY[,"col"] <- rep(col, PIDtable);
  }
 
  if ( !( "col" %in% colnames(polys.XY)) )
     polys.XY[,"col"] <- rgb(.1,.1,.1,.05);
    #polys.XY[polys.XY[,"PID"] == 292,"col"] <- rgb(1,0,0,.75)
  #tmp <- by(polys.XY[,c("X","Y","col")], polys.XY[,"PID"], mypolygon, lwd = lwd, border = border);
  #if (0){
  	pids = unique(polys.XY[,"PIDSID"])
    
  	for (i in pids){
  	  jj = 	polys.XY[,"PIDSID"] == i;
  	  xx= polys.XY[jj,];
  	  if ( ( "POS" %in% colnames(xx)) ) xx <- xx[order(xx[,"POS"]),]
  	  polygon( xx[, c("X","Y")], col=xx[,"col"]);
  	  if (!is.null(textInPolys)) {
  	    text(Centers[i,"X"],Centers[i,"Y"],textInPolys[i], col = "blue")
  	  }
  	  #readLines(n=1)
  	}
  #}
  }
}, ex = function(){
if (0){
  #require(PBSmapping);
  shpFile <- paste(system.file(package = "RgoogleMaps"), "/shapes/bg11_d00.shp", sep = "")
  #shpFile <- system.file('bg11_d00.shp', package = "RgoogleMaps");
  
  shp=PBSmapping::importShapefile(shpFile,projection="LL");
  bb <- qbbox(lat = shp[,"Y"], lon = shp[,"X"]);
  MyMap <- GetMap.bbox(bb$lonR, bb$latR, destfile = "DC.png");
  PlotPolysOnStaticMap(MyMap, shp, lwd=.5, col = rgb(0.25,0.25,0.25,0.025), add = F);
  
  #Try an open street map:

  mapOSM <- GetMap.bbox(bb$lonR, bb$latR, destfile = "DC.png", type="osm");
  PlotPolysOnStaticMap(mapOSM, shp, lwd=.5, col = rgb(0.75,0.25,0.25,0.15), add = F);

  #North Carolina SIDS data set:
  shpFile <- system.file("shapes/sids.shp", package="rgooglemaps");
  shp=PBSmapping::importShapefile(shpFile,projection="LL");
  bb <- qbbox(lat = shp[,"Y"], lon = shp[,"X"]);
  MyMap <- GetMap.bbox(bb$lonR, bb$latR, destfile = "SIDS.png");
  #compute regularized SID rate
  sid <- 100*attr(shp, "PolyData")$SID74/(attr(shp, "PolyData")$BIR74+500)
  b <- as.integer(cut(sid, quantile(sid, seq(0,1,length=8)) ));
  b[is.na(b)] <- 1;
  opal <- col2rgb(grey.colors(7), alpha=TRUE)/255; opal["alpha",] <- 0.2;
  shp[,"col"] <- rgb(0.1,0.1,0.1,0.2);
  for (i in 1:length(b)) 
    shp[shp[,"PID"] == i,"col"] <- rgb(opal[1,b[i]],opal[2,b[i]],opal[3,b[i]],opal[4,b[i]]);
  PlotPolysOnStaticMap(MyMap, shp, lwd=.5, col = shp[,"col"], add = F);
  
  
  #or choose an aspect ratio that corresponds better to North Carolina's elongated shape:
  MyMap <- GetMap.bbox(bb$lonR, bb$latR, destfile = "SIDS.png", size = c(640, 320), zoom = 7);
  PlotPolysOnStaticMap(MyMap, shp, lwd=.5, col = shp[,"col"], add = F);
 }
})

`MaxZoom` <-structure(function#computes the maximum zoom level which will contain the given lat/lon range
### computes the maximum zoom level which will contain the given lat/lon range
(
  latrange, ##<< range of latitude values
  lonrange, ##<< range of longitude values
  size = c(640,640) ##<< desired size of the map tile image. defaults to maximum size returned by the Gogle server, which is 640x640 pixels
){
   SinPhi = sin(latrange * pi /180);
   normX = lonrange / 180;
   normY = (0.5 * log(abs((1 + SinPhi) / (1 -SinPhi) )) ) / pi;
   
   MaxZoom.lon <- floor(1 + log2(abs(size[1]/256/diff(normX))));
   MaxZoom.lat <- floor(1 + log2(abs(size[2]/256/diff(normY))));
   
   return(min(c(MaxZoom.lat=MaxZoom.lat,MaxZoom.lon=MaxZoom.lon)))
### zoom level
 })

`qbbox` <-structure(function#computes bounding box
### The function qbbox computes a bounding box for the given lat,lon 
### points with a few additional options such as quantile boxes, additional margins, etc.
(
  lat, ##<<  latitude values
  lon, ##<<  longitude values
  TYPE = c("all", "quantile")[1], ##<< 
  margin = list(m=c(1,1,1,1), TYPE = c("perc", "abs")[1]), ##<< relative or absolute margin around the data. Set to NULL if no margin desired.
  q.lat = c(0.1,0.9), ##<< latitude quantile trimming, the tails will be trimmed from the bounding box
  q.lon = c(0.1,0.9), ##<< longitude quantile trimming,
  verbose=0 ##<<
){
 	if (TYPE == "all"){
 	  latR <- range(lat,na.rm=TRUE);
   	  lonR <- range(lon,na.rm=TRUE)
 	} else if (TYPE == "quantile"){
 	  latR <- quantile(lat, q.lat, na.rm=TRUE);
      lonR <- quantile(lon, q.lon, na.rm=TRUE);
 	}
 	if (!is.null(margin)){
 	  m <- margin$m;
 	  lat.center <- latR[1] + diff(latR)/2;
      lon.center <- lonR[1] + diff(lonR)/2;
      if (margin$TYPE == "perc"){
      	dlon <- c(-1,1)*(1+m[c(2,4)]/100)*diff(lonR)/2;
      	dlat <- c(-1,1)*(1+m[c(1,3)]/100)*diff(latR)/2;
      } else if (margin$TYPE == "abs"){
      	dlon <- c(-1,1)*(m[c(2,4)] + diff(lonR)/2);
      	dlat <- c(-1,1)*(m[c(1,3)] + diff(latR)/2);
      }
      lonR.margin <- lon.center + dlon;
      latR.margin <- lat.center + dlat;
      if (verbose>1) {
      	cat("old/new lon range:");print(lonR);print(lonR.margin);
      	cat("old/new lat range:");print(latR);print(latR.margin);
      }
      return(list(latR=latR.margin, lonR=lonR.margin))
 	}
 		
 	return(list(latR=latR, lonR=lonR))
### \item{latR }{latitude range}
###  \item{lonR }{longitude range}
 
 }, ex = function(){
  lat = 37.85 + rnorm(100, sd=0.001);
  lon = -120.47 + rnorm(100, sd=0.001);
  #add a few outliers:
  lat[1:5] <- lat[1:5] + rnorm(5, sd =.01);
  lon[1:5] <- lon[1:5] + rnorm(5, sd =.01);
  
  #range, discarding the upper and lower 10% of the data
  qbbox(lat, lon, TYPE = "quantile");
  #full range:
  qbbox(lat, lon, TYPE = "all");
  #add a 10% extra margin on all four sides:
  qbbox(lat, lon, margin = list(m = c(10, 10, 10, 10), TYPE = c("perc", "abs")[1]));
 
})

`Tile2R` <-structure(function#simple utility to offset and scale XY coordinates with respect to the center
### simple utility to offset and scale XY coordinates with respect to the center
(
  points, ##<< XY coordinates returned by e.g. \link{LatLon2XY}
  center  ##<<  XY coordinates of center returned by e.g. \link{LatLon2XY}
){
##details<< mainly used for shrinking the size of a tile to the minimum size.

  X <- 256* (points$Tile[,"X"] - center$Tile[,"X"]) + (points$Coords[,"x"] - center$Coords[,"x"]) ;
  Y <- -256*(points$Tile[,"Y"] - center$Tile[,"Y"]) - (points$Coords[,"y"] - center$Coords[,"y"]) ;
  return(list(X=X,Y=Y))
### list with X and Y pixel values
}, ex = function(){
 latR <- c(34.5,34.9);
  lonR <- c(-100.3, -100);
  lat.center <- 34.7;
  lon.center <- -100.2;
  zoom = 10;
  ll <- LatLon2XY(latR[1], lonR[1], zoom);#lower left corner
  ur <- LatLon2XY(latR[2], lonR[2], zoom );#upper right corner
  cr <- LatLon2XY(lat.center, lon.center, zoom );#center
  ll.Rcoords <- Tile2R(ll, cr);
  ur.Rcoords <- Tile2R(ur, cr);

})

`plotmap` <-structure(function# easy to use wrapper function
###note the similarity in name to PBSmapping::plotMap
###This function is the workhorse of the package RgoogleMaps. It overlays plot on background image of map tile.

(
  lat, ##<< latitude values to be overlaid OR string to be geocoded OR named vector (lat,lon)!
  lon, ##<< longitude values to be overlaid
  map, ##<< optional map object 
  zoom = NULL, ##<< Google maps zoom level
  API = c("google","OSM","bing", "google2")[1], ##<< choice  of map tile API
  maptype = c("roadmap","mobile","satellite","terrain","hybrid","mapmaker-roadmap","mapmaker-hybrid")[2], ##<< defines the type of map to construct. There are several possible maptype values, including satellite, terrain, hybrid, and mobile. 
  destfile, ##<<  File to save the map image to
  data, ##<< data to look up variables in
  alpha = 1, ##<< opacity
  col = 1, ##<< plot color
  apiKey = NULL, ##<< optional API key (allows for higher rate of downloads for Google); mandatory for Bing maps
  verbose = 0, ##<< level of verbosity 
  ... ##<< further arguments to be passed to \code{PlotOnStaticMap}
){
  
  # argnames <- names(as.list(match.call(expand.dots = FALSE)[-1]))
  # arguments <- as.list(match.call()[-1])
  # env <- parent.frame()
  # args <- as.list(match.call(expand.dots = TRUE)[-1])
  # argsgiven <- names(args)
  #browser()
  # 
  # if ("col" %in% argsgiven) 
  #   col <- eval(args$col)
  
  
  if (!missing(data)) {
    lon = data[, deparse(substitute(lon))]
    lat = data[, deparse(substitute(lat))]
    #for (v in 1:length(data)) assign(names(data)[v], data[[v]])
    # browser()
    # lat=with(incidents,lat)
    # lon=with(incidents,lon)
    #col=with(incidents,col)
    if (is.character(col)) col=data[,col]
    #
    #attach(data, -1, warn.conflicts = FALSE) # bad idea!
  }
  if (missing(destfile)) destfile = tempfile()
      
  if (is.character(lat) & missing(map)){
    if (API == "google") {
      map = GetMap(getGeoCode(lat), zoom = zoom,maptype=maptype,destfile=destfile)
    } else if (API == "OSM") {
      map = GetOsmMap(getGeoCode(lat), zoom = zoom,maptype=maptype,destfile=destfile)
    } else if (API == "bing") {
      map = GetBingMap(getGeoCode(lat), zoom = zoom, maptype=maptype, destfile=destfile,apiKey=apiKey)
    } 
    #browser()
    PlotOnStaticMap(MyMap=map)
    invisible(map)
    return(map)
  }    
  if ((is.numeric(lat) | is.list(lat)) & length(lat) == 2 ){
    if (all(names(lat) %in% c("lat", "lon"))) {
      lon = as.numeric(lat["lon"])
      lat = as.numeric(lat["lat"])
    } else {#assume correct order
      print("NOTE: Assuming lat/lon order in lat vector!")
      lon = as.numeric(lat[2])
      lat = as.numeric(lat[1])
    }
  }
  if (is.numeric(lat) & is.numeric(lon) ){
    bb=qbbox(lat,lon)
    if (missing(map)){
      if (missing(zoom)){
        zoom <- min(MaxZoom(bb$latR, bb$lonR, c(720,720)))
        if (API == "google") {
          map = GetMap.bbox(bb$lonR, bb$latR, maptype=maptype,destfile=destfile)
        } else if (API == "OSM") {
          #map = GetOsmMap(lonR= bb$lonR, latR =bb$latR, zoom = zoom,maptype=maptype,destfile=destfile)
          map = GetMapTiles(lonR=bb$lonR, latR=bb$latR,zoom=zoom, verbose=verbose)
          #browser()
        } else if (API == "google2") {
          #map = GetOsmMap(lonR= bb$lonR, latR =bb$latR, zoom = zoom,maptype=maptype,destfile=destfile)
          map = GetMapTiles(lonR=bb$lonR, latR=bb$latR,zoom=zoom, verbose=verbose,
                            urlBase = "http://mt1.google.com/vt/lyrs=m", 
                            tileDir= "~/mapTiles/Google/")
          #browser()
        } else if (API == "bing") {
          bbM=do.call("cbind",bb);
          ll= bbM[1,] #lower left corner
          ur= bbM[2,] #upper right corner 
          map = GetBingMap(mapArea=c(ll,ur), zoom = zoom, maptype=maptype, destfile=destfile,apiKey=apiKey)
        } 
        
      } else {
        center=c(lat=mean(lat,na.rm=TRUE),lon=mean(lon,na.rm=TRUE))
        if (API == "google") {
          map = GetMap(center=center, zoom = zoom,maptype=maptype,destfile=destfile)
        } else if (API == "OSM") {
          #map = GetOsmMap(center=center, zoom = zoom,maptype=maptype,destfile=destfile)
          map = GetMapTiles(lonR=bb$lonR, latR=bb$latR,zoom=zoom, verbose=verbose)
          #browser()
        } else if (API == "google2") {
          #map = GetOsmMap(lonR= bb$lonR, latR =bb$latR, zoom = zoom,maptype=maptype,destfile=destfile)
          map = GetMapTiles(lonR=bb$lonR, latR=bb$latR,zoom=zoom, verbose=verbose,
                            urlBase = "http://mt1.google.com/vt/lyrs=m", 
                            tileDir= "~/mapTiles/Google/")
          #browser()
        } else if (API == "bing") {
          map = GetBingMap(center=center, zoom = zoom, maptype=maptype, destfile=destfile,apiKey=apiKey)
        } 

      }
    } 
    if (verbose>1) browser()
    plotclr = col
    if (alpha < 1 & !all(is.na(as.numeric(col)))) plotclr = AddAlpha(as.numeric(col), alpha = alpha, verbose = 0)
    if (inherits(map,"mapTiles")) {
      PlotOnMapTiles(map,lat=lat,lon=lon,col=plotclr, ...)
    } else {#if (class(map) ==  "staticMap") {
      PlotOnStaticMap(MyMap=map, lat=lat,lon=lon, col=plotclr, ...)
    }
    invisible(map)
  }
}, ex = function(){
  if (0){
    #####################Google maps#############################
    mapBG1 = plotmap("Brandenburg Gate, Berlin", zoom = 15)
  
    #####################bing maps#############################
    
    #for bing maps you will need your own API key, 
    #sign up at https://msdn.microsoft.com/en-us/library/ff428642.aspx
    apiKey = scan("bingAPIkey.txt",what="")
    mapBG2 = plotmap("Brandenburg Gate, Berlin", zoom = 15, API = "bing", apiKey=apiKey)
    
    latlon <- cbind.data.frame(lat = c(38.898648,38.889112, 38.880940), 
                                lon = c(-77.037692, -77.050273, -77.03660));
    
    
    map3 = plotmap(lat = latlon$lat, lon = latlon$lon, API = "bing", apiKey=apiKey,
                   col = "purple", pch="X",cex=1.5)
    
    
    #####################OSM maps#############################
    map4 = plotmap(lat = latlon$lat, lon = latlon$lon, API = "OSM", zoom=15,
                   col = "purple", pch="X",cex=1.5)
  }
})

`LatLon2XY.centered` <-structure(function#computes the centered coordinate transformation from lat/lon to map tile coordinates 
### The function LatLon2XY.centered(MyMap, lat,lon,zoom) computes the coordinate transformation from lat/lon to map tile coordinates given a map object.
(
  MyMap, ##<< map object 
  lat, ##<< latitude values to transform
  lon, ##<< longitude values to transform
  zoom ##<< optional zoom level. If missing, taken from \code{MyMap}
){
  
  # transfXY<-function(MyMap,oldX, oldY)## only use for non proper coordinate transformations
  # {
  #   xlim<-c(MyMap[["BBOX"]][["ll"]][2],MyMap[["BBOX"]][["ur"]][2])
  #   ylim<-c(MyMap[["BBOX"]][["ll"]][1],MyMap[["BBOX"]][["ur"]][1])
  #   Rcoords<-list(newX=(oldX-xlim[1])/(xlim[2]-xlim[1]),
  #                 newY=(oldY-ylim[1])/(ylim[2]-ylim[1]))
  #   #browser()
  #   return(Rcoords)
  # }
  # 
  # if (MyMap$url == "OSM") {
  #   return(transfXY(MyMap,lon,lat))
  # }
   lat.center <- MyMap[[1]];
   lon.center <- MyMap[[2]];
   if (missing(zoom)) zoom <- MyMap[[3]];
     
   #account for "jumps" at longitude boundaries -180/180
   #browser()
   lonLeft = as.numeric(MyMap$BBOX$ll)[2] #["lon"]
   lonRight = as.numeric(MyMap$BBOX$ur)[2] #["lon"]
   
   if (lonRight*lonLeft < 0 & FALSE){#sign change !
     #print("fixing the jump at the boundaries")
     if (MyMap$lon.center < 0){#subtract 360 from all positive longitude values:
       lon[lon>0] = lon[lon>0]-360
     } else if (MyMap$lon.center > 0){#add 360 to all negative longitude values:
       lon[lon<0] = lon[lon<0]+360
     }
   }
   mypoints <- LatLon2XY(lat,lon,zoom);
   mycenter <- LatLon2XY(lat.center,lon.center,zoom);
   
   Rcoords <- Tile2R(mypoints, mycenter);
   
  ##seealso<< \link{LatLon2XY} \link{Tile2R} 
   return(list(newX=Rcoords$X,newY=Rcoords$Y));
### properly scaled and centered (with respect to the center of \code{MyMap} ) coordinates  
###  \item{newX }{ transformed longitude}
###  \item{newY }{transformed latitude}
})

ReadMapTile <- structure(function#Read a bitmap image stored in the PNG format
###Reads an image from a PNG file/content into a raster array.
(
  destfile,  ##<< png file to read 
  METADATA = TRUE,  ##<< read MetaInfo as well ?
  native=TRUE ##<< determines the image representation - if FALSE then the result is an array, if TRUE then the result is a native raster representation, see \link[png]{readPNG} in package png.
){
  fileBase <- substring(destfile,1, nchar(destfile)-4);
  fileExt <-  substring(destfile,nchar(destfile)-2,nchar(destfile));
  
 
  myTile <- readPNG(destfile, native=native);
 #if (exists("rasterImage")) myTile <- as.raster(myTile)

  #attr(myTile, "type") <- "rgb"; 
  size <- dim(myTile)[2:1];
  MetaInfo=NULL;
  if (METADATA) {
    try({
 	#load(paste(fileBase,"rda",sep="."));
 	VarsLoaded <- load(paste(destfile,"rda",sep="."));
 	if (is.element("MetaInfo", VarsLoaded))
 	  MyMap <- list(lat.center= MetaInfo$lat.center, lon.center=MetaInfo$lon.center, zoom=MetaInfo$zoom, 
                      myTile=myTile, BBOX = MetaInfo$BBOX, url = MetaInfo$url, size=size, SCALE=MetaInfo$SCALE);
 	class(MyMap) =  "staticMap"
 	return(MyMap);
   });
 } 
 return(myTile);
### map or tile object
})

	

sp_bbox = function (obj) 
{
    is_points <- function(obj) {
        is <- FALSE
        if (is.array(obj)) 
            if (length(dim(obj)) == 2) 
                if (dim(obj)[2] >= 2) 
                  is <- TRUE
        is
    }
    if (!is_points(obj)) 
        stop("object not a >= 2-column array")
    xr <- range(obj[, 1], na.rm = TRUE)
    yr <- range(obj[, 2], na.rm = TRUE)
    res <- rbind(x = xr, y = yr)
    colnames(res) <- c("min", "max")
    res
}

NumTiles <- structure(function#computes the necessary number of tiles from a bounding box and a zoom level
### computes the necessary number of tiles from a bounding box and a zoom level
(  lonR, ##<< longitude range
   latR, ##<< latitude range, 
   zoom =13, ##<< zoom level
   CheckExistingFiles = TRUE, ##<< logical, if TRUE check if files already exist and only download if not!
   tileExt = ".png", ##<< image type of tile
   tileDir= "~/mapTiles/OSM/", ##<< map tiles are stored in a local directory, e.g. "~/mapTiles/Google/"
   verbose=0 ##<< level of verbosity
){
  nTiles=c(0,0)
  if (!missing(lonR) & !missing(latR)) {
    XYmin = LatLon2XY(lat=latR[1], lon=lonR[1],zoom=zoom)
    XYmax = LatLon2XY(lat=latR[2], lon=lonR[2],zoom=zoom)
    nTiles[1] = abs(XYmax$Tile[1,1]-XYmin$Tile[1,1])+1
    nTiles[2] = abs(XYmax$Tile[1,2]-XYmin$Tile[1,2])+1
    center = c(lat=mean(latR),lon=mean(lonR))
  }
  
  if (CheckExistingFiles) {
    XY = LatLon2XY(lat=center["lat"], lon=center["lon"],zoom=zoom)
    tileXY = XY$Tile + as.numeric(XY$Coords > 256)
    
    if (nTiles[1] %% 2 == 0) {#even
      X = (tileXY[1,1]-nTiles[1]/2):(tileXY[1,1]+nTiles[1]/2-1);
    } else {
      X = (tileXY[1,1]-(nTiles[1]-1)/2):(tileXY[1,1]+(nTiles[1]-1)/2);
    }
    if (nTiles[2] %% 2 == 0) {#even
      Y = (tileXY[1,2]-nTiles[2]/2):(tileXY[1,2]+nTiles[2]/2-1);
    } else {
      Y = (tileXY[1,2]-(nTiles[2]-1)/2):(tileXY[1,2]+(nTiles[2]-1)/2);
    }
    
    fNameServer = function(x,y) paste0(paste(zoom, x, y, sep="_"),tileExt)
    fList = as.vector(outer(X,Y,FUN = fNameServer))
    
    ExistingFiles=list.files(path=tileDir)
    
    fExist = sum(fList %in% ExistingFiles)
    cat("still need to download", prod(nTiles)-fExist,"tiles from ", prod(nTiles), "requested files.\n")
  }
  
  return(nTiles) 
  ### tuple with number of tiles for lon and lat extent
}, ex = function(){
  if (0){
    #US bounding box:
    for (zoom in 4:15) {
      cat("OSM, zoom =", zoom, "\n")
      NumTiles(lonR=c(-135,-66), latR=c(25,54) , zoom=zoom)
    }
    for (zoom in 4:15) {
      cat("Google, zoom =", zoom, "\n")
      NumTiles(lonR=c(-135,-66), latR=c(25,54) , zoom=zoom, tileDir= "~/mapTiles/Google/")
    }
  }
})

bubbleMap <- structure(function#Create a bubble plot of spatial data on Google Maps
### This function creates a bubble plot of spatial
### data, with options for bicolour residual plots.
(
  SP, ##<< object of class data.frame or \link[sp]{SpatialPointsDataFrame-class} with associated coordinate reference systems
  coords=c("x", "y"), ##<< names of coordinate columns
  crs=sp::CRS("+proj=longlat +datum=WGS84") , ##<< coordinate reference systems
  map, ##<< map object; if missing map is downloaded from server
  filename = "", ##<< filename to save the map under, IF map object not given
  zcol = 1, ##<< variable column name, or column number after removing spatial coordinates from x@data: 1 refers to the first non-coordinate column
  max.radius = 100, ##<< value for largest circle (the plotting symbols) in metre, circumcircle of triange or quadrangle (square)
  key.entries, ##<< value for largest circle (the plotting symbols) in metre, circumcircle of triange or quadrangle (square)
  do.sqrt = TRUE,##<< logical; if TRUE the plotting symbol area (sqrt(diameter)) is proportional to the value of the z-variable; if FALSE, the symbol size (diameter) is proportional to the z-variable
#  add = FALSE, ##<< logical; if TRUE the result of the function will be a list stored as variable  in  R. It is possible to combine more layers in the one plot, previously saved output from plotGoogleMaps should be given in the previousMap attribute.
#  previousMap = NULL,##<<  
  colPalette = NULL, ##<< colours to be used to fill plotting symbols; numeric vector of same size like key.entries
  strokeColor = "#FFAA00", ##<< the color to draw the border of circle (the plotting symbols)
  alpha = 0.7, ##<< the fill opacity between 0.0 and 1.0
  strokeWeight = 1, ##<< the stroke width in pixels
  LEGEND = TRUE, ##<< logical; if TRUE add bubbleLegend
  legendLoc = "topleft", ##<< the x and y co-ordinates to be used to position the legend. They can be specified by keyword or in any way which is accepted by \code{legend}
  verbose =0 ##<< level of verbosity
){
  ####################################################################
  if (missing(key.entries)) key.entries = round(quantile(SP@data[,zcol], (1:5)/5),1)
  PolyCol <-   function#Create list of colors depending on attribute data. (for bubbleMap)
  (attribute, ##<< vector of attribute data
   colPalette=NULL, ##<< colours to be used to fill features depending on attribute
   at ##<< values at which colours will change
  ) {
    # attribute=soil.ll@data$ID
    pal<-colorRampPalette(c( "green", "orange","brown"), space = "Lab")
    
    if(!is.numeric(attribute)){ attribute<-as.factor( attribute)}
    
    if(length(colPalette)==1) {
      x<- rep(colPalette,length(attribute))
      col.data<-list(cols=as.character(substr(x,1,7)),col.uniq=colPalette, att=ifelse(!is.factor(attribute),paste("[",min(attribute)," , ",max(attribute),"]",sep=""), " "))
      return(col.data) }
    
    if(is.null(colPalette) ){
      colPalette<-pal(min(10,length(attribute) ) ) }else{ xx<-colPalette<-as.character(substr(colPalette,1,7)) }
    
    if(is.factor(attribute)){
      
      if(length(colPalette)!=nlevels(attribute)) {
        xx<-colPalette<- as.character(substr(pal(nlevels(attribute)),1,7))    }
      
      x<-factor(attribute,labels=colPalette)
      col.data<-list(cols=as.character(substr(x,1,7)),col.uniq=colPalette, att=levels(attribute) )
      return(col.data)
      
    }else{
      bre<-quantile(attribute, seq(1,length(colPalette))/length(colPalette))
      breakss<-factor(c(min(attribute),bre))
      break_unique<-as.numeric(levels(breakss))
      
      if(length(colPalette)>=length(break_unique)){
        colPalette<-colPalette[1:length(break_unique)] } else{
          colPalette<- as.character(substr(colPalette[1:length(break_unique)-1],1,7))}
      
      atr<-cut(attribute, break_unique ,include.lowest = TRUE, dig.lab=6)                                 
      x<-factor(atr,labels=colPalette[1:(length(break_unique)-1)] )
      col.data<-list(cols=as.character(substr(x,1,7)),col.uniq=colPalette, att=levels(atr) )
      return(col.data)                               
      
    }
    
    ###The function provide list of colors (cols), unique colors (col.uniq), levels of attribute (att),attribute breaks (brks).   
  }
    #require(rgdal)
  if (class(SP) == "data.frame") {
    #SP = DF2SpatialPointsDataFrame(SP, coords=c("x", "y"))
    nameOfSP = deparse(substitute(SP))
    z = SP[, zcol]
    ll = SP[, coords]
  } else {
    stopifnot(class(SP) == "SpatialPointsDataFrame")
    obj = as(SP, "SpatialPointsDataFrame")
    data = obj@data
    if (NCOL(data) == 1) {
      z = data
    }
    else {
      z = data[, zcol]
    }
    SP.ll <- sp::spTransform(SP, crs)
    Centar = c(mean(SP.ll@bbox[1, ]), mean(SP.ll@bbox[2, ]))
    sw <- c(SP.ll@bbox[2, 1], SP.ll@bbox[1, 1])
    ne <- c(SP.ll@bbox[2, 2], SP.ll@bbox[1, 2])
    nameOfSP <- sapply(as.list(substitute({
      SP
    })[-1]), deparse)
    nameOfSP <- gsub("[!,\",#,$,%,&,(,),*,+,-,.,/,:,;,<,=,>,?,@,^,`,|,~]", 
                     "_", nameOfSP)
    nameOfSP <- gsub("[[]", "_", nameOfSP)
    nameOfSP <- gsub("[]]", "_", nameOfSP)
    
    attribute = SP@data[, zcol]
    for (i in 1:length(SP.ll@data)) {
      if (identical(attribute, SP.ll@data[, i])) {
        attributeName <- names(SP.ll@data)[i]
      }
    }
    ll = SP.ll@coords
  }
  att <- rep(NA, length(ll[, 1]))
  att1 = ""
  if (filename == "") {
    filename <- paste(nameOfSP, ".png", sep = "")
  }
    if (min(key.entries) < 0) {
        ke <- abs(min(key.entries)) + key.entries + mean(key.entries)
    }
    else {
        ke <- key.entries + mean(key.entries)
    }
    if (do.sqrt) {
        scale.level <- sqrt(ke/(max(ke)))
    }
    else {
        scale.level <- ke/(max(ke))
    }
    radius.level <- max.radius * scale.level
    breakss <- factor(c(min(z), key.entries))
    break_unique <- as.numeric(levels(breakss))
    if (length(unique(z)) == length(key.entries)) {
        zz = factor(z, labels = radius.level)
        radius.vector <- floor(as.numeric(as.vector(zz)))
    }
    else {
        zz = factor(cut(z, break_unique, include.lowest = TRUE), 
            labels = radius.level)
        radius.vector <- floor(as.numeric(as.vector((zz))))
    }

#     polyName <- paste("poly", nameOfSP, sep = "")
#     boxname <- paste(nameOfSP, "box", sep = "")
#     textname <- paste(nameOfSP, "text", sep = "")
#     divLegendImage <- tempfile("Legend")
#     divLegendImage <- substr(divLegendImage, start = regexpr("Legend", 
#         divLegendImage), stop = nchar(divLegendImage))
#     legendboxname <- paste("box", divLegendImage, sep = "")
#     textnameW <- paste(textname, "W", sep = "")
    
    if (strokeColor != "") {
        rgbc <- col2rgb(strokeColor)
        strokeColor <- rgb(rgbc[1], rgbc[2], rgbc[3], maxColorValue = 255)
    }
    if (!is.null(colPalette)) {
        rgbc <- col2rgb(colPalette)
        colPalette <- apply(rgbc, 2, function(x) rgb(x[1], x[2], 
            x[3], maxColorValue = 255))
    }
    
    cxx <- PolyCol(factor(zz, labels = key.entries), colPalette)
    plotclr <- cxx$cols
    plotclr = AddAlpha(plotclr,alpha)
    
    bb <- qbbox(lat = ll[, 2], lon = ll[, 1]);
    if (verbose>1) browser()
    ##download the map:
    if (missing(map))
      map <- GetMap.bbox(bb$lonR, bb$latR, destfile = filename, maptype="mobile", SCALE = 2);
    PlotOnStaticMap(map, lat = ll[, 2], lon = ll[, 1], 
                    col = plotclr, cex = 3*radius.vector/max(radius.vector, na.rm=TRUE), pch = 20)
    if (LEGEND) {
      CEX = sqrt(as.numeric(key.entries))
      CEX = 4*CEX/max(CEX)
      cxx2 <- PolyCol(factor(CEX, labels = key.entries), colPalette)
      LEGEND = paste0("<",as.character(key.entries))
      legend(legendLoc, pt.cex=CEX,col=cxx2$cols, pch=20, legend=LEGEND)
    }
invisible(map)
#####################################################################
### map structure or URL used to download the tile.
}, ex = function(){
  
  if (0) {
    data(lat.lon.meuse, package="loa", envir = environment())
    
    map <- GetMap(center=c(lat=50.97494,lon=5.743606), zoom=13,
           size=c(480,480),destfile = file.path(tempdir(),"meuse.png"),
            maptype="mobile", SCALE = 1);
  
    par(cex=1.5)
    bubbleMap(lat.lon.meuse, coords = c("longitude","latitude"), map=map,
          zcol='zinc', key.entries = 100+ 100 * 2^(0:4));
  }
  
})

degreeAxis = structure(function#axis with degrees
### add an axis with degree labels
(
  side, ##<< integer; see \link{axis}
  at=NULL, ##<< numeric; if missing, \link{axTicks} is called for nice values; see \link{axis}
  labels, ##<< character; if omitted labels are constructed with degree symbols, ending in N/S/E/W; in case of negative degrees, sign is reversed and S or W is added; see \link{axis}
  MyMap, ##<< optional map object to be passed
  ... ##<< optional arguments to \link{axis}
){

  degreeLabelsNS = function(x) {
	pos = sign(x) + 2
	dir = c("*S", "", "*N")
	paste(abs(x), "*degree", dir[pos])
  }
  degreeLabelsEW = function(x) {
	x <- ifelse(x > 180, x - 360, x)
	pos = sign(x) + 2
	if (any(x == -180))
		pos[x == -180] = 2
	if (any(x == 180))
		pos[x == 180] = 2
	dir = c("*W", "", "*E")
	paste(abs(x), "*degree", dir[pos])
  }
    USR = par('usr')
	#browser()
    if (is.null(at) | missing(at)) {
        at = axTicks(side)
		#if (!missing(MyMap)) atLon = pretty(XY2LatLon(MyMap, X=USR[1:2],Y=USR[3])[,"lon"]) else atLon=at;
		#if (!missing(MyMap)) atLat = pretty(XY2LatLon(MyMap, X=USR[1],Y=USR[3:4])[,"lat"]) else atLat=at;
	}
	#browser();
    if (missing(labels)) {
        labels = FALSE
        if (side == 1 || side == 3) {
			if (!missing(MyMap)) atLon = XY2LatLon(MyMap, X=at,Y=USR[3])[,"lon"] else atLon=at;
            labels = parse(text = degreeLabelsEW(as.numeric(formatC(atLon, digits=5))))
        } else if (side == 2 || side == 4) {
		    if (!missing(MyMap)) atLat = XY2LatLon(MyMap, X=USR[1],Y=at)[,"lat"] else atLat=at;
            labels = parse(text = degreeLabelsNS(as.numeric(formatC(atLat, digits=5))))
		}
    }
  #browser()
    ##note<< decimal degrees are used if variation is small, instead of minutes and seconds
    axis(side, at = at, labels = labels, ...)
### axis is plotted on current graph
}, ex = function(){
  xy = cbind(x = 2 * runif(100) - 1, y = 2 * runif(100) - 1)
  plot(xy,xlim=c(-1,1),ylim=c(-1,1))
  degreeAxis(1)
  degreeAxis(2, at = c(-1,-0.5,0,0.5,1))
})

\name{LatLon2XY}

\alias{LatLon2XY}

\title{computes the coordinate transformation from lat/lon to map tile coordinates }

\description{The function LatLon2XY(lat,lon,zoom) computes the coordinate transformation from lat/lon to map tile coordinates given a zoom level. 

It returns the tile coordinates as well as the pixel coordinates within the Tile itself. }

\usage{LatLon2XY(lat, lon, zoom)}

\arguments{

  \item{lat}{latitude values to transform}

  \item{lon}{longitude values to transform}

  \item{zoom}{zoom level.lat,lon,zoom}

}



\value{A list with values

\item{Tile}{integer numbers specifying the tile}

\item{Coords}{pixel coordinate within the Tile}}



\author{Markus Loecher}

\note{The fractional part times 256 is the pixel coordinate within the Tile itself. }







\examples{

LatLon2XY(38.45, -122.375, 11)

}

\name{RGB2GRAY}

\alias{RGB2GRAY}

\title{translates an RGB image matrix to gray scale}

\description{This function translates the rgb values of the array myTile into a scalar matrix with just one gray value per pixel.}

\usage{RGB2GRAY(myTile)}

\arguments{

  \item{myTile}{rgb image matrix, usually array with 3 dimensions}

}

\details{Gray scale intensity defined as  0.30R + 0.59G + 0.11B}

\value{image tile}



\author{Markus Loecher}









\examples{

if (0){

  BrooklynLatLon = getGeoCode("Brooklyn")

  mapBrooklyn <- GetMap(center=BrooklynLatLon, destfile = file.path(tempdir(), "Brooklyn.png"), 

                 zoom=11, size = c(240,240))

  mapBrooklynBW$myTile = RGB2GRAY(mapBrooklyn$myTile)

  PlotOnStaticMap(mapBrooklynBW)

}

}

\name{pennLC}
\alias{pennLC}
\docType{data}
\title{Pennsylvania Lung Cancer}
\description{
County-level (n=67) population/case data for lung cancer in Pennsylvania in 2002, stratified on race (white vs non-white), gender and age (Under 40, 40-59, 60-69 and 70+).  Additionally, county-specific smoking rates.  
}
\usage{data(pennLC)}
\format{
List of 3 items:
\tabular{ll}{
\code{geo} \tab a table of county IDs, longitude/latitude of the geographic centroid of each county \cr
\code{data} \tab a table of county IDs, number of cases, population and strata information \cr
\code{smoking} \tab a table of county IDs and proportion of smokers\cr
\code{spatial.polygon} \tab an object of class SpatialPolygons (See \link[sp]{SpatialPolygons-class}) \cr
}
}
%\details{}
\seealso{ 
 \code{\link{NYleukemia}}
}
\source{
Population data was obtained from the 2000 decennial census, lung cancer 
and smoking data were obtained from the Pennsylvania Department of Health website:  http://www.dsf.health.state.pa.us/
}
%\references{}
\examples{
data(pennLC)
#pennLC$geo
#pennLC$data
#pennLC$smoking

# Map smoking rates in Pennsylvania
#mapvariable(pennLC$smoking[,2], pennLC$spatial.polygon)
}
\keyword{datasets}

% Copyright 2001 by Roger S. Bivand
\name{columbus}
\alias{columbus}
\alias{col.gal.nb}
\alias{coords}
\alias{polys}
\alias{bbs}
\docType{data}
\title{Columbus OH spatial analysis data set}
\usage{data(columbus)}
\description{
The \code{columbus} data frame has 49 rows and 22 columns.
Unit of analysis: 49 neighbourhoods in Columbus, OH, 1980 data.
In addition the data set includes a \code{polylist} object \code{polys}
with the boundaries of the neighbourhoods, a matrix of polygon centroids
\code{coords}, and \code{col.gal.nb}, the neighbours list
from an original GAL-format file. The matrix \code{bbs} is DEPRECATED, but retained for other packages using this data set.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{AREA}{computed by ArcView}
    \item{PERIMETER}{computed by ArcView}
    \item{COLUMBUS.}{internal polygon ID (ignore)}
    \item{COLUMBUS.I}{another internal polygon ID (ignore)}
    \item{POLYID}{yet another polygon ID}
    \item{NEIG}{neighborhood id value (1-49);
             conforms to id value used in Spatial Econometrics book.}
    \item{HOVAL}{housing value (in $1,000)}
    \item{INC}{household income (in $1,000)}
    \item{CRIME}{residential burglaries and vehicle thefts per thousand
        households in the neighborhood}
    \item{OPEN}{open space in neighborhood}
    \item{PLUMB}{percentage housing units without plumbing}
    \item{DISCBD}{distance to CBD}
    \item{X}{x coordinate (in arbitrary digitizing units, not polygon coordinates)}
    \item{Y}{y coordinate (in arbitrary digitizing units, not polygon coordinates)}
    \item{NSA}{north-south dummy (North=1)}
    \item{NSB}{north-south dummy (North=1)}
    \item{EW}{east-west dummy (East=1)}
    \item{CP}{core-periphery dummy (Core=1)}
    \item{THOUS}{constant=1,000}
    \item{NEIGNO}{NEIG+1,000, alternative neighborhood id value}
  }
}
\details{
The row names of \code{columbus} and the \code{region.id} attribute of
\code{polys} are set to \code{columbus$NEIGNO}.
}
\source{
Anselin, Luc.  1988.  Spatial econometrics: methods and
models.  Dordrecht: Kluwer Academic, Table 12.1 p. 189.
}
\note{
All source data files prepared by
Luc Anselin, Spatial Analysis Laboratory, Department of Agricultural and Consumer Economics, University of Illinois, Urbana-Champaign.
}

\examples{
#library(maptools)
#columbus <- readShapePoly(system.file("etc/shapes/columbus.shp",
# package="spdep")[1])
#col.gal.nb <- read.gal(system.file("etc/weights/columbus.gal",
# package="spdep")[1])
}
\keyword{datasets}

\name{genStaticMap}

\alias{genStaticMap}

\title{generates a "static map" from map tiles by "stitching" them together}

\description{necssary because the Google static maps API requires a key now}

\usage{genStaticMap(center, zoom = 15, size = c(640, 640), 

    destfile = tempfile("staticMap", fileext = ".png"), 

    type = c("google", "google-m", "google-s", "osm", 

        "osm-hot", "stamen-toner", "stamen-terrain", 

        "stamen-watercolor")[1], urlBase = "http://mt1.google.com/vt/lyrs=m", 

    tileDir = "/tmp/", tileExt = ".png", verbose = 0, 

    ...)}

\arguments{

  \item{center}{optional center}

  \item{zoom}{zoom}

  \item{size}{size (in pixels) of "stitched" map}

  \item{destfile}{File to load the map image from or save to, depending on \code{NEWMAP}.}

  \item{type}{choice of tile server}

  \item{urlBase}{tileserver URL, alternatives would be "http://a.tile.openstreetmap.org/", "http://tile.stamen.com/toner/","http://tile.stamen.com/watercolor/"}

  \item{tileDir}{map tiles can be stored in a local directory, e.g. "~/mapTiles/Google/"}

  \item{tileExt}{image type of tile}

  \item{verbose}{level of verbosity}

  \item{\dots}{further arguments to be passed to \code{FUN}}

}



\value{list with tiles}



\author{Markus Loecher}









\examples{



if (0){

  lat = c(40.702147,40.718217,40.711614);

  lon = c(-74.012318,-74.015794,-73.998284);

  center = c(mean(lat), mean(lon));

  zoom <- min(MaxZoom(range(lat), range(lon)));

  bb=qbbox(lat,lon)

  

  mt = GetMapTiles(latR =bb$latR , lonR=bb$lonR,zoom=zoom,verbose=1)

  PlotOnMapTiles(mt,lat=lat,lon=lon,pch=20,col=c('red', 'blue', 'green'),cex=2)

  

  mt = GetMapTiles(latR =bb$latR , lonR=bb$lonR,zoom=zoom,

                   tileDir= "~/mapTiles/Google/")

  PlotOnMapTiles(mt,lat=lat,lon=lon,pch=20,col=c('red', 'blue', 'green'),cex=2)

  

}

}

\name{geosphere_mercator}

\alias{geosphere_mercator}

\title{Transform longitude/latiude points to the Mercator projection. }

\description{From \code{geosphere::mercator}}

\usage{geosphere_mercator(p, inverse = FALSE, r = 6378137)}

\arguments{

  \item{p}{longitude/latitude of point(s). Can be a vector of two numbers, a matrix of 2 columns (first one is longitude, second is latitude)}

  \item{inverse}{Logical. If TRUE, do the inverse projection (from Mercator to longitude/latitude}

  \item{r}{Numeric. Radius of the earth; default = 6378137 m}

}



\value{Mercator projection of lon/lat points}



\author{Markus Loecher}

\name{GetMap}

\alias{GetMap}

\title{download a static map from the Google server}

\description{Query the Google server for a static map tile, defined primarily by its 

center and zoom. Many additional arguments allow the user to customize 

the map tile.

documentation at https://developers.google.com/maps/documentation/staticmaps/}

\usage{GetMap(center = c(lat = 42, lon = -76), size = c(640, 

    640), destfile = tempfile("staticMap", fileext = ".png"), 

    zoom = 12, markers, path = "", span, frame, hl, 

    sensor = "true", maptype = c("roadmap", "mobile", 

        "satellite", "terrain", "hybrid", "mapmaker-roadmap", 

        "mapmaker-hybrid")[2], format = c("gif", "jpg", 

        "jpg-baseline", "png8", "png32")[5], extraURL = "", 

    RETURNIMAGE = TRUE, GRAYSCALE = FALSE, NEWMAP = TRUE, 

    SCALE = 1, API_console_key, type = c("google", 

        "google-m", "google-s", "osm", "osm-hot", "stamen-toner", 

        "stamen-terrain", "stamen-watercolor")[1], 

    urlBase = "http://mt1.google.com/vt/lyrs=m", tileDir = "/tmp/", 

    verbose = 0)}

\arguments{

  \item{center}{optional center (lat first,lon second  )}

  \item{size}{desired size of the map tile image. defaults to maximum size returned by the Gogle server, which is 640x640 pixels}

  \item{destfile}{File to load the map image from or save to, depending on \code{NEWMAP}.}

  \item{zoom}{Google maps zoom level.}

  \item{markers}{(optional) defines one or more markers to attach to the image at specified locations. This parameter takes a string of marker definitions separated by the pipe character (|)}

  \item{path}{(optional) defines a single path of two or more connected points to overlay on the image at specified locations. This parameter takes a string of point definitions separated by the pipe character (|)}

  \item{span}{(optional) defines a minimum viewport for the map image expressed as a latitude and longitude pair. The static map service takes this value and produces a map of the proper zoom level to include the entire provided span value from the map`s center point. Note that the resulting map may include larger bounds for either latitude or longitude depending on the rectangular dimensions of the map. If zoom is specified, span is ignored}

  \item{frame}{(optional) specifies that the resulting image should be framed with a colored blue border. The frame consists of a 5 pixel, 55 \% opacity blue border.}

  \item{hl}{(optional) defines the language to use for display of labels on map tiles. Note that this paramater is only supported for some country tiles; if the specific language requested is not supported for the tile set, then the default language for that tile set will be used.}

  \item{sensor}{specifies whether the application requesting the static map is using a sensor to determine the user`s location. This parameter is now required for all static map requests.}

  \item{maptype}{defines the type of map to construct. There are several possible maptype values, including satellite, terrain, hybrid, and mobile.}

  \item{format}{(optional) defines the format of the resulting image. By default, the Static Maps API creates GIF images. There are several possible formats including GIF, JPEG and PNG types. Which format you use depends on how you intend to present the image. JPEG typically provides greater compression, while GIF and PNG provide greater detail. This version supports only PNG.}

  \item{extraURL}{custom URL suffix}

  \item{RETURNIMAGE}{return image yes/no default: TRUE}

  \item{GRAYSCALE}{Boolean toggle; if TRUE the colored map tile is rendered into a black & white image, see \link{RGB2GRAY}}

  \item{NEWMAP}{if TRUE, query the Google server and save to \code{destfile}, if FALSE load from destfile.}

  \item{SCALE}{use the API's scale parameter to return higher-resolution map images. The scale value is multiplied with the size to determine the actual output size of the image in pixels, without changing the coverage area of the map}

  \item{API_console_key}{API key (formerly optional, now mandatory). If missing, the function "stitches" a static map from map tiles}

  \item{type}{choice of tile server}

  \item{urlBase}{tileserver URL, alternatives would be "http://a.tile.openstreetmap.org/", "http://tile.stamen.com/toner/","http://tile.stamen.com/watercolor/"}

  \item{tileDir}{map tiles can be stored in a local directory, e.g. "~/mapTiles/Google/"}

  \item{verbose}{level of verbosity}

}



\value{map structure or URL used to download the tile.}



\author{Markus Loecher}

\note{Note that size is in order (lon, lat)}





\seealso{\link{GetMap.bbox}}

\examples{

if (0){#takes too long to run for CRAN check

  

  lat = c(40.702147,40.718217,40.711614);

  lon = c(-74.012318,-74.015794,-73.998284);

  center = c(mean(lat), mean(lon));

  zoom <- min(MaxZoom(range(lat), range(lon)));

  #this overhead is taken care of implicitly by GetMap.bbox(); 

  markers = paste0("&markers=color:blue|label:S|40.702147,-74.015794&markers=color:",

                   "green|label:G|40.711614,-74.012318&markers=color:red|color:red|",

                   "label:C|40.718217,-73.998284")

  myMap <- GetMap(center=center, zoom=zoom,markers=markers);

  #Note that in the presence of markers one often needs to add some extra padding to the 

  #latitude range to accomodate the extent of the top most marker

  

  #add a path, i.e. polyline:

  myMap <- GetMap(center=center, zoom=zoom,

                  path = paste0("&path=color:0x0000ff|weight:5|40.737102,-73.990318|",

                  "40.749825,-73.987963|40.752946,-73.987384|40.755823,-73.986397"));

  #use implicit geo coding 

  BrooklynMap <- GetMap(center="Brooklyn", zoom=13)

  PlotOnStaticMap(BrooklynMap)

  

  #use implicit geo coding and display labels in Korean:

  BrooklynMap <- GetMap(center="Brooklyn", zoom=13, hl="ko")

  PlotOnStaticMap(BrooklynMap)

  

  #no highways

  ManHatMap <- GetMap(center="Lower Manhattan", zoom=14, 

                      extraURL="&style=feature:road.highway|visibility:off",

                      destfile = "LowerManhattan.png")

  PlotOnStaticMap(ManHatMap)

  

  #reload the map without a new download:

  ManHatMap <- GetMap(destfile = "LowerManhattan.png",NEWMAP=FALSE)

  PlotOnStaticMap(ManHatMap)



  #The example below defines a polygonal area within Manhattan, passed a series of 

  #intersections as locations:

  #myMap <- GetMap(path = paste0("&path=color:0x00000000|weight:5|fillcolor:0xFFFF0033|",

  #          "8th+Avenue+\%26+34th+St,New+York,NY|8th+Avenue+\%26+42nd+St,New+York,NY|",

  #          "Park+Ave+\%26+42nd+St,New+York,NY,NY|Park+Ave+\%26+34th+St,New+York,NY,NY"),

  #            destfile = "MyTile3a.png");

  

  #note that since the path string is just appended to the URL you can "abuse" the path 

  #argument to pass anything to the query, e.g. the style parameter:

  #The following example displays a map of Brooklyn where local roads have been changed 

  #to bright green and the residential areas have been changed to black:

  # myMap <- GetMap(center="Brooklyn", zoom=12, maptype = "roadmap", 

  #path = paste0("&style=feature:road.local|element:geometry|hue:0x00ff00|",

  #        "saturation:100&style=feature:landscape|element:geometry|lightness:-100"),

  #        sensor='false', destfile = "MyTile4.png",  RETURNIMAGE = FALSE);

  

  #In the last example we set RETURNIMAGE to FALSE which is a useful feature in general

  #if png is not installed. In that cases, the images can still be fetched 

  #and saved but not read into R.

  

  #In the following example we let the Static Maps API determine the correct center and 

  #zoom level implicitly, based on evaluation of the position of the markers. 

  #However, to be of use within R we do need to know the values for zoom and 

  #center explicitly, so it is better practice to compute them ourselves and 

  #pass them as arguments, in which case meta information on the map tile can be saved as well.

  

  #myMap <- GetMap(markers = paste0("&markers=color:blue|label:S|40.702147,-74.015794&",

  #          "markers=color:green|label:G|40.711614,-74.012318&markers=color:red|",

  #          "color:red|label:C|40.718217,-73.998284"), 

  #           destfile = "MyTile1.png",  RETURNIMAGE = FALSE);

}

}

\name{updateusr}

\alias{updateusr}

\title{Updates the 'usr' coordinates in the current plot.}

\description{For a traditional graphics plot this function will update the 'usr'

coordinates by transforming a pair of points from the current usr

coordinates to those specified.}

\usage{updateusr(x1, y1 = NULL, x2, y2 = NULL)}

\arguments{

  \item{x1}{The x-coords of 2 points in the current 'usr' coordinates, or anything that can be passed to \code{xy.coords}.}

  \item{y1}{The y-coords of 2 points in the current 'usr' coordinates, or an object representing the points in the new 'usr' coordinates.}

  \item{x2}{The x-coords for the 2 points in the new coordinates.}

  \item{y2}{The y-coords for the 2 points in the new coordinates.}

}

\details{Sometimes graphs (in the traditional graphing scheme) end up with usr

coordinates different from expected for adding to the plot (for

example \code{barplot} does not center the bars at integers).  This

function will take 2 points in the current 'usr' coordinates and the

desired 'usr' coordinates of the 2 points and transform the user

coordinates to make this happen.  The updating only shifts and scales

the coordinates, it does not do any rotation or warping transforms.



If \code{x1} and \code{y1} are lists or matricies and \code{x2} and

\code{y2} are not specified, then \code{x1} is taken to be the

coordinates in the current system and \code{y1} is the coordinates in

the new system.



Currently you need to give the function exactly 2 points in each

system.  The 2 points cannot have the same x values or y values in

either system.}

\value{An invisible list with the previous 'usr' coordinates from \code{par}.}



\author{Markus Loecher}

\note{Currently you need to give coordinates for exactly 2 points without

missing values.  Future versions of the function will allow missing

values or multiple points.



Note by Markus Loecher: both the source and the documentations were copied from the package TeachingDemos version 2.3}







\examples{

tmp <- barplot(1:4)

updateusr(tmp[1:2], 0:1, 1:2, 0:1)

lines(1:4, c(1,3,2,2), lwd=3, type='b',col='red')



# update the y-axis to put a reference distribution line in the bottom

# quarter



tmp <- rnorm(100)

hist(tmp)

tmp2 <- par('usr')

xx <- seq(min(tmp), max(tmp), length.out=250)

yy <- dnorm(xx, mean(tmp), sd(tmp))

updateusr( tmp2[1:2], tmp2[3:4], tmp2[1:2], c(0, max(yy)*4) )

lines(xx,yy)



}

\name{PlotArrowsOnStaticMap}

\alias{PlotArrowsOnStaticMap}

\title{plots arrows or segments on map }

\description{This function plots/overlays arrows or segments on a map.}

\usage{PlotArrowsOnStaticMap(MyMap, lat0, lon0, lat1 = lat0, 

    lon1 = lon0, TrueProj = TRUE, FUN = arrows, add = FALSE, 

    verbose = 0, ...)}

\arguments{

  \item{MyMap}{map image returned from e.g. \code{GetMap()}}

  \item{lat0}{latitude valuesof points FROM which to draw.}

  \item{lon0}{longitude values of points FROM which to draw.}

  \item{lat1}{latitude valuesof points TO which to draw.}

  \item{lon1}{longitude values of points TO which to draw.}

  \item{TrueProj}{set to FALSE if you are willing to accept some degree of inaccuracy in the mapping. In that case, the coordinates of the image are in lat/lon and the user can simply overly points/lines/axis without worrying about projections}

  \item{FUN}{, plotting function to use for overlay; typical choices would be \link{arrows} and \link{segments}}

  \item{add}{start a new plot or add to an existing}

  \item{verbose}{level of verbosity}

  \item{\dots}{further arguments to be passed to \code{FUN}}

}



\value{return value of \code{FUN}}



\author{Markus Loecher}







\seealso{\link{PlotOnStaticMap} \link{arrows}}

\examples{

if (0){

  	MyMap <- GetMap(center=c(lat=40.7,lon=-74), zoom=11)

	PlotArrowsOnStaticMap(MyMap, lat0=40.69, lon0=-73.9, lat1=40.71, lon1=-74.1, col = 'red')   

}

}

\name{ReadMapTile}

\alias{ReadMapTile}

\title{Read a bitmap image stored in the PNG format}

\description{Reads an image from a PNG file/content into a raster array.}

\usage{ReadMapTile(destfile, METADATA = TRUE, native = TRUE)}

\arguments{

  \item{destfile}{png file to read}

  \item{METADATA}{read MetaInfo as well ?}

  \item{native}{determines the image representation - if FALSE then the result is an array, if TRUE then the result is a native raster representation, see \link[png]{readPNG} in package png.}

}



\value{map or tile object}



\author{Markus Loecher}

\name{NumTiles}

\alias{NumTiles}

\title{computes the necessary number of tiles from a bounding box and a zoom level}

\description{computes the necessary number of tiles from a bounding box and a zoom level}

\usage{NumTiles(lonR, latR, zoom = 13, CheckExistingFiles = TRUE, 

    tileExt = ".png", tileDir = "~/mapTiles/OSM/", 

    verbose = 0)}

\arguments{

  \item{lonR}{longitude range}

  \item{latR}{latitude range,}

  \item{zoom}{zoom level}

  \item{CheckExistingFiles}{logical, if TRUE check if files already exist and only download if not!}

  \item{tileExt}{image type of tile}

  \item{tileDir}{map tiles are stored in a local directory, e.g. "~/mapTiles/Google/"}

  \item{verbose}{level of verbosity}

}



\value{tuple with number of tiles for lon and lat extent}



\author{Markus Loecher}









\examples{

if (0){

  #US bounding box:

  for (zoom in 4:15) {

    cat("OSM, zoom =", zoom, "\n")

    NumTiles(lonR=c(-135,-66), latR=c(25,54) , zoom=zoom)

  }

  for (zoom in 4:15) {

    cat("Google, zoom =", zoom, "\n")

    NumTiles(lonR=c(-135,-66), latR=c(25,54) , zoom=zoom, tileDir= "~/mapTiles/Google/")

  }

}

}

\name{plotmap}

\alias{plotmap}

\title{easy to use wrapper function}

\description{note the similarity in name to PBSmapping::plotMap

This function is the workhorse of the package RgoogleMaps. It overlays plot on background image of map tile.}

\usage{plotmap(lat, lon, map, zoom = NULL, API = c("google", 

    "OSM", "bing", "google2")[1], maptype = c("roadmap", 

    "mobile", "satellite", "terrain", "hybrid", "mapmaker-roadmap", 

    "mapmaker-hybrid")[2], destfile, data, alpha = 1, 

    col = 1, apiKey = NULL, verbose = 0, ...)}

\arguments{

  \item{lat}{latitude values to be overlaid OR string to be geocoded OR named vector (lat,lon)!}

  \item{lon}{longitude values to be overlaid}

  \item{map}{optional map object}

  \item{zoom}{Google maps zoom level}

  \item{API}{choice  of map tile API}

  \item{maptype}{defines the type of map to construct. There are several possible maptype values, including satellite, terrain, hybrid, and mobile.}

  \item{destfile}{File to save the map image to}

  \item{data}{data to look up variables in}

  \item{alpha}{opacity}

  \item{col}{plot color}

  \item{apiKey}{optional API key (allows for higher rate of downloads for Google); mandatory for Bing maps}

  \item{verbose}{level of verbosity}

  \item{\dots}{further arguments to be passed to \code{PlotOnStaticMap}}

}







\author{Markus Loecher}









\examples{

if (0){

  #####################Google maps#############################

  mapBG1 = plotmap("Brandenburg Gate, Berlin", zoom = 15)



  #####################bing maps#############################

  

  #for bing maps you will need your own API key, 

  #sign up at https://msdn.microsoft.com/en-us/library/ff428642.aspx

  apiKey = scan("bingAPIkey.txt",what="")

  mapBG2 = plotmap("Brandenburg Gate, Berlin", zoom = 15, API = "bing", apiKey=apiKey)

  

  latlon <- cbind.data.frame(lat = c(38.898648,38.889112, 38.880940), 

                              lon = c(-77.037692, -77.050273, -77.03660));

  

  

  map3 = plotmap(lat = latlon$lat, lon = latlon$lon, API = "bing", apiKey=apiKey,

                 col = "purple", pch="X",cex=1.5)

  

  

  #####################OSM maps#############################

  map4 = plotmap(lat = latlon$lat, lon = latlon$lon, API = "OSM", zoom=15,

                 col = "purple", pch="X",cex=1.5)

}

}

\name{LatLon2XY.centered}

\alias{LatLon2XY.centered}

\title{computes the centered coordinate transformation from lat/lon to map tile coordinates }

\description{The function LatLon2XY.centered(MyMap, lat,lon,zoom) computes the coordinate transformation from lat/lon to map tile coordinates given a map object.}

\usage{LatLon2XY.centered(MyMap, lat, lon, zoom)}

\arguments{

  \item{MyMap}{map object}

  \item{lat}{latitude values to transform}

  \item{lon}{longitude values to transform}

  \item{zoom}{optional zoom level. If missing, taken from \code{MyMap}}

}



\value{properly scaled and centered (with respect to the center of \code{MyMap} ) coordinates  

\item{newX }{ transformed longitude}

\item{newY }{transformed latitude}}



\author{Markus Loecher}







\seealso{\link{LatLon2XY} \link{Tile2R} }

\name{mypolygon}

\alias{mypolygon}

\title{simple wrapper function to plot colored polygons}

\description{same as \link{polygon}, execept the value for color is taken from the 1st element of the exra column 'col'}

\usage{mypolygon(x, ...)}

\arguments{

  \item{x}{matrix containing columns X,Y,col}

  \item{\dots}{extra arguments passed to  \link{polygon}}

}







\author{Markus Loecher}

\name{GetOsmMap}

\alias{GetOsmMap}

\title{Query the Open Street Map server for map tiles instead of Google Maps}

\description{The querying parameters for Open Street Maps are somewhat different in this version. 

Instead of a zoom, center and size, the user supplies a scale parameter and a lat/lon bounding box. 

The scale determines the image size.}

\usage{GetOsmMap(lonR = c(-74.02132, -73.98622), latR = c(40.69983, 

    40.72595), scale = 20000, destfile = "MyTile.png", 

    format = "png", RETURNIMAGE = TRUE, GRAYSCALE = FALSE, 

    NEWMAP = TRUE, verbose = 1, ...)}

\arguments{

  \item{lonR}{longitude range}

  \item{latR}{latitude range}

  \item{scale}{Open Street map scale parameter. The larger this value, the smaller the resulting map tile in memory. There is a balance to be struck between the lat/lon bounding box and the scale parameter.}

  \item{destfile}{File to load the map image from or save to, depending on \code{NEWMAP}.}

  \item{format}{(optional) defines the format of the resulting image.}

  \item{RETURNIMAGE}{return image yes/no default: TRUE}

  \item{GRAYSCALE}{Boolean toggle; if TRUE the colored map tile is rendered into a black & white image, see \link{RGB2GRAY}}

  \item{NEWMAP}{if TRUE, query the Google server and save to \code{destfile}, if FALSE load from destfile.}

  \item{verbose}{level of verbosity,}

  \item{\dots}{extra arguments to be used in future versions}

}



\value{map structure or URL used to download the tile.}



\author{Markus Loecher}

\note{The OSM maptile server is frequently too busy to accomodate every request, so patience is warranted.}







\examples{

if (0) {

 	CologneMap <- GetOsmMap(lonR= c(6.89, 7.09), latR = c(50.87, 51), scale = 150000, 

                            destfile = "Cologne.png");

	PlotOnStaticMap(CologneMap, mar=rep(4,4), NEWMAP = FALSE, TrueProj = FALSE, axes= TRUE);

		

	PrincetonMap <- GetOsmMap(lonR= c(-74.67102, -74.63943), latR = c(40.33804,40.3556), 

                             scale = 12500, destfile = "Princeton.png");

	png("PrincetonWithAxes.png", 1004, 732)

      PlotOnStaticMap(PrincetonMap, axes = TRUE, mar = rep(4,4));

    dev.off()

 }

}

\name{AddAlpha}

\alias{AddAlpha}

\title{add alpha level to color that lacks one}

\description{add alpha level to color that lacks one}

\usage{AddAlpha(plotclr, alpha = 0.5, verbose = 0)}

\arguments{

  \item{plotclr}{color to be modified}

  \item{alpha}{alpha level}

  \item{verbose}{level of verbosity}

}



\value{modified color with alpha value}



\author{Markus Loecher}









\examples{



#example: 

#require(RColorBrewer)

if (requireNamespace("RColorBrewer", quietly = TRUE)) {

  plotclr <- RColorBrewer::brewer.pal(8,"YlOrRd")

  plotclr = AddAlpha(plotclr,0.5)

} else {

  print("package RColorBrewer must be installed for this example")

}



}

\name{GetBingMap}

\alias{GetBingMap}

\title{download a static map from the Microsoft map tile server}

\description{Query the Google server for a static map tile, defined primarily by its 

center and zoom. Many additional arguments allow the user to customize 

the map tile.}

\usage{GetBingMap(center = c(lat = 42, lon = -76), mapArea = c(45.219, 

    -122.325, 47.61, -122.107), size = c(640, 640), 

    destfile, zoom = 12, markers, path = "", maptype = c("Road", 

        "Aerial", "AerialWithLabels")[1], format = c("png", 

        "gif", "jpg", "jpg-baseline", "png8", "png32")[1], 

    extraURL = "", RETURNIMAGE = TRUE, GRAYSCALE = FALSE, 

    NEWMAP = TRUE, SCALE = 1, apiKey = NULL, verbose = 0)}

\arguments{

  \item{center}{optional center (lat first,lon second  )}

  \item{mapArea}{A rectangular area specified as a bounding box (ll,ur). Required when a center point or set of route points are not specified}

  \item{size}{desired size of the map tile image. defaults to maximum size returned by the Gogle server, which is 640x640 pixels}

  \item{destfile}{File to load the map image from or save to, depending on \code{NEWMAP}.}

  \item{zoom}{Google maps zoom level.}

  \item{markers}{(optional) defines one or more markers to attach to the image at specified locations. This parameter takes a string of marker definitions separated by the pipe character (|)}

  \item{path}{(optional) defines a single path of two or more connected points to overlay on the image at specified locations. This parameter takes a string of point definitions separated by the pipe character (|)}

  \item{maptype}{defines the type of map to construct. See https://msdn.microsoft.com/en-us/library/ff701724.aspx}

  \item{format}{(optional) defines the format of the resulting image. By default, the Static Maps API creates GIF images. There are several possible formats including GIF, JPEG and PNG types. Which format you use depends on how you intend to present the image. JPEG typically provides greater compression, while GIF and PNG provide greater detail. This version supports only PNG.}

  \item{extraURL}{custom URL suffix}

  \item{RETURNIMAGE}{return image yes/no default: TRUE}

  \item{GRAYSCALE}{Boolean toggle; if TRUE the colored map tile is rendered into a black & white image, see \link{RGB2GRAY}}

  \item{NEWMAP}{if TRUE, query the Google server and save to \code{destfile}, if FALSE load from destfile.}

  \item{SCALE}{use the API's scale parameter to return higher-resolution map images. The scale value is multiplied with the size to determine the actual output size of the image in pixels, without changing the coverage area of the map}

  \item{apiKey}{optional API key (allows for higher rate of downloads)}

  \item{verbose}{level of verbosity}

}



\value{map structure or URL used to download the tile.}



\author{Markus Loecher}

\note{Note that size is in order (lon, lat)}





\seealso{\link{GetMap.bbox}}

\examples{



if (0){

  #for bing maps you will need your own API key, 

  #sign up at https://msdn.microsoft.com/en-us/library/ff428642.aspx

  apiKey = scan("bingAPIkey.txt",what="")

  map1=GetBingMap(center=c(47.619048,-122.35384),zoom=15,apiKey=apiKey, 

                  verbose=1, destfile="Seattle.png") 

  PlotOnStaticMap(map1)

  m="&pp=47.620495,-122.34931;21;AA&pp=47.619385,-122.351485;;AB&pp=47.616295,-122.3556;22"

  map2=GetBingMap(center=c(47.619048,-122.35384),zoom=15,markers=m,apiKey=apiKey, 

                  verbose=1, destfile="Seattle2.png")

  

  PlotOnStaticMap(map2,lat=c(47.620495,47.619385,47.616295),

                  lon=c(-122.34931,-122.351485,-122.3556))

  	

  m="&pp=49.28273,-123.12074;22&pp=44.05207,-123.08675;22"

  

  map3= GetBingMap(center=c(47.677006,-122.125526),zoom=6,markers=m,apiKey=apiKey,

                   verbose=1, destfile="Seattle2.png")

  #plotmap(map=map3)

  m=cbind.data.frame(lat=c(49.28273,44.05207),lon=c(-123.12074,-123.08675),col=c(3:4))

  PlotOnStaticMap(map3, lat =m$lat,lon=m$lon,col=m$col,pch=19)

  

  #overlay traffic:

  #Get a map with Road imagery and traffic flow based on a query.

  #This example gets a map with road imagery based on a query result Bellevue, Washington. 

  #Traffic flow is also included on the map.

  

  #http://dev.virtualearth.net/REST/V1/Imagery/Map/Road/Bellevue\%20Washington

  #?mapLayer=TrafficFlow&key=BingMapsKey

  #note that we are using the extraURL argument to pass any extra parameters:

  map4 = GetBingMap(center="Bellevue\%20Washington", zoom=12, extraURL="&mapLayer=TrafficFlow", 

                    apiKey=apiKey,verbose=1, destfile="BellevueTraffic.png")

  PlotOnStaticMap(map4)

  

  #Get a map with Road imagery that displays a route.

  #This example gets a map with road imagery that displays a driving 

  #route between the cities of Seattle and Redmond in Washington State. 

  

  #note that we are using the extraURL argument to pass any extra parameters:

  #http://dev.virtualearth.net/REST/v1/Imagery/Map/Road/Routes

  #?wp.0=Seattle,WA;64;1&wp.1=Redmond,WA;66;2&key=BingMapsKey 

  map5 = GetBingMap(center="Bellevue\%20Washington", zoom=8, 

                    extraURL="&Routes?wp.0=Seattle,WA;64;1&wp.1=Redmond,WA;66;2", 

                  apiKey=apiKey,verbose=1, destfile="Seattle2Redmond.png")

  PlotOnStaticMap(map5)

}

}

\name{NYleukemia}
\alias{NYleukemia}
\docType{data}
\title{Upstate New York Leukemia Data}
\description{
Census tract level (\code{n=281}) leukemia data for the 8 counties in upstate New York from 1978-1982, paired with population data from the 1980 census.
}
\usage{data(NYleukemia)}
\format{
List with 5 items:
\tabular{ll}{
\code{geo} \tab table of the FIPS code, longitude, and latitude of the geographic centroid of each census tract \cr
\code{data} \tab table of the FIPS code, number of cases, and population of each census tract \cr
\code{spatial.polygon} \tab object of class SpatialPolygons (See \link[sp]{SpatialPolygons-class}) containing a map of the study region \cr
\code{surrounded} \tab row IDs of the 4 census tracts that are completely surrounded by the \code{surrounding} census tracts \cr
\code{surrounding} \tab row IDs of the 4 census tracts that completely surround the \code{surrounded} census tracts \cr
}
}

\source{http://www.sph.emory.edu/~lwaller/ch4index.htm}
\references{
Turnbull, B. W. et al (1990)
Monitoring for clusters of disease: application to leukemia incidence in upstate New York \emph{American Journal of Epidemiology}, \bold{132}, 136--143
}
\examples{
if (0) {
data(NYleukemia)
  population <- NYleukemia$data$population
  cases <- NYleukemia$data$cases
  mapNY <- GetMap(center=c(lon=-76.00365, lat=42.67456), destfile = "NYstate.png",
  maptype = "mobile", zoom=9)
  ColorMap(100*cases/population, mapNY, NYleukemia$spatial.polygon, add = FALSE,
  alpha = 0.35, log = TRUE, location = "topleft")
 }
}
\keyword{datasets}

\name{PlotOnMapTiles}

\alias{PlotOnMapTiles}

\title{plots on map tiles by "stitching" them together}

\description{Counterpart to \code{PlotOnStaticMap} for map tiles}

\usage{PlotOnMapTiles(mt, lat, lon, center, size = c(768, 

    768), add = FALSE, FUN = points, mar = c(0, 0, 

    0, 0), verbose = 0, ...)}

\arguments{

  \item{mt}{list returned by \code{GetMapTiles}}

  \item{lat}{latitude values to be overlaid, if any}

  \item{lon}{longitude values to be overlaid, if any}

  \item{center}{optional center}

  \item{size}{size (in pixels) of "stitched" map}

  \item{add}{start a new plot or add to an existing}

  \item{FUN}{plotting function to use for overlay; typical choices would be \link{points} and \link{lines}}

  \item{mar}{outer margin in plot; if you want to see axes, change the default}

  \item{verbose}{level of verbosity}

  \item{\dots}{further arguments to be passed to \code{FUN}}

}



\value{nothing returned}



\author{Markus Loecher}









\examples{



if (0){

  lat = c(40.702147,40.718217,40.711614);

  lon = c(-74.012318,-74.015794,-73.998284);

  center = c(mean(lat), mean(lon));

  zoom <- min(MaxZoom(range(lat), range(lon)));

  bb=qbbox(lat,lon)

  

  manhattan_osm = GetMapTiles(latR =bb$latR , lonR=bb$lonR,zoom=zoom,verbose=1)

  PlotOnMapTiles(manhattan_osm,lat=lat,lon=lon,pch=20,col=c('red', 'blue', 'green'),cex=2)

  

  manhattan_goo = GetMapTiles(latR =bb$latR , lonR=bb$lonR,zoom=zoom,

                   tileDir= TRUE, type="google" )

  PlotOnMapTiles(manhattan_goo,lat=lat,lon=lon,pch=20,col=c('red', 'blue', 'green'),cex=2)

  

}

}

\name{plotOSMtile}

\alias{plotOSMtile}

\title{plots a single OSM tile}

\description{Adds tile to plot}

\usage{plotOSMtile(osmtile, zoom, add = TRUE, raster = TRUE, 

    verbose = 0, ...)}

\arguments{

  \item{osmtile}{tile object}

  \item{zoom}{zoom level}

  \item{add}{Boolean, whether to add to existing plot}

  \item{raster}{Boolean, whether to load rster image}

  \item{verbose}{level of verbosity}

  \item{\dots}{further arguments to be passed to \code{rasterImage}}

}



\value{returns nothing}



\author{Markus Loecher}

\name{ColorMap}

\alias{ColorMap}

\title{Plot Levels of a Variable in a Colour-Coded Map}

\description{Plot Levels of a Variable in a Colour-Coded Map}

\usage{ColorMap(values, map = NULL, polys = NULL, log = FALSE, 

    nclr = 7, include.legend = list(TRUE), round = 3, 

    brks = NULL, legend = NULL, location = "topright", 

    rev = FALSE, alpha = 0.5, GRAY = FALSE, palette = c("YlOrRd", 

        "RdYlGn", "Spectral")[1], textInPolys = NULL, 

    ...)}

\arguments{

  \item{values}{variable to plot}

  \item{map}{map object}

  \item{polys}{an object of class SpatialPolygons (See \link[sp]{SpatialPolygons-class}}

  \item{log}{boolean of whether to plot values on log scale}

  \item{nclr}{number of colour-levels to use}

  \item{include.legend}{boolean of whether to include legend}

  \item{round}{number of digits to round to in legend}

  \item{brks}{if desired, pre-specified breaks for legend}

  \item{legend}{if desired, a pre-specified legend}

  \item{location}{location of legend}

  \item{rev}{boolean of whether to reverse colour scheme (darker colours for smaller values)}

  \item{alpha}{alpha value of colors}

  \item{GRAY}{boolean: if TRUE, use gray scale instead}

  \item{palette}{palette to choose from RColorBrewer}

  \item{textInPolys}{text to be displayed inside polygons. This can be a column names for values}

  \item{\dots}{extra args to pass to \code{PlotPolysOnStaticMap}}

}







\author{Markus Loecher}









\examples{

  if (0){

    data("NYleukemia", envir = environment())

    population <- NYleukemia$data$population

    cases <- NYleukemia$data$cases

    mapNY <- GetMap(center=c(lat=42.67456,lon=-76.00365), destfile = "NYstate.png", 

                    maptype = "mobile", zoom=9)

    ColorMap(100*cases/population, mapNY, NYleukemia$spatial.polygon, add = FALSE,

             alpha = 0.35, log = TRUE, location = "topleft")

}

  #ColorMap(100*cases/population, map=NULL, NYleukemia$spatial.polygon)

  

}

\name{SpatialToPBS}

\alias{SpatialToPBS}

\title{converts spatial objects as defined in package sp to simpler PBSmapping type dataframes }

\description{The PlotPolysOnStaticMap() function currently does not take sp objects directly but instead needs

PBSmapping type data.frames. This function converts sp objects into such.                         

THANKS TO Fabio Priuli for a major bug fix w.r.t. holes in spatial polygons!}

\usage{SpatialToPBS(xy, verbose = 0)}

\arguments{

  \item{xy}{spatial object, such as SpatialPoints, SpatialPolygons, etc..}

  \item{verbose}{level of verbosity}

}



\value{list with elements xy = converted object, bb = bounding box, fun = plot function}



\author{Markus Loecher}









\examples{

  if (0) {

    data("NYleukemia", envir = environment())

    population <- NYleukemia$data$population

    cases <- NYleukemia$data$cases

    mapNY <- GetMap(center=c(lat=42.67456,lon=-76.00365), 

                    destfile = file.path(tempdir(),"NYstate.png"), 

                    maptype = "mobile", zoom=9)

    #mapNY=ReadMapTile("NYstate.png")

    clrStuff=ColorMap(100*cases/population, alpha = 0.35, log = TRUE)

    NYpolys = SpatialToPBS(NYleukemia$spatial.polygon)

    PlotPolysOnStaticMap(mapNY, NYpolys$xy, col = clrStuff$colcode, add = FALSE)

    legend("topleft", legend = clrStuff$legend, fill = clrStuff$fill, 

           bg = rgb(0.1,0.1,0.1,0.3))

}

  

}

\name{sp_bbox}

\alias{sp_bbox}

\title{computes bounding box}

\description{The function sp_bbox computes a bounding box; it was copied from the sp package bbox function }

\usage{sp_bbox(obj)}

\arguments{

  \item{obj}{object deriving from class "Spatial", or one of classes: "Line", "Lines", "Polygon" or "Polygons", or ANY, which requires obj to be an array with at least two columns}

}



\value{two-column matrix; the first column has the minimum, the second the maximum values; rows represent the spatial dimensions}


\author{Roger Bivand}


\examples{

# just 9 points on a grid:
x <- c(1,1,1,2,2,2,3,3,3)
y <- c(1,2,3,1,2,3,1,2,3)
xy <- cbind(x,y)

sp_bbox(xy)

}

\name{PlotOnStaticMap}

\alias{PlotOnStaticMap}

\title{overlays plot on background image of map tile}

\description{This function is the workhorse of the package RgoogleMaps. It overlays plot on background image of map tile}

\usage{PlotOnStaticMap(MyMap, lat, lon, destfile, zoom = NULL, 

    size, GRAYSCALE = FALSE, add = FALSE, FUN = points, 

    mar = c(0, 0, 0, 0), NEWMAP = TRUE, TrueProj = TRUE, 

    axes = FALSE, atX = NULL, atY = NULL, verbose = 0, 

    ...)}

\arguments{

  \item{MyMap}{optional map object}

  \item{lat}{latitude values to be overlaid}

  \item{lon}{longitude values to be overlaid}

  \item{destfile}{File to load the map image from or save to, depending on whether \code{MyMap} was passed.}

  \item{zoom}{Google maps zoom level. optional if \code{MyMap} is passed, required if not.}

  \item{size}{desired size of the map tile image. defaults to maximum size returned by the Gogle server, which is 640x640 pixels}

  \item{GRAYSCALE}{Boolean toggle; if TRUE the colored map tile is rendered into a black & white image, see \link{RGB2GRAY}}

  \item{add}{start a new plot or add to an existing}

  \item{FUN}{plotting function to use for overlay; typical choices would be \link{points} and \link{lines}}

  \item{mar}{outer margin in plot; if you want to see axes, change the default}

  \item{NEWMAP}{load map from file or get it "new" from the static map server}

  \item{TrueProj}{set to FALSE if you are willing to accept some degree of inaccuracy in the mapping. In that case, the coordinates of the image are in lat/lon and the user can simply overly points/lines/axis without worrying about projections}

  \item{axes}{overlay axes ?}

  \item{atX}{numeric; position of ticks on x-axis; if missing, \link{axTicks} is called for nice values; see \link{axis}}

  \item{atY}{numeric; position of ticks on y-axis; if missing, \link{axTicks} is called for nice values; see \link{axis}}

  \item{verbose}{level of verbosity}

  \item{\dots}{further arguments to be passed to \code{FUN}}

}



\value{the map object is returned via \code{invisible(MyMap)}}



\author{Markus Loecher}









\examples{

#The first step naturally will be to download a static map from the Google server. A simple example:



  if (0){

    lat = c(40.702147,40.711614,40.718217);

    lon = c(-74.015794,-74.012318,-73.998284);

    center = c(mean(lat), mean(lon));

    zoom <- min(MaxZoom(range(lat), range(lon)));

    #this overhead is taken care of implicitly by GetMap.bbox();              

    MyMap <- GetMap(center=center, zoom=zoom,markers = paste0("&markers=color:blue|label:S|",

             "40.702147,-74.015794&markers=color:green|label:G|40.711614,-74.012318&markers=",

             "color:red|color:red|label:C|40.718217,-73.998284"), destfile = "MyTile1.png");

                   

     tmp <- PlotOnStaticMap(MyMap, lat = lat, 

                            lon = lon, 

                            destfile = "MyTile1.png", cex=1.5,pch=20,

                            col=c('red', 'blue', 'green'), add=FALSE);

     #and add lines:

     PlotOnStaticMap(MyMap, lat = c(40.702147,40.711614,40.718217), 

                     lon = c(-74.015794,-74.012318,-73.998284), 

                     lwd=1.5,col=c('red', 'blue', 'green'), FUN = lines, add=TRUE)

     	

  }

}

\name{MaxZoom}

\alias{MaxZoom}

\title{computes the maximum zoom level which will contain the given lat/lon range}

\description{computes the maximum zoom level which will contain the given lat/lon range}

\usage{MaxZoom(latrange, lonrange, size = c(640, 640))}

\arguments{

  \item{latrange}{range of latitude values}

  \item{lonrange}{range of longitude values}

  \item{size}{desired size of the map tile image. defaults to maximum size returned by the Gogle server, which is 640x640 pixels}

}



\value{zoom level}



\author{Markus Loecher}

\name{GetMap.bbox}

\alias{GetMap.bbox}

\title{GetMap bbox}

\description{Wrapper function for \link{GetMap}. Query the Google server for a static map tile, defined primarily by its lat/lon range and/or center and/or zoom. 

Multiple additional arguments allow the user to customize the map tile.}

\usage{GetMap.bbox(lonR, latR, center, size = c(640, 640), 

    destfile = "MyTile.png", MINIMUMSIZE = FALSE, RETURNIMAGE = TRUE, 

    GRAYSCALE = FALSE, NEWMAP = TRUE, zoom, verbose = 0, 

    SCALE = 1, type = c("google", "google-m", "google-s", 

        "osm", "osm-hot", "stamen-toner", "stamen-terrain", 

        "stamen-watercolor")[1], urlBase = "http://mt1.google.com/vt/lyrs=m", 

    tileDir = "/tmp/", ...)}

\arguments{

  \item{lonR}{longitude range}

  \item{latR}{latitude range}

  \item{center}{optional center}

  \item{size}{desired size of the map tile image. defaults to maximum size returned by the Gogle server, which is 640x640 pixels}

  \item{destfile}{File to load the map image from or save to, depending on \code{NEWMAP}.}

  \item{MINIMUMSIZE}{reduce the size of the map to its minimum size that still fits the lat/lon ranges ?}

  \item{RETURNIMAGE}{return image yes/no default: TRUE}

  \item{GRAYSCALE}{Boolean toggle; if TRUE the colored map tile is rendered into a black & white image, see \link{RGB2GRAY}}

  \item{NEWMAP}{if TRUE, query the Google server and save to \code{destfile}, if FALSE load from destfile.}

  \item{zoom}{Google maps zoom level. optional}

  \item{verbose}{level of verbosity}

  \item{SCALE}{use the API's scale parameter to return higher-resolution map images. The scale value is multiplied with the size to determine the actual output size of the image in pixels, without changing the coverage area of the map}

  \item{type}{choice of tile server}

  \item{urlBase}{tileserver URL, alternatives would be "http://a.tile.openstreetmap.org/", "http://tile.stamen.com/toner/","http://tile.stamen.com/watercolor/"}

  \item{tileDir}{map tiles can be stored in a local directory, e.g. "~/mapTiles/Google/"}

  \item{\dots}{extra arguments to \link{GetMap}}

}



\value{map tile}



\author{Markus Loecher}









\examples{

 if (0){

 	mymarkers <- cbind.data.frame(lat = c(38.898648,38.889112, 38.880940), 

          lon = c(-77.037692, -77.050273, -77.03660), size =  c('tiny','tiny','tiny'), 

          col = c('blue', 'green', 'red'), char = c('','',''));



	##get the bounding box:

  	bb <- qbbox(lat = mymarkers[,"lat"], lon = mymarkers[,"lon"]);

  

	##download the map:

  	MyMap <- GetMap.bbox(bb$lonR, bb$latR, destfile = "DC.png", GRAYSCALE =TRUE,

                markers = mymarkers);

 	##The function qbbox() basically computes a bounding box for the given lat,lon 

   #points with a few additional options such as quantile boxes, additional buffers, etc.  

  	bb <- qbbox(c(40.702147,40.711614,40.718217),c(-74.015794,-74.012318,-73.998284), 

            TYPE = "all", margin = list(m=rep(5,4), TYPE = c("perc", "abs")[1]));

 	##download the map:           

	MyMap <- GetMap.bbox(bb$lonR, bb$latR,destfile = "MyTile3.png", maptype = "satellite") 



}

}

\name{degreeAxis}

\alias{degreeAxis}

\title{axis with degrees}

\description{add an axis with degree labels}

\usage{degreeAxis(side, at = NULL, labels, MyMap, ...)}

\arguments{

  \item{side}{integer; see \link{axis}}

  \item{at}{numeric; if missing, \link{axTicks} is called for nice values; see \link{axis}}

  \item{labels}{character; if omitted labels are constructed with degree symbols, ending in N/S/E/W; in case of negative degrees, sign is reversed and S or W is added; see \link{axis}}

  \item{MyMap}{optional map object to be passed}

  \item{\dots}{optional arguments to \link{axis}}

}



\value{axis is plotted on current graph}



\author{Markus Loecher}

\note{decimal degrees are used if variation is small, instead of minutes and seconds}







\examples{

xy = cbind(x = 2 * runif(100) - 1, y = 2 * runif(100) - 1)

plot(xy,xlim=c(-1,1),ylim=c(-1,1))

degreeAxis(1)

degreeAxis(2, at = c(-1,-0.5,0,0.5,1))

}

\name{DF2SpatialPointsDataFrame}

\alias{DF2SpatialPointsDataFrame}

\title{change data.frame to SpatialPointsDataFrame}

\description{This function modifies an object of class data.frame to one of class SpatialPointsDataFrame}

\usage{DF2SpatialPointsDataFrame(x, coords = c("x", "y"), 

    crs = sp::CRS("+init=epsg:28992"))}

\arguments{

  \item{x}{data frame to be converted}

  \item{coords}{which columns are coordinates}

  \item{crs}{projection scheme}

}



\value{the new object of class SpatialPointsDataFrame}



\author{Markus Loecher}









\examples{

if (requireNamespace("sp", quietly = TRUE)) {

  data("meuse", package = "sp", envir = environment())

  meuseSP = DF2SpatialPointsDataFrame(meuse)

  

  sp::plot(meuseSP, asp = 1, cex = 4 * meuse$zinc/max(meuse$zinc),

       pch = 1, col = as.numeric(meuse$ffreq)+1 )

  data("meuse.riv", package = "sp", envir = environment())

  lines(meuse.riv)  

} else {

  print("package sp must be installed for this example")

}





}

\name{PlotPolysOnStaticMap}

\alias{PlotPolysOnStaticMap}

\title{plots polygons on map}

\description{This function plots/overlays polygons on a map. Typically, the polygons originate from a shapefile.}

\usage{PlotPolysOnStaticMap(MyMap, polys, col, border = NULL, 

    lwd = 0.25, verbose = 0, add = TRUE, textInPolys = NULL, 

    ...)}

\arguments{

  \item{MyMap}{map image returned from e.g. \code{GetMap()}}

  \item{polys}{or of class \link[sp]{SpatialPolygons} from the package sp

polygons to overlay; these can be either of class \link[PBSmapping]{PolySet} from the package PBSmapping}

  \item{col}{(optional) vector of colors, one for each polygon}

  \item{border}{the color to draw the border. The default, NULL, means to use \link{par}("fg"). Use border = NA to omit borders, see \link{polygon}}

  \item{lwd}{line width, see \link{par}}

  \item{verbose}{level of verbosity}

  \item{add}{start a new plot or add to an existing}

  \item{textInPolys}{text to be displayed inside polygons.}

  \item{\dots}{further arguments passed to \code{PlotOnStaticMap}}

}







\author{Markus Loecher}







\seealso{\link{PlotOnStaticMap} \link{mypolygon}}

\examples{

if (0){

  #require(PBSmapping);
  shpFile <- paste(system.file(package = "RgoogleMaps"), "/shapes/bg11_d00.shp", sep = "")
  #shpFile <- system.file('bg11_d00.shp', package = "RgoogleMaps");
  
  shp=PBSmapping::importShapefile(shpFile,projection="LL");
  bb <- qbbox(lat = shp[,"Y"], lon = shp[,"X"]);
  MyMap <- GetMap.bbox(bb$lonR, bb$latR, destfile = "DC.png");
  PlotPolysOnStaticMap(MyMap, shp, lwd=.5, col = rgb(0.25,0.25,0.25,0.025), add = F);
  
  #Try an open street map:

  mapOSM <- GetMap.bbox(bb$lonR, bb$latR, destfile = "DC.png", type="osm");
  PlotPolysOnStaticMap(mapOSM, shp, lwd=.5, col = rgb(0.75,0.25,0.25,0.15), add = F);

  #North Carolina SIDS data set:
  shpFile <- system.file("shapes/sids.shp", package="rgooglemaps");
  shp=PBSmapping::importShapefile(shpFile,projection="LL");
  bb <- qbbox(lat = shp[,"Y"], lon = shp[,"X"]);
  MyMap <- GetMap.bbox(bb$lonR, bb$latR, destfile = "SIDS.png");
  #compute regularized SID rate
  sid <- 100*attr(shp, "PolyData")$SID74/(attr(shp, "PolyData")$BIR74+500)
  b <- as.integer(cut(sid, quantile(sid, seq(0,1,length=8)) ));
  b[is.na(b)] <- 1;
  opal <- col2rgb(grey.colors(7), alpha=TRUE)/255; opal["alpha",] <- 0.2;
  shp[,"col"] <- rgb(0.1,0.1,0.1,0.2);
  for (i in 1:length(b)) 
    shp[shp[,"PID"] == i,"col"] <- rgb(opal[1,b[i]],opal[2,b[i]],opal[3,b[i]],opal[4,b[i]]);
  PlotPolysOnStaticMap(MyMap, shp, lwd=.5, col = shp[,"col"], add = F);
  
  
  #or choose an aspect ratio that corresponds better to North Carolina's elongated shape:
  MyMap <- GetMap.bbox(bb$lonR, bb$latR, destfile = "SIDS.png", size = c(640, 320), zoom = 7);
  PlotPolysOnStaticMap(MyMap, shp, lwd=.5, col = shp[,"col"], add = F);
 }


}

\name{MapBackground}

\alias{MapBackground}

\title{get static Map from the Google server}

\description{get static Map from the Google server}

\usage{MapBackground(lat, lon, destfile, NEWMAP = TRUE, myTile, 

    zoom = NULL, size = c(640, 640), GRAYSCALE = FALSE, 

    mar = c(0, 0, 0, 0), PLOT = FALSE, verbose = 1, 

    ...)}

\arguments{

  \item{lat}{center latitude}

  \item{lon}{center longitude}

  \item{destfile}{File to load the map image from or save to, depending on \code{NEWMAP}.}

  \item{NEWMAP}{if TRUE, query the Google server and save to \code{destfile}, if FALSE load from destfile.}

  \item{myTile}{map tile from previous downloads}

  \item{zoom}{Google maps zoom level.}

  \item{size}{desired size of the map tile image. defaults to maximum size returned by the Gogle server, which is 640x640 pixels}

  \item{GRAYSCALE}{Boolean toggle; if TRUE the colored map tile is rendered into a black & white image, see \link{RGB2GRAY}}

  \item{mar}{outer margin in plot; if you want to see axes, change the default}

  \item{PLOT}{if TRUE, leave the plotting to \link{PlotOnStaticMap}, highly recommended}

  \item{verbose}{level of verbosity}

  \item{\dots}{further arguments to be passed to \link{GetMap.bbox}}

}



\value{list containing the map tile}



\author{Markus Loecher}

\name{TextOnStaticMap}

\alias{TextOnStaticMap}

\title{plots text on map}

\description{TextOnStaticMap draws the strings given in the vector labels at the coordinates given by x and y on a map. y may be missing since xy.coords(x,y) is used for construction of the coordinates.}

\usage{TextOnStaticMap(MyMap, lat, lon, labels = seq_along(lat), 

    TrueProj = TRUE, FUN = text, add = FALSE, verbose = 0, 

    ...)}

\arguments{

  \item{MyMap}{map image returned from e.g. \code{GetMap()}}

  \item{lat}{latitude where to put text.}

  \item{lon}{longitude where to put text.}

  \item{labels}{a character vector or \link{expression} specifying the text to be written. An attempt is made to coerce other language objects (names and calls) to expressions, and vectors and other classed objects to character vectors by \link{as.character}. If labels is longer than x and y, the coordinates are recycled to the length of labels.}

  \item{TrueProj}{set to FALSE if you are willing to accept some degree of inaccuracy in the mapping. In that case, the coordinates of the image are in lat/lon and the user can simply overly points/lines/axis without worrying about projections}

  \item{FUN}{overlay function, typical choice would be \link{text}}

  \item{add}{start a new plot or add to an existing}

  \item{verbose}{level of verbosity}

  \item{\dots}{further arguments to be passed to \code{FUN}}

}



\value{return value of \code{FUN}}



\author{Markus Loecher}









\examples{

  if (0) {

   lat = c(40.702147,40.718217,40.711614);

    lon = c(-74.012318,-74.015794,-73.998284);

    center = c(mean(lat), mean(lon));

    zoom <- min(MaxZoom(range(lat), range(lon)));

    

   

   MyMap <- GetMap(center=center, zoom=zoom,markers = paste0("&markers=color:blue|label:S|",

            "40.702147,-74.015794&markers=color:green|label:G|40.711614,-74.012318&markers=",

             "color:red|color:red|label:C|40.718217,-73.998284"), destfile = "MyTile1.png");

    TextOnStaticMap(MyMap, lat=40.711614,lon=-74.012318, "Some Text", cex=2, col = 'red')

    

}

}

\name{qbbox}

\alias{qbbox}

\title{computes bounding box}

\description{The function qbbox computes a bounding box for the given lat,lon 

points with a few additional options such as quantile boxes, additional margins, etc.}

\usage{qbbox(lat, lon, TYPE = c("all", "quantile")[1], margin = list(m = c(1, 

    1, 1, 1), TYPE = c("perc", "abs")[1]), q.lat = c(0.1, 

    0.9), q.lon = c(0.1, 0.9), verbose = 0)}

\arguments{

  \item{lat}{latitude values}

  \item{lon}{longitude values}

  \item{TYPE}{absolute or percentage trimming?}

  \item{margin}{relative or absolute margin around the data. Set to NULL if no margin desired.}

  \item{q.lat}{latitude quantile trimming, the tails will be trimmed from the bounding box}

  \item{q.lon}{longitude quantile trimming,}

  \item{verbose}{level of verbosity}

}



\value{\item{latR }{latitude range}

\item{lonR }{longitude range}}



\author{Markus Loecher}









\examples{

lat = 37.85 + rnorm(100, sd=0.001);

lon = -120.47 + rnorm(100, sd=0.001);

#add a few outliers:

lat[1:5] <- lat[1:5] + rnorm(5, sd =.01);

lon[1:5] <- lon[1:5] + rnorm(5, sd =.01);



#range, discarding the upper and lower 10\% of the data

qbbox(lat, lon, TYPE = "quantile");

#full range:

qbbox(lat, lon, TYPE = "all");

#add a 10\% extra margin on all four sides:

qbbox(lat, lon, margin = list(m = c(10, 10, 10, 10), TYPE = c("perc", "abs")[1]));

 

}

\name{bubbleMap}

\alias{bubbleMap}

\title{Create a bubble plot of spatial data on Google Maps}

\description{This function creates a bubble plot of spatial

data, with options for bicolour residual plots.}

\usage{bubbleMap(SP, coords = c("x", "y"), crs = sp::CRS("+proj=longlat +datum=WGS84"), 

    map, filename = "", zcol = 1, max.radius = 100, 

    key.entries, do.sqrt = TRUE, colPalette = NULL, 

    strokeColor = "#FFAA00", alpha = 0.7, strokeWeight = 1, 

    LEGEND = TRUE, legendLoc = "topleft", verbose = 0)}

\arguments{

  \item{SP}{object of class data.frame or \link[sp]{SpatialPointsDataFrame-class} with associated coordinate reference systems}

  \item{coords}{names of coordinate columns}

  \item{crs}{coordinate reference systems}

  \item{map}{map object; if missing map is downloaded from server}

  \item{filename}{filename to save the map under, IF map object not given}

  \item{zcol}{variable column name, or column number after removing spatial coordinates from x@data: 1 refers to the first non-coordinate column}

  \item{max.radius}{value for largest circle (the plotting symbols) in metre, circumcircle of triange or quadrangle (square)}

  \item{key.entries}{value for largest circle (the plotting symbols) in metre, circumcircle of triange or quadrangle (square)}

  \item{do.sqrt}{logical; if TRUE the plotting symbol area (sqrt(diameter)) is proportional to the value of the z-variable; if FALSE, the symbol size (diameter) is proportional to the z-variable}

  \item{colPalette}{colours to be used to fill plotting symbols; numeric vector of same size like key.entries



colours to be used to fill features depending on attribute}

  \item{strokeColor}{the color to draw the border of circle (the plotting symbols)}

  \item{alpha}{the fill opacity between 0.0 and 1.0}

  \item{strokeWeight}{the stroke width in pixels}

  \item{LEGEND}{logical; if TRUE add bubbleLegend}

  \item{legendLoc}{the x and y co-ordinates to be used to position the legend. They can be specified by keyword or in any way which is accepted by \code{legend}}

  \item{verbose}{level of verbosity}

}



\value{##################################################################

map structure or URL used to download the tile.}



\author{Markus Loecher}









\examples{



if (0) {

  data(lat.lon.meuse, package="loa", envir = environment())

  

  map <- GetMap(center=c(lat=50.97494,lon=5.743606), zoom=13,

         size=c(480,480),destfile = file.path(tempdir(),"meuse.png"),

          maptype="mobile", SCALE = 1);



  par(cex=1.5)

  bubbleMap(lat.lon.meuse, coords = c("longitude","latitude"), map=map,

        zcol='zinc', key.entries = 100+ 100 * 2^(0:4));

}



}

\name{incidents}
\alias{incidents}

\docType{data}
\title{San Francisco crime data}
\usage{data(incidents)}
\description{
The \code{incidents} data frame has 5000 rows and 16 columns.
These are 5000 random rows from the 2012 crime data recorded in San Francisco.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{IncidntNum}{incident number assigned by the police}
    \item{Category}{Category of crime}
    \item{Descript}{longer description}
    \item{DayOfWeek}{day of week}
    \item{Date}{date}
    \item{Time}{time of day formatted as hh:mm }
    \item{PdDistrict}{police district}
    \item{Resolution}{was the crime resolved?}
    \item{Location}{location as address}
    \item{lon}{longitude}
    \item{lat}{latitude}
    \item{violent}{violent flag}
    \item{HrOfDay}{hour of day as 2-digit integer}
    \item{TimeOfDay}{hour of day as decimal number}
    \item{HourOfWeek}{hour of week as decimal number between 0-168}
    \item{censusBlock}{ID of census block}
  }
}
\details{
crime data recorded in San Francisco
}
\source{
URL https://data.sfgov.org/
}


\examples{
data(incidents)
table(incidents$Category)

}
\keyword{datasets}

\name{Tile2R}

\alias{Tile2R}

\title{simple utility to offset and scale XY coordinates with respect to the center}

\description{simple utility to offset and scale XY coordinates with respect to the center}

\usage{Tile2R(points, center)}

\arguments{

  \item{points}{XY coordinates returned by e.g. \link{LatLon2XY}}

  \item{center}{XY coordinates of center returned by e.g. \link{LatLon2XY}}

}

\details{mainly used for shrinking the size of a tile to the minimum size.}

\value{list with X and Y pixel values}



\author{Markus Loecher}









\examples{

latR <- c(34.5,34.9);

 lonR <- c(-100.3, -100);

 lat.center <- 34.7;

 lon.center <- -100.2;

 zoom = 10;

 ll <- LatLon2XY(latR[1], lonR[1], zoom);#lower left corner

 ur <- LatLon2XY(latR[2], lonR[2], zoom );#upper right corner

 cr <- LatLon2XY(lat.center, lon.center, zoom );#center

 ll.Rcoords <- Tile2R(ll, cr);

 ur.Rcoords <- Tile2R(ur, cr);



}

\name{getGeoCode}

\alias{getGeoCode}

\title{geocoding utility}

\description{Geocode your data using, R, JSON and OSM or Google Maps' Geocoding APIs }

\usage{getGeoCode(gcStr, API = c("osm", "google")[1], JSON = FALSE, 

    verbose = 0)}

\arguments{

  \item{gcStr}{adddress to geocode}

  \item{API}{which API to use. see https://nominatim.org/release-docs/develop/api/Search/ and http://allthingsr.blogspot.de/2012/01/geocode-your-data-using-r-json-and.html}

  \item{JSON}{use the JSON protocol. If FALSE, we do not have to load additional libraries}

  \item{verbose}{level of verbosity}

}



\value{returns lat/lon for address}



\author{Markus Loecher}









\examples{

if (0){

  getGeoCode("1600 Amphitheatre Parkway, Mountain View, CA")

  getGeoCode("Brooklyn")

  #You can run this on the entire column of a data frame or a data table:

  DF = cbind.data.frame(address=c("Berlin,Germany", "Princeton,NJ", 

            "cadillac+mountain+acadia+national+park"), lat = NA, lon = NA)

  DF <- with(DF, data.frame(address, t(sapply(DF$address, getGeoCode))))

}

}

\name{plotOSM}

\alias{plotOSM}

\title{plots OSM map tiles}

\description{places tiles on plot}

\usage{plotOSM(mt, upperLeft, lowerRight, lat, lon, add = FALSE, 

    removeMargin = TRUE, verbose = 0, ...)}

\arguments{

  \item{mt}{list returned by \code{GetMapTiles}}

  \item{upperLeft}{upperLeft corner in lat/lon of the plot region}

  \item{lowerRight}{lowerRight corner in lat/lon of the plot region}

  \item{lat}{latitude values to be overlaid, if any}

  \item{lon}{longitude values to be overlaid, if any}

  \item{add}{Boolean, whether to add to existing plot}

  \item{removeMargin}{Boolean, whether to strip margins of plot}

  \item{verbose}{level of verbosity}

  \item{\dots}{further arguments to be passed to \code{rasterImage}}

}



\value{returns map object invisibly }



\author{Markus Loecher}

\name{XY2LatLon}

\alias{XY2LatLon}

\title{computes the centered coordinate transformation from lat/lon to map tile coordinates }

\description{The function XY2LatLon(MyMap, X,Y,zoom) computes the coordinate transformation from map tile coordinates to lat/lon given a map object.}

\usage{XY2LatLon(MyMap, X, Y, zoom)}

\arguments{

  \item{MyMap}{map object}

  \item{X}{latitude values to transform}

  \item{Y}{longitude values to transform}

  \item{zoom}{optional zoom level. If missing, taken from \code{MyMap}}

}



\value{properly scaled and centered (with respect to the center of \code{MyMap} ) coordinates  

\item{lon }{longitude}

\item{lat }{latitude}}



\author{Markus Loecher}







\seealso{\link{LatLon2XY} \link{Tile2R}}

\examples{

#quick test:



  zoom=12;MyMap <- list(40,-120,zoom, url="google", BBOX = list(ll=c(35,-125), ur=c(45,-115)));

  LatLon <- c(lat = 40.0123, lon = -120.0123);

  Rcoords <- LatLon2XY.centered(MyMap,LatLon["lat"],LatLon["lon"])

  newLatLon <- XY2LatLon(MyMap, Rcoords$newX, Rcoords$newY)

  max(abs(newLatLon - LatLon));



#more systematic:

 for (zoom in 2:10){

   cat("zoom: ", zoom, "\n");

   MyMap <- list(40,-120,zoom, url="google", BBOX = list(ll=c(35,-125), ur=c(45,-115)));

   LatLon <- c(lat = runif(1,-80,80), lon = runif(1,-170,170));

   Rcoords <- LatLon2XY.centered(MyMap,LatLon["lat"],LatLon["lon"])

   newLatLon <- XY2LatLon(MyMap, Rcoords$newX, Rcoords$newY)

   if(max(abs(newLatLon - LatLon)) > 0.0001) print(rbind(LatLon, newLatLon));

 }



}

\name{IdentifyPoints}

\alias{IdentifyPoints}

\title{identify points by clicking on map}

\description{The user can try to identify lat/lon pairs on the map by clicking on them}

\usage{IdentifyPoints(MyMap, n = 1, verbose = 0)}

\arguments{

  \item{MyMap}{map object}

  \item{n}{the maximum number of points to locate.}

  \item{verbose}{level of verbosity}

}



\value{the lat/lon coordinates of the chosen points are returned }



\author{Markus Loecher}









\examples{

#The first step naturally will be to download a static map from the Google server. A simple example:



 #identifiy points:

 #IdentifyPoints(MyMap,5)



}

\name{osmtile_bbox}

\alias{osmtile_bbox}

\title{compute the bounding box of an OpenStreetmap tile}

\description{inspired by \code{osmtile} from the package \code{OpenStreetmap}

returns the Mercator projection bounding box}

\usage{osmtile_bbox(x = 61, y = 41, zoom = 7, minim = -20037508)}

\arguments{

  \item{x}{x tile coordinate}

  \item{y}{x tile coordinate}

  \item{zoom}{zoom level}

  \item{minim}{parameter for OSM projection}

}



\value{bounding box, Mercator projection }



\author{Markus Loecher}

\name{GetMapTiles}

\alias{GetMapTiles}

\title{download map tiles from specified map tile servers such as openstreetmap or Google}

\description{Query the server for map tiles, defined uniquely by their 

X and Y ID and zoom. For offline usage, these map tiles are stored in a local directory

Example OSM:http://a.tile.openstreetmap.org/10/549/335.png

Also see https://wiki.openstreetmap.org/wiki/Tile_servers

Example Google mobile: http://mt1.google.com/vt/lyrs=m&x=1325&y=3143&z=13

Example Google satellite: http://mt1.google.com/vt/lyrs=s&x=1325&y=3143&z=13}

\usage{GetMapTiles(center = c(lat = 52.431635, lon = 13.194773), 

    lonR, latR, nTiles = c(3, 3), zoom = 13, type = c("google", 

        "google-m", "google-s", "osm", "osm-hot", "stamen-toner", 

        "stamen-terrain", "stamen-watercolor")[1], 

    urlBase = "http://mt1.google.com/vt/lyrs=m", tileDir = "/tmp/", 

    CheckExistingFiles = TRUE, TotalSleep = NULL, tileExt = ".png", 

    returnTiles = TRUE, verbose = 0)}

\arguments{

  \item{center}{optional center (lat first,lon second  )}

  \item{lonR}{longitude range}

  \item{latR}{latitude range}

  \item{nTiles}{number of tiles in x and y direction}

  \item{zoom}{Google maps zoom level.}

  \item{type}{choice of tile server}

  \item{urlBase}{tileserver URL, alternatives would be "http://a.tile.openstreetmap.org/", "http://tile.stamen.com/toner/","http://tile.stamen.com/watercolor/"}

  \item{tileDir}{map tiles can be stored in a local directory, e.g. "~/mapTiles/Google/"}

  \item{CheckExistingFiles}{logical, if TRUE check if files already exist and only download if not!}

  \item{TotalSleep}{overall time (in seconds) that one is willing to add in between downloads. This is intended to lower the risk of a server denial. If NULL no call to \link{Sys.sleep} is executed}

  \item{tileExt}{image type of tile}

  \item{returnTiles}{return tiles in a list?}

  \item{verbose}{level of verbosity}

}



\value{list with important information}



\author{Markus Loecher}

\note{Note that size is in order (lon, lat)}





\seealso{\link{GetMap.bbox}}

\examples{

if (0){

  

  #OSM, Ireland

  xlim = c(-7, -3.5) 

  ylim = c(51.35, 55.35)

  Dublin = c(lon=-6.266155,lat=53.350140)

  DublinMerc = geosphere_mercator(Dublin)

  

  ir.osm <- GetMapTiles(lonR=xlim, latR=ylim, zoom=7, verbose=1,

                        type = "osm", tileDir= TRUE)

  map = plotOSM(ir.osm)

  par("usr")#A vector of the form c(x1, x2, y1, y2)

  points(map$bbox$upperLeft,col=2,pch=20)

  points(map$bbox$lowerRight,col=2,pch=20)

  

  points(DublinMerc, col =2, pch=1,cex=1.5)

  

  ir.stamenToner <- GetMapTiles(lonR=xlim, latR=ylim, zoom=7,verbose=0,

                                type = "stamen", tileDir= TRUE)

  plotOSM(ir.stamenToner)

  

  ir.stamenWater <- GetMapTiles(lonR=xlim, latR=ylim, zoom=7, verbose=1,

                                type = "stamen-watercolor", tileDir= TRUE)

  plotOSM(ir.stamenWater)

 

  

  #############################################

  zoom=5

  nTiles = prod(NumTiles(lonR=c(-135,-66), latR=c(25,54) , zoom=zoom))

  us_google_5 = GetMapTiles(lonR=c(-135,-66), latR=c(25,54) , zoom=zoom, TotalSleep = 2*nTiles,

              type = "google", tileDir= TRUE, verbose = TRUE)

  

  PlotOnMapTiles(us_google_5)

  wtc_ll = getGeoCode("World Trade Center, NY")

  wtc_google_15=GetMapTiles(wtc_ll, zoom=15,nTiles = c(3,3), type = "google", 

                            tileDir= TRUE, verbose = 1)

  PlotOnMapTiles(wtc_google_15)

  wtc_google_16 =GetMapTiles(wtc_ll, zoom=16,nTiles = c(4,4), type = "google", 

                             tileDir= TRUE, verbose=1)

  PlotOnMapTiles(wtc_google_16)





  wtc_stamen=GetMapTiles(wtc_ll, zoom=15,nTiles = c(3,3), verbose=1,

                  type = "stamen-toner", tileDir= TRUE)

  PlotOnMapTiles(wtc_stamen)







###combine with leaflet:

#From:http://stackoverflow.com/questions/5050851/

#     best-lightweight-web-server-only-static-content-for-windows

#To use Python as a simple web server just change your working 

#directory to the folder with your static content and type 

#python -m SimpleHTTPServer 8000, everything in the directory

#will be available at http:/localhost:8000/

  

library(leaflet)

m = leaflet::leaflet() \%>\% 

  addTiles( urlTemplate = "http:/localhost:8000/mapTiles/OSM/{z}_{x}_{y}.png")

m = leaflet::leaflet() \%>\% 

  addTiles( urlTemplate = "http:/localhost:8000/mapTiles/Google/{z}_{x}_{y}.png")

m = m \%>\% leaflet::setView(-74.01312, 40.71180, zoom = 16)

m = m \%>\% leaflet::addMarkers(-74.01312, 40.71180)



#Quadriga:

m = m \%>\% leaflet::setView(13.39780, 52.51534, zoom = 16)

m = m \%>\% leaflet::addMarkers(13.39780, 52.51534)

}



}
